// ****************** Copyright Header ************************************
// WebWisdom JavaScript Shared Browser Version 3.0
// Copyright 1999 Syracuse University and WebWisdom.com
// Author: Geoffrey C. Fox
// Contact: support@webwisdom.com
//
// Reproduction of this software without this Copyright Header
// is prohibited and it constitutes a violation of
// the SU and WebWisdom.com Copyright (a federal felony).
//
// This software cannot be incorporated into any commercial
// product, or a product supporting commercial activity,
// without first obtaining a license from WebWisdom.com
// E-mail license@webwisdom.com to apply.
// *********** End of Copyright Header ************************************

var WW_tangoboss = null;
if(window.opener != null)	{
	WW_tangoboss = window.opener;
}
else	{
	alert('serious error -- null openening window');
}

// WW_tangoboss holds routines with send and receive routines
var WW_tangowisdomstatus =0;
if( WW_tangoboss != null)	{
	if( WW_tangoboss.thiscamefromtango() != null)	{
		WW_tangowisdomstatus=1;
	}
}
WW_tangoboss.WW_spawnedparentdone = false;

var WW_gamemaster = null;	// Location of Game Control in Main window or Frame thereof
var defaulturl = WW_tangoboss.WW_firsturl;
var WW_spawnedmainframeurl = defaulturl;
var WW_possiblegeneratedurl = '';
var WW_generationcycle = -1;
var WW_inputexpectedurl = ''; // Input value of URL expected from Form/Link event
var WW_expectedurlmemory = 0;
var WW_firstdynamictangoflag = 0;
var WW_clockunits = WW_tangoboss.WW_clockunits; // 1 (2 second) 2(1 second) 4 (.5 second cycle)
var WW_bartestlimit = 15*WW_clockunits; // Limit for testing on Control Bar
var WW_allowclicks = false; // if true, allow clicks in nonmaster (needed to allow click() method)
var WW_pointerframeset = new WW_frameset();
var WW_eventlabel = new Array('HrefClick','JavaScript HrefClick','Voided JavaScript HrefClick','onclick','onclick/JavaScript HrefClick','onclick/Voided JavaScript HrefClick','Mouse Over link','Mouse Out link','Mouse Over Layer','Mouse Out Layer','Bare Click');
var WW_indicatebaderror = -1;
var WW_indicatenotsobaderror = -1;
var WW_badloaderror = 0;
var WW_notsobadloaderror = 0;
var WW_savethumbnail = '';

// Set controlbar handling
var WW_masterofthering = WW_tangoboss;
var WW_bartotalwidth =0;
var WW_barrandomname = WW_tangoboss.WW_barrandomname;
var WW_origwidth = window.innerWidth;
var WW_origheight = window.innerHeight;

window.onresize = resizemethod;
function resizemethod()	{

	if(WW_tangoboss.WW_tangostatus != 0)
		return;
	if(WW_isitawindow(WW_tangoboss))	{
		WW_tangoboss.WW_spawnedwindowwidth = window.innerWidth;
		WW_tangoboss.WW_spawnedwindowheight = window.innerHeight;
		var localform = WW_tangoboss.WW_getformhandle(1);
		if(localform != null )	{
			localform.windowwidth.value = window.innerWidth;
			localform.windowheight.value = window.innerHeight;
		}
	}
	if( (window.innerWidth==WW_origwidth) && (window.innerHeight==WW_origheight))
		return;
	WW_tangoboss.WW_newtangolabel(WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel);
	wwevent = new WW_generatedevent(WW_tangoboss.WW_username,WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber,'windowsize');
	wwevent.infotype = 1;
	wwevent.innerwidth = window.innerWidth;
	wwevent.innerheight = window.innerHeight;
	WW_tangoboss.WW_accumandsendevent(wwevent,WW_Eventnonmastername,'Window Resize Event',1);
	WW_tangoboss.WW_targeturl = WW_spawnedmainframeurl;
	WW_tangoboss.WW_countspawnedtries = 0;
	WW_spawnedmainframeurl = defaulturl;
	WW_tangoboss.WW_registereventindicator(8,WW_tangoboss.WW_numallevents-1,-1,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
	if(WW_isitawindow(WWsignedchild))	{
		if(WW_isitawindow(WWsignedchild.appletframe))
			WWsignedchild.appletframe.close(); }
	window.location.reload();
	return;
}

// Structure to hold Pointer Frameset Information
function WW_frameset()	{ // Container for Registered Pages

	this.mainpage = null;
	this.trytocountdocarrays = 0;
	this.sizeofdocarrays = 0;
	this.childnum = 0;
	this.framepages = new Array();
	this.frametrytocountdocarrays = new Array();
	this.framesizeofdocarrays = new Array();

}	// End Constructor WW_frameset()

//	Structure to Hold Link Data
function recordlink(evtype)	{

	this.linktype = evtype; // Normal link click 0-5; link mouseover 6; link mouseout 7; not a link 8-10
	this.linknumber = 0;
	if(evtype >= 8)
		this.linknumber = -1;
	this.linktext = '';
	this.linkhref = '';
	this.linkcount = 0;
	this.divxpos = 0;
	this.divypos = 0;
	this.framenumber = -1;
	this.layernumber = new Array();
	this.layername = new Array();
	this.framecount = 0;
	this.layercount = new Array();
	this.layerlevel = -1;
}
function sendlink(recordit)	{	// Pack link in a message

	var num = recordit.layerlevel;
	if( num < 0 )
		return;
	WW_tangoboss.WW_newtangolabel(WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel);
	wwevent = new WW_generatedevent(WW_tangoboss.WW_username,WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber,'link');
	wwevent.currenturl = WW_spawnedmainframeurl;
	wwevent.linktype = recordit.linktype;
	wwevent.linknumber = recordit.linknumber;
	wwevent.linktext = recordit.linktext;
	wwevent.linkhref = recordit.linkhref;
	wwevent.linkcount = recordit.linkcount;
	wwevent.divxpos = recordit.divxpos;
	wwevent.divypos = recordit.divypos;
	wwevent.framenumber = recordit.framenumber;
	wwevent.framecount = recordit.framecount;
	wwevent.layerlevel = num;
	if( num > 1 )	{
		wwevent.arraysize = num-1;
		wwevent.arrayitself = new Array();
		for(var m=0; m <num;m++)        {
			wwevent.arrayitself[m] = new WW_childevent('link');
			wwevent.arrayitself[m].layernumber = recordit.layernumber[m];
			wwevent.arrayitself[m].layercount = recordit.layercount[m];
			wwevent.arrayitself[m].layername = recordit.layername[m];
		}
	}
	var mess = 'Link ';
	if(recordit.linktype > 7 )
		mess ='Not a Link ';
	WW_tangoboss.WW_registereventindicator(5,WW_tangoboss.WW_numallevents,recordit.framenumber,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
	WW_tangoboss.WW_accumandsendevent(wwevent,WW_Eventnonmastername,mess + WW_eventlabel[recordit.linktype] + ' Event',1);
	return;
	
}	// End sendlink(recordit)

// Structure to hold form information
function recordclick()	{
	this.type = 'click';
	this.formnumber =0;
	this.elementnumber=0;
	this.formlength =0;
	this.framenumber = -1;
	this.layernumber = -1;
	this.framecount = 0;
	this.layercount =0;
}
function recordchange()	{
	this.type = 'change';
	this.formnumber =0;
	this.elementnumber=0;
	this.formlength =0;
	this.framenumber = -1;
	this.layernumber = -1;
	this.framecount = 0;
	this.layercount =0;
}

function recordchecked()	{
	this.type = 'checked';
	this.formnumber =0;
	this.elementnumber=0;
	this.formlength =0;
	this.framenumber = -1;
	this.layernumber = -1;
	this.framecount = 0;
	this.layercount =0;
}

function recordmultichange()	{
	this.type = 'multichange';
	this.formnumber =0;
	this.elementnumber=0;
	this.formlength =0;
	this,numchanged = 0;
	this.selectedindexarray = new Array();
	this.framenumber = -1;
	this.layernumber = -1;
	this.framecount = 0;
	this.layercount =0;
}

function sendclick(recordit,expectedurl)	{

	WW_tangoboss.WW_newtangolabel(WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel);
	wwevent = new WW_generatedevent(WW_tangoboss.WW_username,WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber,'formclick');
	wwevent.currenturl = WW_spawnedmainframeurl;
	wwevent.expectedurl = expectedurl.toString();
	wwevent.formnumber = recordit.formnumber;
	wwevent.elementnumber = recordit.elementnumber;
	wwevent.formlength = recordit.formlength;
	wwevent.framenumber = recordit.framenumber;
	wwevent.framecount = recordit.framecount;
	wwevent.layernumber = recordit.layernumber;
	wwevent.layercount = recordit.layercount;
	WW_tangoboss.WW_registereventindicator(4,WW_tangoboss.WW_numallevents,recordit.framenumber,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
	WW_tangoboss.WW_accumandsendevent(wwevent,WW_Eventnonmastername,'Form Click Event',1);
	return;
	
}	// End sendclick(recordit,expectedurl)

function sendchange(recordit)	{

	var messtype = 'formtextchange';
	if( WW_isdefined(recordit.selectedindex) )
		messtype = 'formsinglelistchange';
	if( recordit.type == 'multichange' )
		messtype = 'formmultilistchange';
	WW_tangoboss.WW_newtangolabel(WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel);
	wwevent = new WW_generatedevent(WW_tangoboss.WW_username,WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber,messtype);
	wwevent.currenturl = WW_spawnedmainframeurl;
	wwevent.formnumber = recordit.formnumber;
	wwevent.elementnumber = recordit.elementnumber;
	wwevent.formlength = recordit.formlength;
	wwevent.framenumber = recordit.framenumber;
	wwevent.framecount = recordit.framecount;
	wwevent.layernumber = recordit.layernumber;
	wwevent.layercount = recordit.layercount;
	if( messtype == 'formtextchange' )	{
		wwevent.formtext = recordit.text; }
	if( messtype == 'formsinglelistchange' )	{
		wwevent.selectedindex = recordit.selectedindex; } 
	if( recordit.type == 'multichange' )	{
		var num = recordit.numchanged;
		wwevent.arraysize = num;
        wwevent.arrayitself = new Array();
	    for(var m=0; m <num;m++)        {
			wwevent.arrayitself[m] = new WW_childevent('formmultilistchange');
			wwevent.arrayitself[m].selectedindex = recordit.selectedindexarray[m]; }
	}
	WW_tangoboss.WW_accumandsendevent(wwevent,WW_Eventnonmastername,'Form Change Event',1);
	return;

}	// End sendchange(recordit)

// Structure to hold page information
function pageinfo()	{

	this.basicurl ='';
	this.newtangolabel = '';
	this.oldtangolabel = '';
	this.childnum =0;
	this.xscroll =0;
	this.yscroll =0;
	this.title='Unset Title';
	this.places = new Array();
	this.framexscroll = new Array();
	this.frameyscroll = new Array(); 
	this.newframelabels = new Array();
	this.oldframelabels = new Array();

// Used to record events where no change in URL but onunload or Dynamic Tango Only this used
// currently) detects a change in page (typically User invokes reload)
	this.reloadframenumber = -2; // if -1 reload main page, if >= 0 reload this framenumber
	
}	// End Constructor pageinfo() for framed pages


function packpageinfo(wwevent)	{	// Set frame information into event

	if( WW_previouspageinfo.reloadframenumber > -2)
		wwevent.reloadframenumber = WW_previouspageinfo.reloadframenumber;
	var num = WW_previouspageinfo.childnum;
	if( num <=1)	{
		wwevent.xscroll = WW_previouspageinfo.xscroll;
		wwevent.yscroll = WW_previouspageinfo.yscroll;
		return; }
	wwevent.arraysize = num;
	wwevent.framecount = num;
	wwevent.arrayitself = new Array();
	for(var m=0; m <num;m++)	{
		wwevent.arrayitself[m] = {};
		wwevent.arrayitself[m].xscroll = WW_previouspageinfo.framexscroll[m];
		wwevent.arrayitself[m].yscroll = WW_previouspageinfo.frameyscroll[m];
		wwevent.arrayitself[m].frameurl = WW_previouspageinfo.places[m]; }
	return;
	
}	// End	packpageinfo(wwevent)

function setpageinfo(wwevent,outputurl)	{
//	Read framed page info from event

	if(WW_isdefined(wwevent.expectedurl))	{
		WW_expectedurlmemory = -WW_tangoboss.WW_waitforformtoact;
		WW_inputexpectedurl = wwevent.expectedurl; }

	readinpageinfo = new pageinfo();
	readinpageinfo.basicurl = outputurl;
	readinpageinfo.newtangolabel = wwevent.tangogrouplabel;
	if(WW_isdefined(wwevent.reloadframenumber))
		readinpageinfo.reloadframenumber = wwevent.reloadframenumber;
	if(WW_isdefined(wwevent.xscroll))
		readinpageinfo.xscroll = wwevent.xscroll;
	if(WW_isdefined(wwevent.yscroll))
		readinpageinfo.yscroll = wwevent.yscroll;
	if(WW_isdefined(wwevent.pagetitle))
		readinpageinfo.title = wwevent.pagetitle;
	if(WW_isundefined(wwevent.framecount))
		return readinpageinfo;
	var num = wwevent.framecount;
	readinpageinfo.childnum = num;
	for( var m =0; m < num; m++)	{
		readinpageinfo.places[m] = WW_tangoboss.WW_dosubsturl(wwevent.arrayitself[m].frameurl,WW_tangoboss.WW_oldstem,WW_tangoboss.WW_newstem);
		readinpageinfo.framexscroll[m] = wwevent.arrayitself[m].xscroll;
		readinpageinfo.frameyscroll[m] = wwevent.arrayitself[m].yscroll;
	}
	return readinpageinfo;

}	// End setpageinfo(wwevent,readinpageinfo)

// Compare two framed pages -- return 0 (identical) 1 (differ critically in URL's) -1 (differ only in scrolling)
function comppageinfo(info1,info2)	{

	var num1 = info1.childnum;
	var num2 = info2.childnum;
	var usetodecide = WW_tangoboss.WW_usescroll;
	if( WW_tangoboss.WW_geteventmode == 0 )
		usetodecide = WW_tangoboss.WW_sendscroll;
	if( (num1<=1) && (num2<=1) )	{
		if( usetodecide)	{ // Process Scroll Events
			if(Math.abs(info1.xscroll - info2.xscroll) > 2)
				return -1;
			if(Math.abs(info1.yscroll - info2.yscroll) > 2 )
				return -1;
		}
		return 0;
	}
	if( num1 != num2 )
		return 1;
	var scrolldiff = 0;
	for(var m=0; m<num1; m++ )	{
		if(info1.places[m] != info2.places[m] )
			return 1;
		if(usetodecide)	{ // Process Scroll Events in Frames
			if(Math.abs(info1.framexscroll[m]-info2.framexscroll[m]) > 2 )
				scrolldiff = -1;
			if(Math.abs(info1.frameyscroll[m]-info2.frameyscroll[m]) > 2 )
				scrolldiff = -1;
		}
	}
	return scrolldiff;
}
function copypageinfo(info)	{

	newinfo = new pageinfo();
	newinfo.basicurl = info.basicurl;
	newinfo.newtangolabel = info.newtangolabel;
	newinfo.oldtangolabel = info.oldtangolabel;
	newinfo.title = info.title;
	var num = info.childnum;
	newinfo.childnum = num;
	newinfo.xscroll = info.xscroll;
	newinfo.yscroll = info.yscroll;
	newinfo.reloadframenumber = info.reloadframenumber;
	if( num <= 1)
		return newinfo;
	for(var m=0; m<num; m++ )      {
		newinfo.places[m] = info.places[m];
		newinfo.newframelabels[m] = info.newframelabels[m]; 
		newinfo.oldframelabels[m] = info.oldframelabels[m];
		newinfo.framexscroll[m] = info.framexscroll[m];
		newinfo.frameyscroll[m] = info.frameyscroll[m];
	}
	return newinfo;
}
	
var WW_spawnedmainframepageinfo = null;
var WW_previouspageinfo = new pageinfo();
var WW_currentinputpageinfo = new pageinfo();

// Loop setting URL's and preserving ControlBar
var heartbeat =0;
var barbeat =WW_bartestlimit;
var transferurl ='';
var pageinfostring = '';
var eventinfostring = '';
var doctitle = 'Unset';
var WW_clockskip = 0;
var WW_countcycles =0;
var WW_heartlimit = 15*WW_clockunits;

//  Location Event Processing
function WW_Tangolocationevent(specialeventflag,originaleventnumber)	{ // Process Location Event

	var windowarg = WW_getframehandle('WWsignedchild');
	if( windowarg == null)
		return true;
	var receivedevent = WW_tangoboss.WW_eventrecord[originaleventnumber-1];
	var urlfrommaster = '';
	if( WW_isdefined(receivedevent.currenturl))
		urlfrommaster = receivedevent.currenturl;
	if( urlfrommaster == '' )
		return true;
	WW_tangoboss.WW_majoreventprocess = 1;
	var eventindicator = receivedevent.infotype;
	if( specialeventflag )	{
		WW_inputexpectedurl = '';
		WW_expectedurlmemory = 0;
		eventindicator = 0; }
	var readinpageinfo = setpageinfo(receivedevent,urlfrommaster);
	var somethingdone = 0;
	var addedmessage = '';
	if( (WW_tangoboss.WW_oldstem != '') && (WW_tangoboss.WW_newstem != '') ) { // Convert URL Stems
		urlfrommaster= WW_tangoboss.WW_dosubsturl(urlfrommaster,WW_tangoboss.WW_oldstem,WW_tangoboss.WW_newstem); }
		
	if(eventindicator == 6 )	{ // Reset current url with action from trapped link or form
		WW_tangoboss.WW_currentfullurl = urlfrommaster;
		WW_currentinputpageinfo = readinpageinfo;
		somethingdone =1;
		WW_createmajorinputevent(specialeventflag,originaleventnumber,somethingdone,urlfrommaster,addedmessage);
		return true;}
		
	if( urlfrommaster != WW_tangoboss.WW_currentfullurl )	{	// Event URL different from that expected from last transmission
		WW_tangoboss.WW_setjavaconsole(' Master URL ' + urlfrommaster);
		if( WW_spawnedmainframeurl != urlfrommaster )  {
			WW_tangoboss.WW_setjavaconsole(' Client URL was ' + WW_spawnedmainframeurl + ' indicator ' + eventindicator);
			if( WW_inputexpectedurl != '' )
				WW_tangoboss.WW_setjavaconsole(' Expected Action URL is ' + WW_inputexpectedurl);
			windowarg.location.href = urlfrommaster;
			addedmessage = 'URL Changed and master(' + urlfrommaster + ') != client(' + WW_spawnedmainframeurl +')'; }
		else	{
			addedmessage = 'URL Changed but master=client ' + urlfrommaster; }
		WW_tangoboss.WW_currentfullurl = urlfrommaster;
		WW_currentinputpageinfo = readinpageinfo;
		WW_tangoboss.WW_processingerrorflag = 0;
		somethingdone =1;
	}	// End Change in overall URL from that expected
	else	{	// Event Full URL Unchanged
		var scrollframeflag =  comppageinfo(readinpageinfo,WW_spawnedmainframepageinfo);
		if( (readinpageinfo.childnum > 0) && (scrollframeflag == 1) )	{ // Frames Changed in more than scrolling
			WW_tangoboss.WW_setjavaconsole(' Framed Page Changed Internally');
			WW_tangoboss.WW_processingerrorflag = 0;
			addedmessage = 'Frames Changed';
			WW_tangoboss.WW_setframesfrominfo(readinpageinfo);
			somethingdone =1;
			WW_currentinputpageinfo = readinpageinfo;
			WW_tangoboss.WW_currentfullurl = urlfrommaster;
		}
		else	{ // Frames Not Changed
			var possiblereload = readinpageinfo.reloadframenumber;
			if( possiblereload > -2 )	{ // Reload demanded
				WW_tangoboss.WW_setjavaconsole(' Reload Detected in Frame ' + possiblereload);
				WW_tangoboss.WW_processingerrorflag = 0;
				if( possiblereload == -1 )	{
					addedmessage = 'Main Page Reloaded';
					windowarg.location.reload();
				}
				else	{
					addedmessage = 'Frame ' +  possiblereload + ' Reloaded';
					var numframes = windowarg.length;
					if( WW_isdefined(numframes) && (numframes >= (possiblereload+1)) )	{
						windowarg.frames[possiblereload].location.reload();
					}
				}
				WW_tangoboss.WW_setframesfrominfo(readinpageinfo);
				somethingdone =1;
				WW_currentinputpageinfo = readinpageinfo;
				WW_tangoboss.WW_currentfullurl = urlfrommaster;
			}
			else	{ // nothing At All Unless User Changed Illegally!!!!!!
				addedmessage = 'URL from master=client ' + WW_spawnedmainframeurl;
				if( (WW_spawnedmainframeurl != urlfrommaster) )	{ // User Changed URL
					WW_tangoboss.WW_processingerrorflag = 1;
					addedmessage = 'URL from master(' + urlfrommaster + ') !=client(' + WW_spawnedmainframeurl + ')';
					WW_tangoboss.WW_setjavaconsole(' Reload as ' + addedmessage);
					windowarg.location.href = urlfrommaster;
					somethingdone = 1;
				}
			}
		}
		if( (scrollframeflag == -1) && (somethingdone == 0) )	{ // Scrolling Changed -- possibly in frames
			if( receivedevent.infotype == 0)
				receivedevent.infotype = 2;
			receivedevent.message += ' (Used for Scrolling)';
			WW_setscrolling(readinpageinfo);
			WW_spawnedmainframepageinfo = readinpageinfo;
			WW_tangoboss.WW_processingerrorflag = 0;
		}

	}	// End Event Full URL unchanged
	WW_createmajorinputevent(specialeventflag,originaleventnumber,somethingdone,urlfrommaster,addedmessage);
	return true;
   
}	// End WW_Tangolocationevent(receivedevent)

//	Create Major event on Input
function WW_createmajorinputevent(specialeventflag,originaleventnumber,somethingdone,urlfrommaster,addedmessage)	{
	
	var eventnumber = originaleventnumber;
	var oldevent = WW_tangoboss.WW_eventrecord[eventnumber-1];
	oldevent.processed = 1;
	var outputmessage = '';
	if(WW_isdefined(oldevent.message))
		outputmessage = oldevent.message;
	WW_tangoboss.WW_globalurl= urlfrommaster;
	if(specialeventflag)
		addedmessage = 'Heartbeat: ' + addedmessage;
	WW_tangoboss.WW_setstatusline(addedmessage + ' ' + outputmessage);
	if( somethingdone == 0 )	{
		WW_tangoboss.WW_majoreventprocess = 0;
		return true; }
	var receivedevent = null;
	if(specialeventflag)	{
		receivedevent = WW_cloneevent(oldevent);
		receivedevent.infotype =0;
		receivedevent.processed =1;
		WW_tangoboss.WW_eventrecord[WW_tangoboss.WW_numallevents] = receivedevent;
		++WW_tangoboss.WW_numallevents;
		eventnumber = WW_tangoboss.WW_numallevents;
	}
	else	{
		receivedevent = oldevent;
	}
	WW_savethumbnail = '';
	if( WW_isdefined(receivedevent.thumbnailurl))
		WW_savethumbnail = receivedevent.thumbnailurl;
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl] = {};
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl].thumbnail = {};
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl].thumbnail.processing = -1;
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl].thumbnail.currenturl = '';
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl].url = urlfrommaster;
	if( outputmessage == '' )
		outputmessage = urlfrommaster;
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl].label = receivedevent.type + ': ' + outputmessage;
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl].associatedevent = eventnumber;
	WW_tangoboss.WW_updatefavorites(urlfrommaster);
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl].indicator = WW_tangoboss.WW_numeventindicators;
	WW_tangoboss.WW_registereventindicator(7,WW_tangoboss.WW_numberurl,-2,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
	++WW_tangoboss.WW_numberurl;
	WW_tangoboss.WW_majoreventprocess = 0;
	receivedevent.majorevent = WW_tangoboss.WW_numberurl;
	receivedevent.processed = 1;
	WW_tangoboss.WW_numpointereventsdone = WW_tangoboss.WW_numeventsdone;
	return;

}	// End WW_createmajorinputevent(somethingdone,outputurltype,outputurl,outputmessage,addedmessage,thumbnailurl)

// Control Local Computations every clock tick *********************
function WW_loopforever()	{
	if( !WW_isitawindow(WW_tangoboss))
		return;
	++barbeat;
	if( barbeat > WW_bartestlimit)	{	// Create Control Bar
		barbeat =0;
		var oldwindow = WW_tangoboss.WW_topcontrolwindow;
		if( (!WW_isitawindow(oldwindow)) || (WW_tangoboss.WW_topcontrolwindowreadytogo !=1))	{
			WW_createdestroybuttonbar();	}
	}
	WW_tangoboss.WW_neverdone = 2;
	if( WW_isundefined(window.length) )	{ // *** test if this window set up correctly
	        return; }
	if( window.length < 2 )	{
	        return; }
	outsidewindow = window.frames[1];
	if( !WW_isitawindow(outsidewindow) )	{
	        return; }
	if(WW_isundefined(outsidewindow.WW_setbyoutsidewindow))	{
                return; }
	if( outsidewindow.WW_setbyparent == 0 )	{ // *** set up unsigned frames[1]
		outsidewindow.WW_setbyparent = 1;
		outsidewindow.WW_tangoboss = WW_tangoboss;
		outsidewindow.WW_tangowisdomstatus = WW_tangowisdomstatus;
	}
	WW_tangoboss.WW_connecttohistory(); // *** Set up link from History Parent (if exists) to our window system
	WW_clockskip = ++WW_clockskip;	// Advance JavaScript clock
	if( WW_clockskip > 3 )	{
		WW_clockskip = 0;
		WW_tangoboss.WW_sendclocktick(); }
	WW_tangoboss.WW_updatebuttonbar(); // Keep Buttonbar uptodate
		
	var oldurl = WW_spawnedmainframeurl; // Examine status of real window in frames[0] *****
	WW_spawnedmainframepageinfo = new pageinfo();
	var examineflag = WW_examineframedlocation(WW_previouspageinfo);
	WW_spawnedmainframeurl = WW_spawnedmainframepageinfo.basicurl;
	++WW_countcycles;
	outsidewindow.WW_countcycles = WW_countcycles; // **** save results in unsigned window
	if( (WW_tangoboss.WW_barmessagelimit > 0) && (WW_countcycles >= WW_tangoboss.WW_barmessagelimit) )
		WW_tangoboss.WW_removebarmessage();
	
	if( (WW_tangoboss.WW_geteventmode == 2)&&(WW_tangoboss.WW_majoreventprocess == 0) )	 // Set up replayed events from WW_eventrecord
		WW_tangoboss.WW_Addnextevent();

	WW_allowclicks = false; // Don't allow clicks by user on nonmaster
	
	var receivedevent = null;	// Container for events
	
	if( WW_tangoboss.WW_requestupdate==1 )	{
		WW_tangoboss.WW_updatestate(1);
		WW_tangoboss.WW_requestupdate = 0;
	}

// Process Pointer events
		while( WW_tangoboss.WW_numpointereventsdone < WW_tangoboss.WW_numallevents)	{
			receivedevent = WW_tangoboss.WW_eventrecord[WW_tangoboss.WW_numpointereventsdone];
			if( receivedevent.infotype != 3 )	{
				++WW_tangoboss.WW_numpointereventsdone;
				continue;
			}
			if( WW_isdefined(receivedevent.processed) && (receivedevent.processed==1) )	{
				++WW_tangoboss.WW_numpointereventsdone;
				continue;
			}
			break;
		}

//	Process Event Queue for Master
	if( (WW_tangoboss.WW_geteventmode == 0) && (WW_tangoboss.WW_majoreventprocess == 0) && (WW_tangoboss.WW_numeventsdone < WW_tangoboss.WW_numallevents) )	{ // Process Events
		while( WW_tangoboss.WW_numeventsdone < WW_tangoboss.WW_numallevents)	{
				receivedevent = WW_tangoboss.WW_eventrecord[WW_tangoboss.WW_numeventsdone];
				++WW_tangoboss.WW_numeventsdone;
				if( WW_isdefined(receivedevent.processed))	{
					if(receivedevent.processed>0)
						continue;
				}
			var eventindicator = receivedevent.infotype;
			if( eventindicator !=2 )
				continue;
			outputurltype = receivedevent.type;
			if( outputurltype != 'bookmark' )
				continue;
			var evsourceflag = receivedevent.sourceflag;
			if( evsourceflag != WW_tangoboss.WW_inputsequence )	{
				WW_tangoboss.WW_inputsequence = evsourceflag;
				WW_tangoboss.WW_setstatusline('New Event Stream ' + evsourceflag);
				WW_tangoboss.WW_inputgrouplabel = receivedevent.tangogrouplabel;
				WW_tangoboss.WW_numpointereventsdone = WW_tangoboss.WW_numeventsdone;
			}
			if( eventindicator == 2 )	{	// Bookmarks
				var minorevupdateresult =true;
				if( outputurltype.indexOf('bookmark') >= 0 )
					minorevupdateresult = WW_tangoboss.WW_readsystembookmarks(receivedevent);
				receivedevent.processed = 1; // Succesful processing
				break
			}
		}
	}	// End Process events for Master
	
//	Process Event Queue for Replay or Non Master
	if( (WW_tangoboss.WW_geteventmode >= 1) && (WW_tangoboss.WW_majoreventprocess == 0) && (WW_tangoboss.WW_numeventsdone < WW_tangoboss.WW_numallevents) )	{ // Process Events
		var specialround = WW_tangoboss.WW_doublecheckonthis;
		if( WW_inputexpectedurl != '' )
			specialround =0;
		while( (specialround>0) || (WW_tangoboss.WW_numeventsdone < WW_tangoboss.WW_numallevents))	{
			if( WW_getframehandle('WWsignedchild') == null )
 				break;
			var specialeventnumber = 0;
			if( specialround>0 )	{
				receivedevent = WW_tangoboss.WW_eventrecord[specialround-1];
				specialeventnumber = specialround;
				specialround = 0;
				WW_tangoboss.WW_doublecheckonthis=0; }
			else	{
				receivedevent = WW_tangoboss.WW_eventrecord[WW_tangoboss.WW_numeventsdone];
				++WW_tangoboss.WW_numeventsdone;
				if( WW_isdefined(receivedevent.processed))	{
					if(receivedevent.processed>0)
						continue;
				}
			}
			if( WW_inputexpectedurl != '' )	{
				if( WW_spawnedmainframeurl == WW_inputexpectedurl )	{
					WW_inputexpectedurl = '';
					WW_expectedurlmemory = 0;
				}
				else	{
					++WW_expectedurlmemory;
					if( WW_expectedurlmemory >= 0 )
						WW_inputexpectedurl = '';
					else	{
						--WW_tangoboss.WW_numeventsdone;
						break;
					}
				}
			}
			WW_tangoboss.WW_majoreventprocess = 1; // Set Flag in case resize needed
			if(!WW_tangoboss.WW_checkwindowsize(receivedevent))
				return true; // return if window being resized even from a pointer event
			WW_tangoboss.WW_majoreventprocess = 0;
			var eventindicator = receivedevent.infotype;
			if( (eventindicator > 2) && (eventindicator !=6) )
				continue;
			outputurltype = receivedevent.type;
			if( eventindicator == 2 && (outputurltype.indexOf('parameter') < 0) && (outputurltype.indexOf('bookmark') < 0) )	{	// Check Child Page Loaded
				if(WW_isdefined(receivedevent.currenturl) && (receivedevent.currenturl != WW_spawnedmainframeurl) )	{
					if( WW_indicatebaderror != WW_tangoboss.WW_numeventsdone)	{
						WW_indicatebaderror = WW_tangoboss.WW_numeventsdone;
						WW_badloaderror = 0; }
					++WW_badloaderror;
					if(WW_badloaderror > WW_tangoboss.WW_badloadlimit)	{
						WW_tangoboss.WW_setjavaconsole('Ignore Update minor event ' + WW_tangoboss.WW_numeventsdone + " URL Wrong " + WW_spawnedmainframeurl + " Event=" + receivedevent.currenturl);
						receivedevent.processed = 2;
						WW_tangoboss.WW_processingerrorflag = 2;
						WW_badloaderror = 0;
						WW_indicatebaderror = -1;
						WW_tangoboss.WW_startbarmessage("Error due to URL wrong (See Console or Skip Events in Control Tab Resets All)",10);
						break; }
					WW_tangoboss.WW_processingerrorflag = 1;
					--WW_tangoboss.WW_numeventsdone;
					break; }
				if(WW_isitanincompletewindow())	{
					if( WW_indicatebaderror != WW_tangoboss.WW_numeventsdone)	{
						WW_indicatebaderror = WW_tangoboss.WW_numeventsdone;
						WW_badloaderror = 0; }
					++WW_badloaderror;
					if(WW_badloaderror > WW_tangoboss.WW_badloadlimit)	{
						WW_tangoboss.WW_setjavaconsole('Ignore Update minor event ' + WW_tangoboss.WW_numeventsdone + " Page Ill formed");
						WW_tangoboss.WW_startbarmessage("Error due to Illformed Page (See Console or Skip Events in Control Tab Resets All)",10);
						receivedevent.processed = 2;
						WW_tangoboss.WW_processingerrorflag = 2;
						WW_badloaderror = 0;
						WW_indicatebaderror = -1;
						break; }
					WW_tangoboss.WW_processingerrorflag = 1;
					--WW_tangoboss.WW_numeventsdone;
					break;
				}
			}
			var evsourceflag = receivedevent.sourceflag;
			if( evsourceflag != WW_tangoboss.WW_inputsequence )	{
				WW_tangoboss.WW_inputsequence = evsourceflag;
				WW_tangoboss.WW_setstatusline('New Event Stream ' + evsourceflag);
				WW_tangoboss.WW_inputgrouplabel = receivedevent.tangogrouplabel;
				WW_tangoboss.WW_numpointereventsdone = WW_tangoboss.WW_numeventsdone;
			}
			if( (eventindicator == 0) || (eventindicator == 1) || (eventindicator == 6) ){	// Heart and Location Set
				WW_tangoboss.WW_majoreventprocess = 1;
				WW_tangoboss.WW_inputgrouplabel = receivedevent.tangogrouplabel;
				if( specialeventnumber > 0 )
					WW_Tangolocationevent(true,specialeventnumber);
				else	WW_Tangolocationevent(false,WW_tangoboss.WW_numeventsdone);
				break;
			}

			if( eventindicator == 2 )	{	// // Forms Links Layers Scrolling Parameters Bookmarks
				if( receivedevent.tangogrouplabel == WW_tangoboss.WW_inputgrouplabel )	{
					var minorevupdateresult =true;
					if( outputurltype.indexOf('form') >= 0 )
						minorevupdateresult = WW_interpretformevents(receivedevent,1);
					if( outputurltype.indexOf('parameter') >= 0 )
						minorevupdateresult = WW_tangoboss.WW_readformparameters(receivedevent);
					if( outputurltype.indexOf('bookmark') >= 0 )
						minorevupdateresult = WW_tangoboss.WW_readsystembookmarks(receivedevent);
					if( outputurltype.indexOf('link') >= 0 )
						minorevupdateresult = WW_interpretlinkevents(receivedevent);
					if( outputurltype.indexOf('scroll') >= 0 )	{
						if(WW_tangoboss.WW_usescroll)	{	// Interpret Scroll Events
							minorevupdateresult = WW_interpretscrollevents(receivedevent); }
					}
					if(!minorevupdateresult)	{ // Error in Processing of Some Type
						if( WW_indicatenotsobaderror != WW_tangoboss.WW_numeventsdone)	{
							WW_indicatenotsobaderror = WW_tangoboss.WW_numeventsdone;
							WW_tangoboss.WW_seterrorline(' Minor Event Error ' + 'Evno ' + WW_tangoboss.WW_numeventsdone + 'Limit ' + WW_tangoboss.WW_notsobadloadlimit);
							WW_notsobadloaderror = 0; }
						++WW_notsobadloaderror;
						if(WW_notsobadloaderror > WW_tangoboss.WW_notsobadloadlimit)	{
							WW_tangoboss.WW_seterrorline('Ignore Update minor event ' + WW_tangoboss.WW_numeventsdone + " Insertion error");
							receivedevent.processed = 2;
							WW_tangoboss.WW_processingerrorflag = 2;
							WW_notsobadloaderror = 0;
							WW_indicatenotsobaderror = -1;
							WW_tangoboss.WW_startbarmessage("Error due to Bad Data (See Console or Skip Events in Control Tab Resets All)",10);
							break; }
						WW_tangoboss.WW_setjavaconsole(' Error in Update ' + WW_tangoboss.WW_numeventsdone);
						WW_tangoboss.WW_processingerrorflag =1;
						--WW_tangoboss.WW_numeventsdone;
						break;
					}
					receivedevent.processed = 1; // Succesful processing
					WW_tangoboss.WW_processingerrorflag =0;
					break;
				}
				else	{ // Mismatched Tango Group Labels
					if( WW_indicatebaderror != WW_tangoboss.WW_numeventsdone)	{
						WW_indicatebaderror = WW_tangoboss.WW_numeventsdone;
							WW_tangoboss.WW_seterrorline(' Minor Event Error ' + 'Evno ' + WW_tangoboss.WW_numeventsdone + 'Limit ' + WW_tangoboss.WW_badloadlimit);
						WW_badloaderror = 0; }
					++WW_badloaderror;
					if(WW_badloaderror > WW_tangoboss.WW_badloadlimit)	{
						WW_tangoboss.WW_seterrorline('Ignore Update minor event ' + WW_tangoboss.WW_numeventsdone + " Groups Wrong Event" + receivedevent.tangogrouplabel + ' Stream ' + WW_tangoboss.WW_inputgrouplabel);
						receivedevent.processed = 2;
						WW_tangoboss.WW_processingerrorflag = 1;
						WW_badloaderror = 0;
						WW_indicatebaderror = -1;
						break; }
					WW_tangoboss.WW_processingerrorflag = 1;
					--WW_tangoboss.WW_numeventsdone;
					break; 
				}
			}
		}
	}
	WW_setupevents(); // *** Set up Event Capturing
	
	if( (WW_tangoboss.WW_geteventmode == 0) && (WW_spawnedmainframeurl != '') )	{ // Master Set ********
		if(WW_spawnedmainframeurl != oldurl )	{	// Main URL Changed
			WW_spawnedmainframepageinfo.reloadframenumber = -2;
			WW_previouspageinfo = copypageinfo(WW_spawnedmainframepageinfo);
			wwevent = new WW_generatedevent(WW_tangoboss.WW_username,WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber,'simplepage');
			WW_wasitgenerated(wwevent); 
			wwevent.currenturl = WW_spawnedmainframeurl;
			wwevent.innerheight = self.innerHeight;
			wwevent.innerwidth = self.innerWidth;
			WW_tangoboss.WW_globalurl = WW_spawnedmainframeurl;
			doctitle = WW_previouspageinfo.title;
			if( WW_previouspageinfo.title == '' )
				doctitle = WW_spawnedmainframeurl;
			wwevent.pagetitle = doctitle;
			packpageinfo(wwevent);
			WW_tangoboss.WW_registereventindicator(3,WW_tangoboss.WW_numallevents,-1,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
			WW_tangoboss.WW_accumandsendevent(wwevent,WW_Eventnonmastername,doctitle,1);
			WW_tangoboss.WW_accummajorinfo( WW_spawnedmainframeurl,doctitle);
			WW_tangoboss.WW_sendaddcoloredhand(1);
			WW_heuristicnextprevurls(WW_spawnedmainframeurl);
			heartbeat =0;
		}
		else	{	// Main URL Unchanged -- See if frame changed or perhaps just detected through unload or dynamic flag
			var scrollframeflag = comppageinfo(WW_previouspageinfo,WW_spawnedmainframepageinfo);

			if( (examineflag>0) || (scrollframeflag == 1) )	{	// Frame Changed or Reload Detected
				if( (scrollframeflag == 1) && (WW_spawnedmainframepageinfo.reloadframenumber >= 0 ) )
					WW_spawnedmainframepageinfo.reloadframenumber = -2;
				WW_previouspageinfo = copypageinfo(WW_spawnedmainframepageinfo);
				WW_tangoboss.WW_globalurl = WW_spawnedmainframeurl;
				wwevent = new WW_generatedevent(WW_tangoboss.WW_username,WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber,'simplepage');
				WW_wasitgenerated(wwevent);
				wwevent.currenturl = WW_spawnedmainframeurl;
				doctitle = WW_previouspageinfo.title;
				if( WW_previouspageinfo.title == '' )
					doctitle = WW_spawnedmainframeurl;
				if( (scrollframeflag <= 0) || (WW_previouspageinfo.reloadframenumber == -1))	{
					doctitle = 'Reload Frame:' + WW_previouspageinfo.reloadframenumber + ' ' + doctitle; }
				else	{
					doctitle = 'Frame Change:' + doctitle; }
				wwevent.pagetitle = doctitle;
				wwevent.innerheight = self.innerHeight;
				wwevent.innerwidth = self.innerWidth;
				packpageinfo(wwevent);
				WW_tangoboss.WW_registereventindicator(3,WW_tangoboss.WW_numallevents,-2,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
				WW_tangoboss.WW_accumandsendevent(wwevent,WW_Eventnonmastername,doctitle,1);
				WW_tangoboss.WW_accummajorinfo(WW_spawnedmainframeurl,doctitle);
				WW_tangoboss.WW_sendaddcoloredhand(1);
				heartbeat =0;
			}
			else	{
				if( scrollframeflag == -1 )	{ // Scrolling changed in fixed frameset
					WW_previouspageinfo = copypageinfo(WW_spawnedmainframepageinfo);
					WW_tangoboss.WW_globalurl = WW_spawnedmainframeurl;
					WW_tangoboss.WW_newtangolabel(WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel);
					wwevent = new WW_generatedevent(WW_tangoboss.WW_username,WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber,'scroll');
					wwevent.infotype = 2;
					wwevent.currenturl = WW_spawnedmainframeurl;
					packpageinfo(wwevent);
					WW_tangoboss.WW_accumandsendevent(wwevent,WW_Eventnonmastername,'Scroll Change',1);
					heartbeat =0;
				}
				else	{	// Main and Frames Unchanged
					++heartbeat;
					if( heartbeat >= WW_heartlimit )
						WW_tangoboss.WW_waitingparticipantlist.length = 0;
					if((heartbeat >= WW_heartlimit) || (WW_tangoboss.WW_waitingparticipantlist.length > 0) )	{
						var mess1 = 'Heartbeat ';
						var mess2 = 'General Heartbeat Pulse';
						if( WW_tangoboss.WW_waitingparticipantlist.length > 0 )	{
							mess1 = WW_tangoboss.WW_waitingparticipantlist.toString();
							mess2 = 'Initialize ' + mess1;
							mess1 += ' Heartbeat '; }	
						heartbeat =0;
						doctitle = WW_spawnedmainframepageinfo.title;
						wwevent = new WW_generatedevent(WW_tangoboss.WW_username,WW_tangoboss.WW_localflag,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber,'heart');
						wwevent.infotype = 0;
						wwevent.pagetitle = doctitle;
						wwevent.currenturl = WW_spawnedmainframeurl;
						wwevent.innerheight = self.innerHeight;
						wwevent.innerwidth = self.innerWidth;
						packpageinfo(wwevent);
						WW_tangoboss.WW_accumandsendevent(wwevent,WW_Eventnonmastername,mess1 + doctitle,0);
						WW_updatefullpointerparms(0);
						if( WW_tangoboss.WW_parameterssent)
							WW_tangoboss.WW_sendformparameters(0);
						if( WW_tangoboss.WW_numsystembookmarks > 0 )
							WW_tangoboss.WW_sendsystembookmarks(0);
						WW_tangoboss.WW_sendaddcoloredhand(0);
						if( WW_tangoboss.WW_waitingparticipantlist.length > 0 )
							WW_tangoboss.WW_setstatusline(mess2);
						else	{
							WW_tangoboss.WW_settempstatusline(mess2); }
						WW_tangoboss.WW_waitingparticipantlist.length = 0;
					}
				}
			}
		}
	}
	return;

}	// End WW_loopforever() looping forever

// Functions to launch ControlBar

function WW_launchbar() {

	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserAccess");

	msgWindow=window.open("",WW_barrandomname,"outerWidth=" + WW_bartotalwidth +",outerHeight=40,alwaysRaised=yes,hotkeys=no,location=no,menubar=no,resizable=no,screenX=0,screenY=0,scrollbars=no,status=no,titlebar=no,toolbar=no");
	if (msgWindow.document.URL == "")
		window.open("horizontalbar.html",WW_barrandomname);
	else
		msgWindow.location.reload();
	WW_tangoboss.WW_launchedbarbutton = 1;
	
}	// End WW_launchbar()

function WW_destroybar() {

	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserAccess")
	msgWindow=window.open("",WW_barrandomname);
	if (msgWindow.document.URL != "")
		msgWindow.close();
	WW_tangoboss.WW_launchedbarbutton = 0;

}	// End WW_destroybar()

function WW_settotalwidth()	{

	WW_bartotalwidth =0;
	if(!WW_isitawindow(WW_tangoboss))
		return;
	var localbuttonspec = WW_tangoboss.WW_buttonspec;
	var row = 0;
	for(var mm=0;mm< localbuttonspec.nbutton;mm++)	{
		if( localbuttonspec.ignore[mm] == 1 )
			continue;
		if( localbuttonspec.height[mm] < 30 )  {
			row = 1 - row;
			if( row == 0 )
				continue;
		}
		WW_bartotalwidth += localbuttonspec.width[mm]; 
	}
	
}	// End WW_settotalwidth()

function WW_createdestroybuttonbar()	{

	if( !WW_isitawindow(WW_tangoboss))
		return true;
	var oldwindow = WW_tangoboss.WW_topcontrolwindow;
	WW_tangoboss.WW_topcontrolwindow = null;
	WW_tangoboss.WW_topcontrolwindowreadytogo =0;
	WW_tangoboss.WW_launchedbarbutton = 0;
	WW_settotalwidth();
	if( WW_isitawindow(oldwindow))	{	
		WW_destroybar(); 
		barbeat=WW_bartestlimit; }
	else	{
		WW_launchbar();
		barbeat = 0;	}
	return;
	
}	// End WW_createdestroybuttonbar()

function WW_isthisapointeredpage(framearg)	{ // Return True if Healthy Pointer in Frame

	if(!WW_isitawindow(framearg))
		return false;
	if(WW_isdefined(framearg.WWTango_pointertarget))	{
		if(framearg.WWTango_pointertarget)	{
			if(WW_isdefined(framearg.WW_isloaded))	{
				if( framearg.WW_isloaded == 1 )	{
					return true;
				}
			}
		}
	}
	return false;

}	// End WW_isthisapointeredpage(framearg)

function WW_updatefullpointerparms(flag)	{ // Record as Event latest pointer information
// Last event contains current state of pointer if this is a pointer page
// flag =0 does not preserve event as heartbeat

	var loopct = 1;
	var pointerframe = null;
	if( WW_pointerframeset.childnum > 1 )
		loopct += WW_pointerframeset.childnum ;
	for(var m=0; m < loopct; m++)	{
		if( m == 0 )	{
			pointerframe = WW_pointerframeset.mainpage; }
		if( m > 0 )	{
			pointerframe = WW_pointerframeset.framepages[m-1]; }
		if(!WW_isitawindow(pointerframe))
			continue;
		if(!WW_isthisapointeredpage(pointerframe))
			continue;
		pointerframe.WW_updatefullpointerparms(flag);
	}
	return true;

}	// End WW_updatefullpointerparms(flag)

// *************** See if Shared Page ready for use *****************
function WW_isitanincompletewindow()	{

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return true;
	var num = windowarg.length;
	if( num <= 1)	{
		if(WW_testaframe(-1,windowarg))
			return true;
	}
	else	{
		for(var m=0; m <num; m++)	{
			framearg = windowarg.frames[m];
			if(WW_testaframe(m,framearg))
				return true;
		}
	}
	return false;

}	// End WW_isitanincompletewindow()

// Return -2 unidentified, -1 Main child window, >= 0 frame number
function WW_identifyframe(windowhandle)	{

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = self.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return -2;
	var num = windowarg.length;
	if( num <= 1)	{
		if(windowarg == windowhandle)
			return -1;
		return -2;
	}
	else	{
		for(var m=0; m <num; m++)	{
			framearg = windowarg.frames[m];
			if(framearg == windowhandle)
				return m;
		}
	}
	return -2;

}	// End WW_identifyframe(windowhandle)

function WW_testaframe(framenumber,framearg)	{ // return true if frame bad

	if( WW_pointerframeset.trytocountdocarrays >=  0 )	// Thorough test for main page
		return true;
	if( framenumber >= 0 )	{
		if( WW_isundefined(WW_pointerframeset.frametrytocountdocarrays[framenumber]) || (WW_pointerframeset.frametrytocountdocarrays[framenumber] >=  0) )	// Thorough test for frame
			return true;
	}
	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	if(WW_isundefined(framearg.document))
		return true;
	if(WW_isundefined(framearg.document.forms))
		return true;
	if(WW_isundefined(framearg.document.forms.length))
		return true;
	if(WW_isundefined(framearg.document.links))
		return true;
	if(WW_isundefined(framearg.document.links.length))
		return true;
	if(WW_isundefined(framearg.document.layers))
		return true;
	if(WW_isundefined(framearg.document.layers.length))
		return true;
	return false;

}	// End WW_testaframe(framearg)

// *************** Examine Shared Page for Events / URL's Etc. ******************************
function WW_examineframedlocation(oldstorestuff) {

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = window.WWsignedchild;
	var retflag = -1; // error return
	if(!WW_isitawindow(windowarg))	{
		WW_spawnedmainframepageinfo.childnum =0;
		WW_spawnedmainframepageinfo.basicurl ='';
		WW_spawnedmainframepageinfo.title ='';
		return retflag;
	}
	retflag = 0; // Probably no change
	
//	Set up Pointer Main Page: Done here as needs security privileges
//	Set Game Control Here -- assumed to be in main page (pointers can be in frames)
	var nopointerstuff = true;
	var nogamestuff = true;
	WW_gamemaster = null;
	if( WW_isthisapointeredpage(windowarg) )	{
		if( WW_isitawindow(WW_tangoboss))	{
			if( WW_isdefined(windowarg.WW_pointersetupoption) && WW_isdefined(windowarg.WW_gameinprogress) && (windowarg.WW_pointersetupoption > 10) )	{
				WW_gamemaster = windowarg;
				nogamestuff = false;
				WW_tangoboss.WW_setgamestatus(windowarg.WW_gameinprogress,windowarg.WW_pointersetupoption,windowarg.WW_playermoving);
			}
			nopointerstuff = false;
			WW_pointerframeset.mainpage = windowarg;
			WW_pointerframeset.childnum = 0;
			if( WW_tangoboss.WW_geteventmode == 0 )	{
				windowarg.WW_setasmaster(WW_tangoboss,-1,self.innerWidth,self.innerHeight,1); }
			else	{
				windowarg.WW_setasnonmaster(WW_tangoboss,-1,self.innerWidth,self.innerHeight,1); 
				windowarg.WWTango_acceptmasterstyle = WW_tangoboss.WWTango_acceptmasterstyle;
				windowarg.WWTango_canchangepointer = WW_tangoboss.WWTango_canchangepointer; }
			if( (WW_isthisapointeredpage(windowarg)) && (WW_tangoboss.WW_resetpointerto > 0) )	{
				var localeventpt = WW_tangoboss.WW_eventrecord[WW_tangoboss.WW_resetpointerto-1];
				if(WW_isundefined(localeventpt.framenumber) || (localeventpt.framenumber == -1) )	{
					windowarg.WW_processeventfromtango(localeventpt);
					WW_tangoboss.WW_resetpointerto = -1; }
			}
		}
	}
	if( nopointerstuff )	{
		WW_pointerframeset.mainpage = null;
	 }

    var testtitle = windowarg.document.title;
	if(WW_isundefined(testtitle))
		 testtitle = 'No Title Specified';
	else	{
		testtitle = testtitle.toString()+"";
	}
	WW_spawnedmainframepageinfo.title = testtitle;
	var testit = (windowarg.location.href).toString()+"";
	WW_spawnedmainframepageinfo.basicurl = testit;
	if(WW_isundefined(windowarg.WW_dynamictangoflag))	{
		retflag = 0;
		if( WW_firstdynamictangoflag != 0 )	{
			WW_registerdynamictangoflag(-1);
			retflag = 1; 
			WW_spawnedmainframepageinfo.reloadframenumber = -1;
		}
		WW_pointerframeset.trytocountdocarrays = 0;
		WW_pointerframeset.sizeofdocarrays = 0;
		WW_firstdynamictangoflag = 1;
		WW_spawnedmainframepageinfo.oldtangolabel = '';
		WW_tangoboss.WW_newtangolabel(WW_tangoboss.WW_localflag,'');
		WW_tangoboss.WW_labelstream[WW_tangoboss.WW_tangosequencenumber].eventnumber = WW_tangoboss.WW_numallevents;
		windowarg.WW_dynamictangoflag = WW_tangoboss.WW_tangogrouplabel;
		WW_tangoboss.WW_setdebugline('New Page Detected from lack of Flag ' + WW_tangoboss.WW_tangosequencenumber);
	}
	else	{
		WW_spawnedmainframepageinfo.oldtangolabel = windowarg.WW_dynamictangoflag;
	}
	if((WW_pointerframeset.trytocountdocarrays >= 0) && WW_isdefined(windowarg.document))	{
		var cursize = WW_countframecomponents(windowarg);
		
		var keepthesame = 6;
		if(cursize > 0 )
			keepthesame = 3;
		if(WW_pointerframeset.sizeofdocarrays == cursize )	{
			++WW_pointerframeset.trytocountdocarrays; }
		else	{
			WW_pointerframeset.trytocountdocarrays = 0; }
		if(WW_pointerframeset.trytocountdocarrays >= keepthesame )	{
			WW_pointerframeset.trytocountdocarrays = -1;
			WW_registercompleteddocument(-1,cursize);
			WW_thumbnailbegin();
			WW_thumbnailend();
		}

		WW_pointerframeset.sizeofdocarrays = cursize;
	}	// End Monitoring of Document Arrays
			
	WW_spawnedmainframepageinfo.newtangolabel = WW_tangoboss.WW_tangogrouplabel;
	var num = windowarg.length;
	WW_spawnedmainframepageinfo.childnum = num;
	if( WW_tangoboss.WW_allowonunload  || WW_isundefined(windowarg.onUnload) )
			windowarg.onUnload = new Function("WW_registerunload(-1,'" + WW_tangoboss.WW_tangogrouplabel + "'," + WW_tangoboss.WW_tangosequencenumber + ")");
	if( num <= 1)	{
		WW_spawnedmainframepageinfo.xscroll = WW_getwindowxscroll(windowarg);
		WW_spawnedmainframepageinfo.yscroll = WW_getwindowyscroll(windowarg);
		if( nogamestuff)	{
	 		WW_tangoboss.WW_setgamestatus(false,1,0); }
		return(retflag); }

// Framed Child Page
	WW_pointerframeset.childnum = num;
	WW_pointerframeset.mainpage = null;
	var generatenewlabel = true;	// Generate at most one new label per call
	if(oldstorestuff.newtangolabel != WW_spawnedmainframepageinfo.newtangolabel)
		generatenewlabel = false;
	for(var m=0; m < num; m++ )     {
		var frameitself = windowarg.frames[m];
		if((!WW_isitawindow(frameitself))|| WW_isundefined(frameitself.location))	{
			WW_spawnedmainframepageinfo.places[m] = '';
			WW_spawnedmainframepageinfo.oldframelabels[m] = '';
			WW_spawnedmainframepageinfo.newframelabels[m] ='';
			continue;
		}
		WW_pointerframeset.framepages[m] = frameitself;
		nopointerstuff = true;
		if( WW_isthisapointeredpage(frameitself) )	{
			if( WW_isitawindow(WW_tangoboss))	{
				if( WW_isdefined(frameitself.WW_pointersetupoption) && WW_isdefined(frameitself.WW_gameinprogress) && (windowarg.WW_pointersetupoption > 10) )	{
					WW_gamemaster = frameitself;
					nogamestuff = false;
					WW_tangoboss.WW_setgamestatus(frameitself.WW_gameinprogress,frameitself.WW_pointersetupoption,frameitself.WW_playermoving);
				}
				nopointerstuff = false;
				WW_pointerframeset.framepages[m] = frameitself;
				if( WW_tangoboss.WW_geteventmode == 0 )	{
					frameitself.WW_setasmaster(WW_tangoboss,m,self.innerWidth,self.innerHeight,1); }
				else	{
					frameitself.WW_setasnonmaster(WW_tangoboss,m,self.innerWidth,self.innerHeight,1);
					frameitself.WWTango_acceptmasterstyle = WW_tangoboss.WWTango_acceptmasterstyle;
					frameitself.WWTango_canchangepointer = WW_tangoboss.WWTango_canchangepointer;}
				if( (WW_isthisapointeredpage(frameitself)) && (WW_tangoboss.WW_resetpointerto > 0) )	{
					var localeventpt = WW_tangoboss.WW_eventrecord[WW_tangoboss.WW_resetpointerto-1];
					if(WW_isdefined(localeventpt.framenumber) && (localeventpt.framenumber == m) )	{
						frameitself.WW_processeventfromtango(localeventpt);
						WW_tangoboss.WW_resetpointerto = -1; }
				}
			}
		}
		if( nopointerstuff )	{
			WW_pointerframeset.framepages[m] = null;
		}

// Set new URL and Scrolling
		var tempurl = (frameitself.location.href).toString()+"";
		var len = parseInt(tempurl.length);
		if( tempurl.charAt(len-1) == '/' )
			tempurl = tempurl.substring(0,len-1);
		WW_spawnedmainframepageinfo.places[m] = tempurl;
		WW_spawnedmainframepageinfo.framexscroll[m] = WW_getwindowxscroll(frameitself);
		WW_spawnedmainframepageinfo.frameyscroll[m] = WW_getwindowyscroll(frameitself);
		if(WW_isundefined(frameitself.WW_dynamictangoflag))	{
			WW_registerdynamictangoflag(m);
			WW_spawnedmainframepageinfo.oldframelabels[m]= '';
			if( generatenewlabel )	{
				if(WW_isdefined(oldstorestuff.newframelabels[m])&&(oldstorestuff.newframelabels[m]!=''))	{
					generatenewlabel = false;
					WW_tangoboss.WW_newtangolabel(WW_tangoboss.WW_localflag,'');
					WW_tangoboss.WW_labelstream[WW_tangoboss.WW_tangosequencenumber].eventnumber = WW_tangoboss.WW_numallevents;
					retflag =1;
					WW_spawnedmainframepageinfo.reloadframenumber = m;
				}
			}
			WW_pointerframeset.frametrytocountdocarrays[m] = 0;
			WW_pointerframeset.framesizeofdocarrays[m] = 0;
			frameitself.WW_dynamictangoflag = WW_tangoboss.WW_tangogrouplabel;
			WW_tangoboss.WW_setdebugline('New Frame ' + m + ' Detected from lack of Flag ' + WW_tangoboss.WW_tangosequencenumber);
		}
		else	{
			WW_spawnedmainframepageinfo.oldframelabels[m] = frameitself.WW_dynamictangoflag;
		}
		if((WW_pointerframeset.frametrytocountdocarrays[m] >= 0) && WW_isdefined(frameitself.document))	{
			var cursize = WW_countframecomponents(frameitself);

			var keepthesame = 6;
			if(cursize > 0 )
				keepthesame = 3;
			if(WW_pointerframeset.framesizeofdocarrays[m] == cursize )	{
				++WW_pointerframeset.frametrytocountdocarrays[m]; }
			else	{
				WW_pointerframeset.frametrytocountdocarrays[m] = 0; }
			if(WW_pointerframeset.frametrytocountdocarrays[m] >= keepthesame )	{
				WW_pointerframeset.frametrytocountdocarrays[m] = -1;
				WW_registercompleteddocument(m,cursize);
			}
			WW_pointerframeset.framesizeofdocarrays[m] = cursize;
		}	// End Monitoring of Document Arrays in a frame
	
		WW_spawnedmainframepageinfo.newframelabels[m] = WW_tangoboss.WW_tangogrouplabel;
		if( WW_tangoboss.WW_allowonunload || WW_isundefined(windowarg.onUnload) )
			windowarg.onUnload = new Function("WW_registerunload(" + m + ",'" + WW_tangoboss.WW_tangogrouplabel + "'," + WW_tangoboss.WW_tangosequencenumber + ")");
	}	// End Loop over Frames
	if( nogamestuff)	{
	 	WW_tangoboss.WW_setgamestatus(false,1,0); }
	return(retflag);

}	// End WW_examineframedlocation()

function WW_registerdynamictangoflag(framenumber)	{ // Register onUnload events from undefined flag

	WW_tangoboss.WW_dynamictangoflagevent[WW_tangoboss.WW_numdynamictangoflag] = {};
	WW_tangoboss.WW_dynamictangoflagevent[WW_tangoboss.WW_numdynamictangoflag].indicator = WW_tangoboss.WW_numeventindicators;
	WW_tangoboss.WW_registereventindicator(2,WW_tangoboss.WW_numdynamictangoflag,framenumber,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
	++WW_tangoboss.WW_numdynamictangoflag;
	return;
	
}	// End WW_registerdynamictangoflag(framenumber)

function WW_registercompleteddocument(framenumber,cursize)	{ // Register Completed Documents

	WW_tangoboss.WW_completeddocumentsevent[WW_tangoboss.WW_numcompleteddocuments] = {};
	WW_tangoboss.WW_completeddocumentsevent[WW_tangoboss.WW_numcompleteddocuments].numelements = cursize;
	WW_tangoboss.WW_completeddocumentsevent[WW_tangoboss.WW_numcompleteddocuments].indicator = WW_tangoboss.WW_numeventindicators;
	WW_tangoboss.WW_registereventindicator(10,WW_tangoboss.WW_numcompleteddocuments,framenumber,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
	++WW_tangoboss.WW_numcompleteddocuments;
	return;
	
}	// End WW_registercompleteddocument(cursize)

// Count Frame Components
function WW_countframecomponents(framearg)	{

	var cursize = 0;
	if(!WW_isitawindow(framearg))
		return cursize;
	if(WW_isdefined(framearg.document.images))	{
		if(WW_isdefined(framearg.document.images.length))
			cursize += framearg.document.images.length;
	}
	if(WW_isdefined(framearg.document.layers))	{
		if(WW_isdefined(framearg.document.layers.length))
			cursize += framearg.document.layers.length;
	}
	if(WW_isdefined(framearg.document.links))	{
		if(WW_isdefined(framearg.document.links.length))
			cursize += framearg.document.links.length;
	}
	if(WW_isdefined(framearg.document.forms))	{
		if(WW_isdefined(framearg.document.forms.length))
			cursize += framearg.document.forms.length;
	}
	return cursize;

}	// End WW_countframecomponents(framearg)

function WW_registerunload(framenumber,grouplabel,seqno)	{ // Register onUnload events

	if(!WW_isitawindow(WW_tangoboss))
		return;
	if(WW_isundefined(WW_tangoboss.WW_onunloadevent))
		return;
	WW_tangoboss.WW_onunloadevent[WW_tangoboss.WW_numonunload] = {};
	WW_tangoboss.WW_onunloadevent[WW_tangoboss.WW_numonunload].indicator = WW_tangoboss.WW_numeventindicators;
	WW_tangoboss.WW_registereventindicator(1,WW_tangoboss.WW_numonunload,framenumber,grouplabel,seqno);
	++WW_tangoboss.WW_numonunload;
	WW_tangoboss.WW_setdebugline('Unload Frame ' + framenumber + ' from handler ' + seqno);
	return;
	
}	// End WW_registerunload(framenum,grouplabel,seqno)

function WW_setupevents()	{ // Set up Netscape Event Capturing in Current Window

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserWrite");
	window.enableExternalCapture();
	if( WW_tangoboss.WW_geteventmode == 0)	{
		if( WW_tangoboss.WW_capturelinkmouseoverout || WW_tangoboss.WW_captureallmouseoverout )	{
			window.captureEvents(Event.CLICK  | Event.CHANGE | Event.MOUSEOVER | Event. MOUSEOUT);
			window.onMouseOver = WW_mouseoverhandler;
			window.onMouseOut = WW_mouseouthandler;
		}
		else	{
			window.captureEvents(Event.CLICK  | Event.CHANGE );
		}
		window.onChange = WW_changehandler;
	}
	else	{
		window.captureEvents(Event.CLICK);
	}
	window.onClick = WW_clickhandler;

	return;

}	// End setupevents()

//	Set up Pointers to Indicate Possible Internally Generated Location Change
//	Submit Button or Link
function WW_setinternalgeneration(possibleurl)	{

	if(possibleurl != '' )	{
		var nonmasterstem = WW_geturlstem(WW_spawnedmainframeurl);
		WW_possiblegeneratedurl = WW_checkurl(nonmasterstem,possibleurl);
	}
	else	{
		WW_possiblegeneratedurl;
	}
	WW_generationcycle = WW_countcycles;
	return;
	
}	// End WW_setinternalgeneration(possibleurl)

//	Heuristic to indicate that detected change due to Captured Form or Link
function WW_wasitgenerated(wwevent)	{

	wwevent.infotype = 1;
	if( WW_generationcycle < 0 )
		return false;
	if( (WW_countcycles - WW_generationcycle) > 2 )	{
		WW_generationcycle = -1;
		return false;
	}
	wwevent.infotype = 6;
	return true;
	
}	// End	WW_wasitgenerated(wwevent)

function WW_clickhandler(e)	{	// Handle Click Events

	var messagewindow = WW_tangoboss;
	if(!WW_isitawindow(messagewindow))
		return true;
	WW_generationcycle = -1;
	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	if(WW_isundefined(e))
		return true;
	if(WW_isundefined(e.target))
		return true;
	var targetev = e.target;
	if( WW_tangoboss.WW_geteventmode != 0)	{
		if(WW_allowclicks)	{
			WW_tangoboss.WW_setjavaconsole('Allowed Click ' + targetev.toString());
			return routeEvent(e); }
		if(WW_isdefined(targetev.form))	{
			if(WW_tangoboss.WW_allowformclick)	{ // Form Click allowed Anyway
				messagewindow.WW_setstatusline('Click on Form Allowed');
				return routeEvent(e); }
			messagewindow.WW_setstatusline('Click on Form Ignored'); 
			return false; }
		if(WW_isdefined(targetev.href))	{
			if(WW_tangoboss.WW_allowurlclick)	{ // Link Click allowed Anyway
				messagewindow.WW_setstatusline('Click on Link Allowed');
				return routeEvent(e); }
			messagewindow.WW_setstatusline('Click on Hyperlink Ignored ' + targetev.href); 
			return false; }
		return true; }
	
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return false;
	var fromform = targetev.form;
	if(WW_isundefined(fromform))	{
		if(WW_tangoboss.WW_capturelinkclicks && WW_isdefined(targetev.href))	{ // Click on link
			return WW_linkhandler(e,0); }
		if( WW_tangoboss.WW_captureallclicks )	{ // Click on something
			return WW_linkhandler(e,10); }
		var retval = routeEvent(e);
		if (retval == false) 
			return false;
		return WW_tangoboss.WW_clicknottrapped; 
	}
	messagewindow.WW_setstatusline('Click Detected in form');
	recordit = new recordclick();
	
//	*** Identify Target Form if possible
	if(WW_identifyform(windowarg,targetev,fromform,recordit))	{
		messagewindow.WW_setstatusline('Click does not come from form');
		var retval = routeEvent(e);
		if (retval == false) 
			return false;
		return WW_tangoboss.WW_clicknottrapped;
	}

	var formeltype = targetev.type;
	messagewindow.WW_setstatusline(WW_spawnedmainframeurl + ': Click recorded form ' + recordit.formnumber + ' element ' + recordit.elementnumber + ' type ' + formeltype);
	if( formeltype == 'submit' )
		WW_setinternalgeneration(fromform.action);
	sendclick(recordit,WW_possiblegeneratedurl);
	var retval = routeEvent(e);
	if (retval == false) 
		return false;
	return WW_tangoboss.WW_clicktrapped;

}	// End WW_clickhandler(e)

//	Identify Form and store in recordit
//  Does not search layers
function WW_identifyform(windowarg,targetev,fromform,recordit)	{

	var numframes = windowarg.length;
	recordit.framecount = numframes;
	var framemax = Math.max(1,numframes);
	var problem = true;
	for(var frameloop=0; frameloop < framemax; ++frameloop)	{
		var startat = windowarg;
		if( numframes > 0 )
			startat = windowarg.frames[frameloop];
		var layermax = startat.document.layers.length;
		for(var layerloop = -1; layerloop < layermax; ++layerloop)	{
			var getitfrom = startat;
			if( layerloop >=0 )
				getitfrom = startat.document.layers[layerloop];
			docformslen = getitfrom.document.forms.length;
			for(var m=0;m<docformslen;m++)	{
				if( fromform == getitfrom.document.forms[m])	{
					problem =false;
					recordit.formnumber = m; 
					recordit.framenumber = frameloop;
					if( numframes == 0 )
						recordit.framenumber = -1;
					recordit.layernumber = layerloop;
					recordit.layercount = layermax;
					recordit.framecount = numframes;
					break; }
			}	// Loop over forms in document
			if(!problem)
				break;
		}	 // Loop over layers
		if(!problem)
			break;
	}	// Loop over frames or just main window
	if(problem)
		return true;
//	*** End identification of form

	var formlen = fromform.length;
	recordit.formlength = formlen;
	problem = true;
	for(var m=0;m<formlen;m++)  {
		if( targetev == fromform.elements[m] )	{
			problem =false;
			recordit.elementnumber=m; 
			break; }
	}
	return problem;

}	// End WW_identifyform(windowarg,targetev,fromform,recordit)

//	e is event and iev is 0 (link click) 6 (link mouseover) 7 (link mouseout) 10(other click) 8(other mouseover) 9(other mouseout)
// iev reset to 5 if href=javascript:void( .... and onclick handler
// iev reset to 4 if href=javascript: .... and onclick handler
// iev reset to 2 if href=javascript:void( .... and no onclick handler
// iev reset to 1 if href=javascript: .... and no onclick handler
// iev =0 reserved for case with no onclick handler and no javascript: in href
// iev =3 reserved for case with onclick handler but no javascript: in href
function WW_linkhandler(e,iev)	{ // Handle Event on a Link

	var messagewindow = WW_tangoboss;
	if(!WW_isitawindow(messagewindow))
		return true;
	WW_generationcycle = -1;
	var targetev = e.target;
	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	var mess = 'in a link';
	if(iev >=8)
		mess = 'Outside a link';
	messagewindow.WW_setstatusline(WW_eventlabel[iev] + ' Detected ' + mess);
	if( (iev == 6) || (iev==8) )	{	// MouseOver -- Ignore if no special handler
		if(WW_isundefined(targetev.onmouseover))
			return routeEvent(e);
	}
	if( (iev == 7) || (iev == 9) )	{	// MouseOut -- Ignore if no special handler
		if(WW_isundefined(targetev.onmouseout))
			return routeEvent(e);
	}
	if( iev == 10)	{ // Click not on link or form
		if(WW_isundefined(targetev.onclick))
			return routeEvent(e);
	}
	if( iev == 0 )	{	// Click on Link
		if(WW_isdefined(targetev.onclick))
			iev = 3;
	}
	recordit = new recordlink(iev);
	if(WW_isdefined(e.pageX))
		recordit.divxpos = e.pageX;
	if(WW_isdefined(e.pageY))
		recordit.divypos = e.pageY;
	if(WW_isdefined(targetev.href))	{	// href attribute is defined
		var temptext = targetev.href.toString();
		recordit.linkhref = temptext;
		if( iev <= 3 )	{ // Refine case of click on link
			if( temptext.length > 11 )	{ // Check if nonvoided or voided javascript
				if( (temptext.substring(0,11)).toLowerCase() == 'javascript:' )	{
					recordit.linktype = iev + 1;
					if( temptext.length > 16 )	{ // Check if voided javascript
						if( (temptext.substring(0,16)).toLowerCase() == 'javascript:void(' )
							recordit.linktype = iev + 1;
					}
				}
			}
		}
	}	// End case where href defined
	else	{ // No href attribute
		if( iev == 0 )	{ // No href and onclick
			return routeEvent(e);
		}
	}
	if(WW_isdefined(targetev.text))
		recordit.linktext = targetev.text.toString();
	
//	*** Identify Target link as recorded by event target if possible
	var linktype = recordit.linktype;
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return false;
	if(WW_identifylink(windowarg,targetev,recordit))	{
		messagewindow.WW_setstatusline(WW_eventlabel[linktype] + ' does not come from link or layer');
		var retval = routeEvent(e);
		if (retval == false) 
			return false;
		if( (linktype < 6)||(linktype==10) )	{
			return WW_tangoboss.WW_clicknottrapped; }
		else	{
			return WW_tangoboss.WW_clicktrapped; }
	}
	var detailedmess = 'from link' + recordit.linknumber;
	if(linktype >= 8)
		detailedmess = 'outside link';
	messagewindow.WW_setstatusline(WW_spawnedmainframeurl + ':' + WW_eventlabel[linktype] + ' recorded ' + detailedmess);
	sendlink(recordit);
	var retval = routeEvent(e);
	if (retval == false) 
		return false;
	if( (linktype < 6) || (linktype==10) )	{
		return WW_tangoboss.WW_clicknottrapped; }
	else	{
		return WW_tangoboss.WW_clicktrapped; }
	
}	// End WW_linkhandler(e,iev)

function WW_mouseoverhandler(e)	{	// Handle Mouse Over Events in Links

	if(WW_isundefined(e))
		return true;
	if(WW_isundefined(e.target))
		return true;
	var targetev = e.target;
	if(WW_tangoboss.WW_capturelinkmouseoverout && WW_isdefined(targetev.href))	{ // Link
		return WW_linkhandler(e,6); }
	if(WW_tangoboss.WW_captureallmouseoverout)
		return WW_linkhandler(e,8);
	return routeEvent(e);

}	// End WW_mouseoverhandler(e)

function WW_mouseouthandler(e)	{	// Handle Mouse Out Events in Links

	if(WW_isundefined(e))
		return true;
	if(WW_isundefined(e.target))
		return true;
	var targetev = e.target;
	if(WW_tangoboss.WW_capturelinkmouseoverout && WW_isdefined(targetev.href))	{ // Link
		return WW_linkhandler(e,7); }
	if(WW_tangoboss.WW_captureallmouseoverout)
		return WW_linkhandler(e,9);
	return routeEvent(e);

}	// End WW_mouseouthandler(e)

//	Identify link and store in recordit
function WW_identifylink(windowarg,targetev,recordit)	{

	var numframes = windowarg.length;
	recordit.framecount = numframes;
	var framemax = Math.max(1,numframes);
	var problem = true;
	var layerlevel = -1;
	for(var frameloop=0; frameloop < framemax; ++frameloop)	{
		var startat = windowarg;
		if( numframes > 0 )
			startat = windowarg.frames[frameloop];
		if((layerlevel = WW_recurselayer(recordit,0,targetev,startat)) > 0 )	{
			problem =false;
			recordit.layerlevel = layerlevel;
			recordit.framenumber = frameloop;
			if( numframes == 0 )
				recordit.framenumber = -1;
			recordit.framecount = numframes;
			break; }
	}	// Loop over frames or just main window
//	*** End identification of link

	return problem; // true implies failed to find

}	// End WW_identifylink(windowarg,targetev,recordit)

function WW_recurselayer(recordit,layerlevel,targetev,layerroot)	{

	if(recordit.linknumber < 0 )	{ // Not a link but a layer
		if( targetev == layerroot )
			return 1;
	}
	else	{
		doclinkslen = layerroot.document.links.length;
		for(var m=0;m<doclinkslen;m++)	{
			if( targetev == layerroot.document.links[m])	{
				recordit.linknumber = m;
				recordit.linkcount = doclinkslen;
				return 1;
			}
		}	// Loop over links in layer
	}
	var newroot= layerroot.document.layers;
	if(WW_isundefined(newroot))
		return 0;
	var layermax = newroot.length;
	if(layermax <= 0)
		return 0;
	for(var layerloop = 0;layerloop < layermax; layerloop++)	{
		var result = WW_recurselayer(recordit,layerlevel+1,targetev,newroot[layerloop]);
		if( result == 0 )
			continue;
		recordit.layernumber[layerlevel] = layerloop;
		recordit.layercount[layerlevel] = layermax;
		recordit.layername[layerlevel] = newroot[layerloop].name;
		return (result+1);
	}
	return 0;
	
}	// End WW_recurselayer(recordit,layerlevel,targetev,layerroot)

function WW_changehandler(e)	{

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	WW_generationcycle = -1;
	if(WW_isundefined(e.target))
		return false;
	var messagewindow = WW_tangoboss;
	if(!WW_isitawindow(messagewindow))
		return false;
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return false;
	var targetev = e.target;
	var fromform = targetev.form;
	if(WW_isundefined(fromform))	{
		var retval = routeEvent(e);
		if (retval == false) 
			return false;
		return WW_tangoboss.WW_changenotform;
	}
	recordit = new recordchange();
	
//	*** Identify Target Form if possible
	if(WW_identifyform(windowarg,targetev,fromform,recordit))	{
		messagewindow.WW_setstatusline('Change does not come from form ');
		var retval = routeEvent(e);
		if (retval == false) 
			return false;
		return WW_tangoboss.WW_changenotform;
	}

	var eltype = targetev.type;
	if( (eltype == 'select-one') || (eltype == 'select-multiple') )	{
		if( eltype == 'select-multiple' )	{
			recordit.type = 'multichange';
			var num =0;
			recordit.selectedindexarray = new Array();
			for( var m=0; m < targetev.options.length; m++)	{
				if(targetev.options[m].selected)	{
					recordit.selectedindexarray[num] = m;
					num++; }
			}
			recordit.numchanged = num;
			messagewindow.WW_setstatusline(WW_spawnedmainframeurl + ':' +  eltype + ' Change recorded form ' + recordit.formnumber + ' element ' + recordit.elementnumber + ' num selected ' + num);
		}
		if( eltype == 'select-one' )	{
			recordit.selectedindex = targetev.selectedIndex;
			messagewindow.WW_setstatusline(WW_spawnedmainframeurl + ':' +  eltype + ' Change recorded form ' + recordit.formnumber + ' element ' + recordit.elementnumber + ' selected index ' + recordit.selectedindex);
		}
	}
	else	{
		if( (eltype == 'password') || (eltype == 'file') || (eltype == 'text') || (eltype == 'textarea') || (eltype == 'hidden') )	{
			recordit.text = targetev.value;
			messagewindow.WW_setstatusline(WW_spawnedmainframeurl + ':' +  eltype + ' Change recorded form ' + recordit.formnumber + ' element ' + recordit.elementnumber + 'Text')
		}
		else	{
			messagewindow.WW_setstatusline('Unsupported Form Type change ignored ' + WW_spawnedmainframeurl + ':' +  eltype + ' Change noted in form ' + recordit.formnumber + ' element ' + recordit.elementnumber);
			var retval = routeEvent(e);
			if (retval == false) 
				return false;
			return WW_tangoboss.WW_changeform;
		}
	}
	sendchange(recordit);
	var retval = routeEvent(e);
	if (retval == false) 
		return false;
	return WW_tangoboss.WW_changeform;

}	// End WW_changehandler(e)

function WW_setclick(recordit)	{ // Set Form Click returning true if legal

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return false;
	var messagewindow = WW_tangoboss;
	if(!WW_isitawindow(messagewindow))
		return false;
	curformobject = WW_getchildformhandle(windowarg,messagewindow,recordit);
	if( curformobject == null )
		return false;
	messagewindow.WW_setstatusline('Click implemented form ' + recordit.formnumber + ' element ' + recordit.elementnumber);
	var clickedel = curformobject.elements[recordit.elementnumber];
	var formeltype = clickedel.type;
	WW_tangoboss.WW_settempjavaconsole(' Click implemented form ' + recordit.formnumber + ' element ' + recordit.elementnumber + ' ' + clickedel.value);
	if( formeltype == 'submit' )	{
		var actionurl = curformobject.action;
		var nonmasterstem = WW_geturlstem(WW_spawnedmainframeurl);
		var newWW_spawnedmainframeurl = WW_checkurl(nonmasterstem,actionurl);
		WW_spawnedmainframeurl = newWW_spawnedmainframeurl;
		WW_tangoboss.WW_setjavaconsole(' Set Client URL to: ' + WW_spawnedmainframeurl);
		WW_inputexpectedurl = newWW_spawnedmainframeurl;
		WW_expectedurlmemory = -WW_tangoboss.WW_waitforformtoact;
	}
	WW_allowclicks = true;
	clickedel.click();
	return true;

}	// End 	WW_setclick(recordit)

//	Analyse received event and find object handle of form it is addressing
//	Return null if form is inconsistent
function WW_getchildformhandle(windowarg,messagewindow,recordit)	{

	var framenum = recordit.framecount;
	if( framenum != windowarg.length )	{
		 messagewindow.WW_setstatusline('Illegal Frame Count in FormEvent ' +  framenum + ' Actual ' + windowarg.length);
		 return null;
	}
	var getitfrom = windowarg;
	if( recordit.framecount != 0 )
		getitfrom = windowarg.frames[recordit.framenumber];
	
	var layernum = recordit.layernumber;
	if( layernum >= 0 )	{	// In a layer;
		var actuallayercount = getitfrom.document.layers.length;
		if( actuallayercount != recordit.layercount )	{
			messagewindow.WW_setstatusline('Frame ' + framenum + ' Illegal Layer Count in FormEvent ' +  recordit.layercount + ' Actual ' + actuallayercount);
			return null;
		}
		getitfrom = getitfrom.document.layers[layernum];
	}
	var docformslen = getitfrom.document.forms.length;
	var curformnum = recordit.formnumber;
	if( curformnum >= docformslen )	{
		 messagewindow.WW_setstatusline('Illegal Form Number ' +  curformnum + ' From ' + docformslen);
		return null; }
	var curlen = recordit.formlength;
	var curformobject = getitfrom.document.forms[curformnum];
	if( curlen != curformobject.length)	{
		messagewindow.WW_setstatusline('Frame ' + framenum + ' Layer' + layernum + ' Illegal Form ' + curformnum + ' Lengths ' + curlen + ' and ' + curformobject.length);
		return null; }
	return curformobject;

}	// End WW_getchildformhandle(windowarg,messagewindow,recordit)

function WW_setelementvalue(recordit)	{ // Set Form Element Value, returning true if legal

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return false;
	var messagewindow = WW_tangoboss;
	if(!WW_isitawindow(messagewindow))
		return false;

	curformobject = WW_getchildformhandle(windowarg,messagewindow,recordit);
	if( curformobject == null )
		return false;
	var curelementnumber = recordit.elementnumber;
	var eltype = curformobject.elements[curelementnumber].type;
	if( recordit.type == 'multichange' )	{
		var num = recordit.numchanged;
		var numinform = curformobject.elements[curelementnumber].options.length;
		for( var m=0; m< numinform; m++)	{
			curformobject.elements[curelementnumber].options[m].selected = false; }
		for( var m=0; m< num; m++)	{
			curformobject.elements[curelementnumber].options[recordit.selectedindexarray[m]].selected = true;
}
		messagewindow.WW_setstatusline(eltype + ' Change implemented form ' + recordit.formnumber + ' element ' + curelementnumber + ' num changed ' + num);
		WW_tangoboss.WW_settempjavaconsole(eltype + ' Change implemented form ' + recordit.formnumber + ' element ' + curelementnumber + ' num changed ' + num);
		return true;
	}
	if( recordit.type == 'checked' )	{
		curformobject.elements[curelementnumber].checked = recordit.checkedvalue;
		messagewindow.WW_setstatusline(eltype + ' Value Set for form ' + recordit.formnumber + ' element ' + curelementnumber + ' ' + recordit.checkedvalue);
		WW_tangoboss.WW_settempjavaconsole(eltype + ' Value Set for form ' + recordit.formnumber + ' element ' + curelementnumber + ' ' + recordit.checkedvalue);
	}
	else	{
		if( WW_isdefined(recordit.selectedindex) )	{
			curformobject.elements[curelementnumber].selectedIndex = recordit.selectedindex;
			messagewindow.WW_setstatusline(eltype + ' Change implemented form ' + recordit.formnumber + ' element ' + curelementnumber + ' selected index ' + recordit.selectedindex);
			WW_tangoboss.WW_settempjavaconsole(eltype + ' Change implemented form ' + recordit.formnumber + ' element ' + curelementnumber + ' selected index ' + recordit.selectedindex);
		}
		else	{
			if( eltype == 'file' )	{
			netscape.security.PrivilegeManager.enablePrivilege( "UniversalFileRead"); }
			curformobject.elements[curelementnumber].value = recordit.text;
			messagewindow.WW_setstatusline(eltype + ' Change implemented form ' + recordit.formnumber + ' element ' + curelementnumber + ' Text');
			WW_tangoboss.WW_settempjavaconsole(eltype + ' Change implemented form ' + recordit.formnumber + ' element ' + curelementnumber + ' Text');
		}
	}
	return true;

}	// End WW_setelementvalue(recordit)

function WW_saveforms(wwevent)	{ // Save All Forms in a Page
// button reset submit Ignored as only used to generate clicks
// file hidden password text textarea  saved as text string which is value attribute in same way whether
// invoked by event capture or save form request
// checkbox and radio record true/false checked value (note these generate click events  and in this
// mode one changes checked status indirectly via invocation ofclick() method in WW_setclick(recordit))
// select-multiple and select-one record selected indices in same way whether
// invoked by event cpature or save form request

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	wwevent.currenturl = WW_spawnedmainframeurl;
	var windowarg = window.WWsignedchild;
        if(!WW_isitawindow(windowarg))
                return false;
	var messagewindow = WW_tangoboss;
	if(!WW_isitawindow(messagewindow))
		return false;
	var docformslen = 0;
	var framecount = windowarg.length;
	for(var framenumber= -1; framenumber < framecount; framenumber++)	{
		var startat = windowarg;
		if( framecount > 0 )	{
			if( framenumber == -1)
				continue;
			startat = windowarg.frames[framenumber];
		}
		docformslen += startat.document.forms.length;
		var layercount = startat.document.layers.length;
		for(var layernumber=0; layernumber < layercount; layernumber++)	{
			var getitfrom = startat;
			if( layernumber >= 0 )
				getitfrom = startat.document.layers[layernumber];
			docformslen += getitfrom.document.forms.length;
		}	// End loop over layers in a frame
	}	// End loop over frames or main window
	if( docformslen <= 0)
		return false;

	wwevent.formcount = docformslen;
	wwevent.formnumber = -1;
	wwevent.arraysize = docformslen;
	wwevent.arrayitself = new Array();
	var runthroughform =0;
	for(var framenumber= -1; framenumber < framecount; framenumber++)	{
		var startat = windowarg;
		if( framecount > 0 )	{
			if( framenumber == -1)
				continue;
			startat = windowarg.frames[framenumber];
		}
		var layercount = startat.document.layers.length;
		for(var layernumber= -1; layernumber < layercount; layernumber++)	{
			var getitfrom = startat;
			if( layernumber >= 0 )
				getitfrom = startat.document.layers[layernumber];
			var formsarray = getitfrom.document.forms;
			var localformslen = formsarray.length;
			if(localformslen == 0 )
				continue;
			for(var iform=0; iform < localformslen; iform++)	{
				wwevent.arrayitself[runthroughform] = new WW_childevent('form');
				WW_savesingleform(wwevent.arrayitself[runthroughform],framecount,framenumber,layercount,layernumber,formsarray[iform],iform);
				++runthroughform;
			}	// End loop over forms in a layer/document
		}	// End loop over layers in a frame
	}	// End loop over frames or main window
	return true;

}	// End WW_saveforms(wwevent)

function WW_savesingleform(wwevent,framecount,framenumber,layercount,layernumber,formobject,iform)	{
// Save form iform contained in formobject storing in wwevent

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	wwevent.framenumber = framenumber;
	wwevent.framecount = framecount;
	wwevent.layernumber = layernumber;
	wwevent.layercount = layercount;
	wwevent.formnumber = iform;
	var numelements = formobject.length;
	wwevent.formlength = numelements;
	wwevent.arrayitself = new Array();
	var ctarray =0;
        for(var n=0; n<numelements; n++)   {
                var elobject = formobject.elements[n];
		var eltype = elobject.type;
		var elindex = WW_elementcategory(eltype);
		if(elindex <=1 )
			continue;
		wwevent.arrayitself[ctarray] = new WW_childevent(WW_elementcategoryname[elindex]);
		WW_savesingleformelement(wwevent.arrayitself[ctarray],elobject);
		wwevent.arrayitself[ctarray].elementnumber = n;
		wwevent.arrayitself[ctarray].formlength = numelements;
		wwevent.arrayitself[ctarray].formnumber = iform;
		wwevent.arrayitself[ctarray].framenumber = framenumber;
		wwevent.arrayitself[ctarray].framecount = framecount;
		wwevent.arrayitself[ctarray].layernumber = layernumber;
		wwevent.arrayitself[ctarray].layercount = layercount;
		++ctarray;
	}
	wwevent.arraysize = ctarray;
	return true;

}	// End WW_savesingleform(wwevent,formobject,iform)

function WW_savesingleformelement(wwevent,elobject,elnumber)	{
// Save form element defined by object elobject in wwevent

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	var eltype = elobject.type;
	var elindex = WW_elementcategory(eltype);
	if(elindex <=1 )
		return false;
	wwevent.formelementtype = eltype;
	if( elindex == 2 )	{
		wwevent.formtext = elobject.value;
		return true; }
	if( elindex == 5 )	{
		wwevent.formelementchecked = elobject.checked;
		return true; }
	if( elindex == 3 )	{
		wwevent.selectedindex = elobject.selectedIndex;
		return true; }
	if( elindex == 4 )	{
		var num =0;
		wwevent.arrayitself = new Array();
		for( var m=0; m < elobject.options.length; m++)	{
			if(elobject.options[m].selected)	{
				wwevent.arrayitself[num] = new WW_childevent(WW_elementcategoryname[elindex]);
				wwevent.arrayitself[num].selectedindex = m;
				num++; }
		}
		wwevent.arraysize = num;
	}
	return true;

}	// End WW_savesingleformelement(wwevent,elobject,elnumber)

function WW_elementcategory(eltype)	{
// Find category of element type

	if( (eltype=='button')||(eltype=='reset')||(eltype=='submit') )
		return 1;
	if( (eltype=='file')||(eltype=='hidden')||(eltype=='password')||(eltype=='text')||(eltype=='textarea') )
		return 2;
	if( (eltype=='select-one') )
		return 3;
	if( (eltype=='select-multiple') )
		return 4;
	if( (eltype=='checkbox')||(eltype=='radio') )
		return 5;
	return 0;

}	// End WW_elementcategory(eltype)

WW_elementcategoryname = new Array('unknown','ignore','formtextchange','formsinglelistchange','formmultilistchange','formchecked');

function WW_interpretlinkevents(wwevent)	{
// Interpret events defining link or layer (click, mouseover, mouseout) events
// return false if some error, true if legal

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	if( WW_isundefined(wwevent.type))
		return false;
	var evtype = wwevent.type;
	if( evtype.indexOf('link') < 0 )
		return false;
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return false;
	var messagewindow = WW_tangoboss;
	if(!WW_isitawindow(messagewindow))
		return false;
	curlinkobject = WW_getchildlinkhandle(windowarg,messagewindow,wwevent);
	if( curlinkobject == null )
		return false;

	var linktype = wwevent.linktype;
	messagewindow.WW_setstatusline('Link # ' + wwevent.linknumber + ' type ' + WW_eventlabel[linktype]);
	WW_tangoboss.WW_settempjavaconsole(' Link # ' + wwevent.linknumber + ' type ' + WW_eventlabel[linktype]);
	var locale= {};
	if( linktype > 2 )	{
		locale.pageX = wwevent.divxpos;
		locale.pageY = wwevent.divypos;
		locale.target = curlinkobject; }
	if( (linktype == 6)||(linktype==8) ) { // Mouseover
		if(WW_isdefined(curlinkobject.onmouseover))	{
			locale.type = 'mouseover';
			curlinkobject.onmouseover(locale); }
		else	{
			messagewindow.WW_setdebugline('Missing onmouseover event handler'); }
		return true;
	}	// End mouseover
	if( (linktype == 7)||(linktype==9) ) { // Mouseout
		if(WW_isdefined(curlinkobject.onmouseout))	{
			locale.type = 'mouseout';
			curlinkobject.onmouseout(locale); }
		else	{
			messagewindow.WW_setdebugline('Missing onmouseout event handler'); }
		return true;
	}	// End mouseout

//	onclick -- assume only voided javascript in href relevant
// Any other href actions assumed to correspond to detected URL changes
	if(linktype == 0)
		return true;
	if(linktype > 2 )	{
		if(WW_isdefined(curlinkobject.onclick))	{
			locale.type = 'click';
			if(!curlinkobject.onclick(locale))
				return true; } // if onclick returns false, NEVER look at href
		else	{
			messagewindow.WW_setdebugline('Missing onclick event handler'); }
		if( (linktype == 3)||(linktype==10) )
			return true;
	}
	
	temptext = wwevent.linkhref;
	if(WW_isundefined(temptext))
		return false;
	if( (temptext.substring(0,11)).toLowerCase() != 'javascript:')
		return false;
	temptext = temptext.substring(11);
	messagewindow.WW_setdebugline(temptext);
	windowarg.location.href = wwevent.linkhref;
	return true;
	
}	// End WW_interpretlinkevents(wwevent)

//	Analyse received event and find object handle of link it is addressing
//	Return null if link is inconsistent
function WW_getchildlinkhandle(windowarg,messagewindow,receivedevent)	{

	var framenum = receivedevent.framecount;
	if( framenum != windowarg.length )	{
		 messagewindow.WW_setstatusline('Illegal Frame Count in Link/Layer Event ' +  framenum + ' Actual ' + windowarg.length);
		 return null;
	}
	var getitfrom = windowarg;
	if( receivedevent.framecount != 0 )
		getitfrom = windowarg.frames[receivedevent.framenumber];
	
	var layerlevel = receivedevent.layerlevel;
	var curlen = receivedevent.linkcount;
	if( layerlevel > 1 )	{
		var eventarray = receivedevent.arrayitself;
		for(var m=0;m<(layerlevel-1);m++)	{
			var layercount = eventarray[m].layercount;
			var actuallayercount = getitfrom.document.layers.length;
			if( WW_isundefined(actuallayercount) ||(actuallayercount != layercount) )	{
				messagewindow.WW_setstatusline('Frame ' + framenum + ' Layer Level ' + m + ' Illegal Layer Count in Link/Layer Event ' +  receivedevent.layercount + ' Actual ' + actuallayercount);
				return null;
			}
			var layernum = eventarray[m].layernumber; // Layer Numbers are not guaranteed to be same
			var layername = eventarray[m].layername; // Layer names are same if specified by user
			var layerpos1 = -1;
			var layerpos2 = -1;
			for(var n=0; n < layercount; n++)	{
				var possibility = getitfrom.document.layers[n];
				if(layername != '' )	{	// Name is first choice
					if(WW_isdefined(possibility.name) && (possibility.name == layername))	{
						layerpos1 = n;
						break; }
				}
				if( m == (layerlevel-2) )	{ // Last Layer
					var possiblelinkcount = possibility.document.links.length;
					if( possiblelinkcount == curlen )	{
						if(layerpos2 == -1 )	{ // Needs to be Unique Match to Link Count
							layerpos2 = n; }
						else	{
							layerpos2 = -2; }
					}
				}
				else	{ // Inner Layer -- Match to next level layer count
					var possiblelayercount = possibility.document.layers.length;
					if( possiblelayercount == eventarray[m+1].layercount)	{
						if(layerpos2 == -1 )	{ // Needs to be Unique Match to Layer Count
							layerpos2 = n; }
						else	{
							layerpos2 = -2; }
					}
				}
			}
			if( layerpos2 >= 0 )
				layernum = layerpos2;
			if( layerpos1 >= 0 )
				layernum = layerpos1;
			getitfrom = getitfrom.document.layers[layernum];
		}
	}
	var curlinknum = receivedevent.linknumber;
	if( curlinknum < 0 )
		return getitfrom;
	var doclinkslen = getitfrom.document.links.length;
	if( curlinknum >= doclinkslen )	{
		 messagewindow.WW_setstatusline('Illegal link Number ' +  curlinknum + ' Out of ' + doclinkslen + ' Links in Layer ' + getitfrom.name + ' at level ' + layerlevel);
		return null; }

	var curlinkobject = getitfrom.document.links[curlinknum];
	if( curlen != doclinkslen)	{
		messagewindow.WW_setstatusline('Frame ' + framenum + ' Layer' + layernum + ' Illegal link ' + curlinknum + ' Lengths ' + curlen + ' and ' + doclinkslen);
		return null; }
	return curlinkobject;

}	// End WW_getchildlinkhandle(windowarg,messagewindow,receivedevent)

function WW_interpretscrollevents(wwevent)	{
// Interpret events defining scroll events
//	Return true if set correctly, false otherwise

	if( WW_isundefined(wwevent.type))
		return false;
	var evtype = wwevent.type;
	if( evtype.indexOf('scroll') < 0 )
		return false;
	temppageinfo = new pageinfo();
	if(WW_isdefined(wwevent.xscroll))
		temppageinfo.xscroll = wwevent.xscroll;
	if(WW_isdefined(wwevent.yscroll))
		temppageinfo.yscroll = wwevent.yscroll;
	if(WW_isundefined(wwevent.arraysize))
		return WW_setscrolling(temppageinfo);
	var num = wwevent.arraysize;
	if( num <= 1 )
		return WW_setscrolling(temppageinfo);
	temppageinfo.childnum = num;
	for( var m =0; m < num; m++)	{
		var tempxy = 0;
		if(WW_isdefined(wwevent.arrayitself[m].xscroll));
			tempxy = wwevent.arrayitself[m].xscroll;
		temppageinfo.framexscroll[m] = tempxy;
		tempxy = 0;
		if(WW_isdefined(wwevent.arrayitself[m].yscroll));
			tempxy = wwevent.arrayitself[m].yscroll;	
		temppageinfo.frameyscroll[m] = tempxy;
	}
	return WW_setscrolling(tempageinfo);

}	// End WW_interpretscrollevents(wwevent)

function WW_setscrolling(pageinfo)	{ // Interpret Scrolling in framed Data Structure

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return false;
	if(pageinfo.childnum <= 1)	{	// No Frames
		if( WW_spawnedmainframepageinfo.childnum > 1 )
			return false;
		var oldx = WW_spawnedmainframepageinfo.xscroll;
		var newx = pageinfo.xscroll;
		var oldy = WW_spawnedmainframepageinfo.yscroll;
		var newy = pageinfo.yscroll;
		if( (oldx != newx) || (oldy != newy) )
			windowarg.scrollTo(newx,newy);
		return true;
	}
//	Code for case with frames
	if( WW_spawnedmainframepageinfo.childnum != pageinfo.childnum )
		return false;
	for(var m=0; m < pageinfo.childnum; m++ )     {
		var frameitself = windowarg.frames[m];
		if(!WW_isitawindow(frameitself))
			return false;
		var oldx = WW_spawnedmainframepageinfo.framexscroll[m];
		var newx = pageinfo.framexscroll[m];
		var oldy = WW_spawnedmainframepageinfo.frameyscroll[m];
		var newy =  pageinfo.frameyscroll[m];
		if( (oldx != newx) || (oldy != newy) )
			frameitself.scrollTo(newx,newy);
	}
	return true;

}	// End WW_setscrolling(pageinfo)
	

// Exported Functions *****************************************************
function WW_interpretformevents(wwevent,iotype)	{
// Interpret events holding one or more forms invoking WW_interpretformelements(wwevent) 
// to interpret actual form elements
// Return true if no errors, false if errors
// iotype = 1 called from event stream
// iotype = 2 called from user click on event

	if( WW_isundefined(wwevent.type))
		return false;
	var evtype = wwevent.type;
	if( evtype.indexOf('form') < 0 )
		return false;
	if( evtype != 'form' )	{ // Just a form element
		if( (iotype==1) && (!WW_tangoboss.WW_acceptformsnippets) )
			return true;
		return WW_interpretformelements(wwevent);
	}
	if( iotype==1 )	{ // events from Stream
		WW_tangoboss.WW_acceptformsnippets = true;
		if( !WW_tangoboss.WW_acceptmasterforms )	{
			WW_tangoboss.WW_startbarmessage("Full Form Update Ignored",10);
			return true; } // Ignore stream events if WW_acceptmasterforms false
		WW_tangoboss.WW_startbarmessage("Full Form Update Implemented",10);
	}
	
//	Interpret complex event holding one or more forms
	var flag = wwevent.formnumber;
	if( flag >= 0 )	{ // Interpret Single Form
		return WW_interpretsingleform(wwevent);
	}
	if(WW_isundefined(wwevent.arraysize))
		return false;
	if(WW_isundefined(wwevent.arrayitself))
		return false;
	var formct = wwevent.arraysize;
	var success = true;
	for(var m=0; m<formct; m++)	{
		if(!WW_interpretsingleform(wwevent.arrayitself[m]))	{
			WW_tangoboss.WW_seterrorline('Error in Form ' + m);
			success = false; }
	}
	return success;

}	// End WW_interpretformevents(wwevent)

function WW_interpretsingleform(wwevent)	{
// Interpret Single Form returning true if success

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");
	if( WW_isundefined(wwevent.type))
		return false;
	var evtype = wwevent.type;
	if( evtype != 'form' )	
		return false;
	var windowarg = window.WWsignedchild;
	if(!WW_isitawindow(windowarg))
		return false;
	var messagewindow = WW_tangoboss;
	if(!WW_isitawindow(messagewindow))
		return false;
	if( WW_getchildformhandle(windowarg,messagewindow,wwevent) == null )	{
		WW_tangoboss.WW_seterrorline('Unable to get handle to this form');
		return false; }
	if(WW_isundefined(wwevent.arraysize))
		return true;
	var numsaved = wwevent.arraysize;
	if(numsaved <= 0)
		return true;
	if(WW_isundefined(wwevent.arrayitself))
		return false;
	var success = true;
	for(var n=0; n<numsaved; n++)	{
		if( !WW_interpretformelements(wwevent.arrayitself[n]))	{
			WW_tangoboss.WW_seterrorline('Error in Form Element ' + n);
			success = false; }
	}
	return success;

}	// End WW_interpretsingleform(wwevent)

function WW_interpretformelements(wwevent)	{
// Interpret events holding a single form element

	var typeflag = wwevent.type;
	var intflag = 1;
	if( typeflag == 'formtextchange' )
		intflag = 2;
	if( typeflag == 'formsinglelistchange' )
		intflag = 3;
	if( typeflag == 'formmultilistchange' )
		intflag = 4;
	if( typeflag == 'formchecked' )
		intflag = 5;
	if( intflag == 1 )	{
		recordit = new recordclick(); }
	if( (intflag == 2)||(intflag == 3) )
		recordit = new recordchange(); 
	if( intflag == 4 )
		recordit = new recordmultichange();
	if( intflag == 5 )
		recordit = new recordchecked();
	recordit.formnumber = wwevent.formnumber;
	recordit.formlength =  wwevent.formlength;
	recordit.framenumber =  wwevent.framenumber;
	recordit.framecount =  wwevent.framecount;
	recordit.layernumber =  wwevent.layernumber;
	recordit.layercount =  wwevent.layercount;
	recordit.elementnumber = wwevent.elementnumber;
	if( intflag == 2 )
		recordit.text = wwevent.formtext;
	if( intflag == 3 )
		recordit.selectedindex = wwevent.selectedindex;
	if( intflag == 4 )	{
		recordit.numchanged = wwevent.arraysize;
		for(var m=0; m <wwevent.arraysize; m++)	{
			recordit.selectedindexarray[m] = wwevent.arrayitself[m].selectedindex; }
	}
	if( intflag == 5 )
		recordit.checkedvalue = wwevent.formelementchecked;
	if(recordit.type == 'click' )	{
		return WW_setclick(recordit); }
	else	{
		return WW_setelementvalue(recordit); }

}	// End WW_interpretformelements(wwevent)

function WW_signedcopyhistory(choosepart)	{ // Copy data from Header of History Page
// choosepart =1 Favorites =2 Events but not Favorites = 3 Configurations Only

	localhistoryparent = WW_tangoboss.WW_historyparent;
	if(!WW_isitawindow(localhistoryparent))
		return;
	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess");

//	Unpack Configurations
	if( choosepart==3 )	{
		var configform = localhistoryparent.document.forms['configurations'];
		if(WW_isundefined(configform))
			return;
		var configformsize = configform.length;
		var newlen = WW_tangoboss.WW_numconfigs;
		var newpref = -1;
		for( var m=1; m < configformsize; m+=5)	{
			var pack1 = configform.elements[m].value;
			var pack2 = configform.elements[m+1].value;
			var pack3 = configform.elements[m+2].value;
			var pack4 = configform.elements[m+3].value;
			var pack5 = configform.elements[m+4].value;
			WW_testoneventtarget = false;
			var wwevent = new WW_basicevent();
			WW_getevent(pack1,wwevent);
			var match = false;
			for(var mm = 0;mm< newlen; mm++)	{
				if(WW_tangoboss.WW_configarray[mm].username == wwevent.username)	{
					match = true;
					break;
				}
			}
			if( match )
				continue;
			WW_tangoboss.WW_configarray[newlen] = new WW_tangoboss.WW_createconfig(newlen, '');
			WW_tangoboss.WW_configarray[newlen].currenturl = wwevent.currenturl;
			WW_tangoboss.WW_configarray[newlen].username = wwevent.username;
			WW_tangoboss.WW_configarray[newlen].configtype = wwevent.configtype; 
			WW_tangoboss.WW_configarray[newlen].preferred = wwevent.preferred;
			WW_tangoboss.WW_configarray[newlen].masteroption = wwevent.masteroption;
			WW_testoneventtarget = true;
			WW_tangoboss.WW_configarray[newlen].packedfav = pack2;
			WW_tangoboss.WW_configarray[newlen].packedww1 = pack3;
			WW_tangoboss.WW_configarray[newlen].packedww2 = pack4;
			WW_tangoboss.WW_configarray[newlen].packedww3 = pack5;
			if( wwevent.preferred )
				newpref = newlen;
			++newlen;
		}
		WW_tangoboss.WW_numconfigs = newlen;
		if( newpref < 0 )
			return;
		WW_tangoboss.WW_selectedconfig = newpref;
		WW_tangoboss.WW_switchtoconfiguration();
		return;
	}
	
// Unpack Favorites from Major Events
	var majorform = localhistoryparent.document.forms['majorevents'];
	if(WW_isundefined(majorform))
		return;
	var majorformsize = majorform.length;
	for(var m=2; m < majorformsize; m++)	{
		var elname = majorform.elements[m].name;
		if( choosepart==1 )	{
			if(elname.substring(0,3) == 'url' )
				WW_tangoboss.WW_updatefavorites(unescape(majorform.elements[m].value));
			continue;
		}
	}
	if( choosepart==1 )
		return;

// Unpack Events
	var minorform = localhistoryparent.document.forms['minorevents'];
	var firstmajor = parseInt(majorform.elements[0].value);
	var majorchange = WW_tangoboss.WW_numberurl+1-firstmajor; // Change in major event numbering
	
// Load major events into WW_tangoboss.WW_majorevent array
	var loadthis = WW_tangoboss.WW_numberurl+1;
	var initialmajorevent = loadthis;
	for(var m=2; m < majorformsize; m++)	{
		var elname = majorform.elements[m].name;
		var elvalue = majorform.elements[m].value;
		if(elname.substring(0,10) == 'majorevent' )	{
			loadthis = parseInt(elvalue)+majorchange;
			WW_tangoboss.WW_majorevent[loadthis-1] = {};
			WW_tangoboss.WW_majorevent[loadthis-1].indicator = -1;
			continue; }
		if(elname.substring(0,3) == 'url' )	{
			WW_tangoboss.WW_majorevent[loadthis-1].url = unescape(elvalue);
			continue; }
		if(elname.substring(0,5) == 'label' )	{
			WW_tangoboss.WW_majorevent[loadthis-1].label = unescape(elvalue);
			continue; }
		if(elname.substring(0,9) == 'thumbnail' )	{
			WW_tangoboss.WW_majorevent[loadthis-1].thumbnail = WW_tangoboss.WW_unpackthumbnail(elvalue);
			continue; }
		if(elname.substring(0,10) == 'minorevent' )	{
			WW_tangoboss.WW_majorevent[loadthis-1].associatedevent = parseInt(elvalue);
			continue; }
	}	// End major event form data
	WW_tangoboss.WW_numberurl = loadthis;

// Load minor events into WW_eventXXX arrays
// Allow events to be missing if not written out -- collapse array in this case
	WW_testoneventtarget = false; // must allow all events to be unpacked
	loadthis = WW_tangoboss.WW_numallevents;
	var oldnumber = 0;
	convert = new Array();
	var today = new Date();
	var currenttime = today.getTime();
	var basetime = -1;
	var minorformsize = minorform.length;
	for(var m=2; m < minorformsize; m++)	{
		var elname = minorform.elements[m].name;
		var elvalue = minorform.elements[m].value;
		if(elname.substring(0,10) == 'minorevent' )	{ // Find Event Number
			var oldnumber_temp = parseInt(elvalue);
			if( oldnumber_temp <= oldnumber )	{
				WW_tangoboss.WW_setstatusline(' Inconsistent minor events in history ' + oldnumber_temp + ' < ' + oldnumber);
				WW_testoneventtarget = true;
				return; }
			oldnumber = oldnumber_temp;
			++loadthis;
			convert[oldnumber] = loadthis; // oldnumber is original minor event number; convert[oldnumber] new one
			continue; }
		if(elname.substring(0,17) == 'eventarchivearray' )	{ // Unpack event
			wwevent = new WW_basicevent();
			WW_getevent(elvalue,wwevent);
			if(WW_isdefined(wwevent.error))	{
				WW_tangoboss.WW_setstatusline('Error reading minor event from history see Java Console ' + oldnumber);
				WW_javaprintevent(wwevent);
				WW_testoneventtarget = true;
				return; }
			wwevent.reject = false;
			wwevent.processed = 0;
			wwevent.minorevent = loadthis;
			if( WW_isdefined(wwevent.majorevent))
					wwevent.majorevent += majorchange;
			if(WW_isundefined(wwevent.originalsourcetime) )	{
				if(WW_isdefined(wwevent.sourcetime) )	{
					wwevent.originalsourcetime = wwevent.sourcetime; }
			}
			if( WW_isdefined(wwevent.sourcetime) )	{
				if( basetime < 0 )
					basetime = wwevent.sourcetime;
				wwevent.sourcetime += currenttime - basetime;
			}
			if( WW_isundefined(wwevent.originaltargettime) )	{
				if( WW_isdefined(wwevent.targettime) )
					wwevent.originaltargettime = wwevent.targettime;
			}
			if( WW_isdefined(wwevent.targettime) )	{
				if( basetime < 0 )
					basetime = wwevent.targettime;
				wwevent.targettime += currenttime - basetime;
			}
			WW_tangoboss.WW_eventrecord[loadthis-1] = wwevent;
			continue;
		}
	}
	
// Correct minor events links to major events
	WW_testoneventtarget = true; // reset testing
	WW_tangoboss.WW_numallevents = loadthis;
	WW_tangoboss.WW_numeventsdone = WW_tangoboss.WW_numallevents;
	WW_tangoboss.WW_numpointereventsdone = WW_tangoboss.WW_numallevents;
	for(var m=initialmajorevent; m<= WW_tangoboss.WW_numberurl; m++)	{ 
		var currentlink = WW_tangoboss.WW_majorevent[m-1].associatedevent;
		if(WW_isundefined(convert[currentlink]))	{
			WW_tangoboss.WW_setstatusline('Associated Event Lost ' + m + ' to ' + currentlink);
			WW_tangoboss.WW_majorevent[m-1].associatedevent =0;
			continue;
		}
		WW_tangoboss.WW_majorevent[m-1].associatedevent = convert[currentlink];
	}
	return;
	
}	// End WW_signedcopyhistory(choosepart)

function WW_spawnedsetframesfrominfo(info)	{

	var windowarg = WWsignedchild;
	if( !WW_isitawindow(windowarg) )
		return;
	var numframes = windowarg.length;
	if( WW_isundefined(numframes))
		return;
	var oldurl = WW_spawnedmainframepageinfo.basicurl;
	if(oldurl != info.basicurl ) {
		windowarg.location.href = info.basicurl;
		return; }
	for( var m=0 ;m< numframes;m++)	{
		if(WW_isundefined(info.places[m]))
			return;
		if(info.places[m] != WW_spawnedmainframepageinfo.places[m])
			windowarg.frames[m].location.href = info.places[m];
	}
}	// End WW_spawnedsetframesfrominfo(info)

function WW_signedconfirm(message)	{

	return self.confirm(message);
}	// End WW_signedconfirm(message)

function WW_getspawnedwidth()	{
	return self.innerWidth;
}	// End WW_getspawnedwidth()

function WW_getspawnedheight()	{
	return self.innerHeight;
}	// End WW_getspawnedheight()

function WW_getspawnedmainframeurl()	{
	return self.WW_spawnedmainframeurl;
}	// End WW_getspawnedmainframeurl()

function WW_spawnedparentclose()	{	// Close Signed window
	self.close();
	return;
}	// End WW_spawnedparentclose()

function WW_setspawnedwindowstatus(mess)	{ // Set Signed window status Bar
	self.status = mess;
	return;
}	// End WW_setspawnedwindowstatus(mess)

function WW_getframehandle(framename)    {

        var testtype3 = typeof  window.length;
        if( testtype3 == 'undefined' )
                return null;
        if( window.length == null )
                return null;
        var size = window.length;
        for (var i=0; i < size ; i++)       {
                var varn = window.frames[i].name;
                if( varn == framename  )
                        return window.frames[i];
        }
        return null;
		
}	// End WW_getframehandle(framename)

// fnsew = 5 Focus ** =1 Top Left  ** = 3 Top Right ** = 2 Bottom Left ** =4 Bottom Right
function WW_windowalignfocus(actualwindow,fnsew)	{

	if( fnsew == 0 )	{
		actualwindow.focus();
		return; }
	var usexpos = parseInt(WW_tangoboss.WW_userwindowxpos);
	var useypos = parseInt(WW_tangoboss.WW_userwindowypos);
	if( fnsew == 1 )	{
		actualwindow.moveTo(usexpos,useypos);
		actualwindow.focus();
		return; }
	var xpos = screen.width;
	var ypos = screen.height;
	var xpos1 = actualwindow.outerWidth;
	var ypos1 = actualwindow.outerHeight;
	if( fnsew == 3 )
		actualwindow.moveTo(xpos-xpos1,useypos);
	if( fnsew == 2 )
		actualwindow.moveTo(usexpos,ypos-ypos1);
	if( fnsew == 4 )
		actualwindow.moveTo(xpos-xpos1,ypos-ypos1);
	actualwindow.focus();
	return;

}	// End WW_windowalignfocus(actualwindow,fnsew)

//	Align Your Hand window
// With Argument -1 return true if Window Exists
// With argument -2 remove window
function WW_cardhandalignfocus(fnsew)	{

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = WW_gamemaster;
	if(!WW_isitawindow(windowarg))
		return false;
	if( !WW_isitawindow(windowarg.WW_trickswindow))
		return false;
	if( fnsew == -1 )
		return true;
	if( fnsew == -2 )	{
		windowarg.WW_trickswindow.close();
	}
	WW_windowalignfocus(windowarg.WW_trickswindow,fnsew);
	return true;

}	// End	WW_cardhandalignfocus(fnsew)

//	Align This Window
function WW_spawnedalignfocus(fnsew)	{

	WW_windowalignfocus(self,fnsew);
	return true;
	
}	// End WW_spawnedalignfocus(fnsew)

//	Game Interface
function WW_startgame(gameoption)	{

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = WW_gamemaster;
	if(!WW_isitawindow(windowarg))
		return false;
	if( WW_isundefined(windowarg.WW_pointersetupoption) )
		return false;
	if( windowarg.WW_pointersetupoption < 11 )
		return false;
	windowarg.WW_startgame(WW_tangoboss.WW_playernames,WW_tangoboss.WW_dealername,gameoption);
	return true;
	
}	// End WW_startgame(gameoption)

function WW_endgame()	{

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = WW_gamemaster;
	if(!WW_isitawindow(windowarg))
		return false;
	if( WW_isundefined(windowarg.WW_pointersetupoption) )
		return false;
	if( windowarg.WW_pointersetupoption < 11 )
		return false;
	windowarg.WW_endgame();
	return true;
	
}	// End WW_endgame()

function WW_setgameoption(optiontype,optionvalue)	{

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = WW_gamemaster;
	if(!WW_isitawindow(windowarg))
		return false;
	if( WW_isundefined(windowarg.WW_pointersetupoption) )
		return false;
	if( windowarg.WW_pointersetupoption < 11 )
		return false;
	windowarg.WW_setgameoption(optiontype,optionvalue);
	return true;
	
}	// End WW_setgameoption(optiontype,optionvalue)

function WW_getgamestatus()	{ // Return Set of Game Defining Features

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = WW_gamemaster;
	if(!WW_isitawindow(windowarg))
		return null;
	if( WW_isundefined(windowarg.WW_pointersetupoption) )
		return null;
	return windowarg.WW_getgamestatus();
	
}	// End WW_getgamestatus()

// Heuristic Analysis Section ***********************************************

// Heuristic Analysis to Find Next and Previous URL's
// Argument is URL to analyse to find a number embedded so next and
// previous URL's are gotten by incrementing or decrementing this number
// Control by WW_nextprevheuristicmaxno where if < 0 unsets Next/Prev Heuristics; otherwise largest allowed number
// and WW_nextprevheuristicminchar where number part of Next/Prev URL must have at least this many characters
// and WW_nextprevheuristictext where if non empty, insist number part of URL contains this
// Set result in WW_nextheuristicurl  and WW_prevheuristicurl which are '' if unset
function WW_heuristicnextprevurls(usethisurl)	{

	WW_tangoboss.WW_nextheuristicurl = '';
	WW_tangoboss.WW_prevheuristicurl = '';
	var nextprevmaxno = WW_tangoboss.WW_nextprevheuristicmaxno;
	if( nextprevmaxno < 0 )
		return true;
	var nextprevheuristictext = WW_tangoboss.WW_nextprevheuristictext;
	var chosenlen = WW_tangoboss.WW_nextprevheuristicminchar;
	var heuristicfind = new RegExp(nextprevheuristictext,"i");
	var numfind = new RegExp("(\\d+)(\\D*\\.[^\\.]*$)");

// Choose nextprev with largest number of digits before  nextprev tag (.jpg etc.)
// Insist that URL matches WW_tangoboss.WW_nextprevheuristictext
	if(nextprevheuristictext.length > 0 )	{
		if(!heuristicfind.test(usethisurl))
			return true;
	}
	if( !numfind.test(usethisurl) )
		return true;
	var size = RegExp.$1.length;
	if( size < chosenlen )
		return true;
	chosenlen = size;
	var internalno = parseInt(RegExp.$1,10);
	if(internalno > nextprevmaxno )
		return true;
	var precursor = RegExp.leftContext;
	var postcursor = RegExp.$2;
	var nexturl = internalno + 1;
	if( nexturl <= nextprevmaxno )	{
		var nexttexturl = nexturl.toString();
		var more = chosenlen - nexttexturl.length;
		for(var m=0;m<more;m++)	{
			nexttexturl = '0' + nexttexturl; }
		WW_tangoboss.WW_nextheuristicurl = precursor + nexttexturl + postcursor;
	}
	var prevurl = internalno - 1;
	if( prevurl > 0 )	{
		var prevtexturl = prevurl.toString();
		var more = chosenlen - prevtexturl.length;
		for(var m=0;m<more;m++)	{
			prevtexturl = '0' + prevtexturl; }
		WW_tangoboss.WW_prevheuristicurl = precursor + prevtexturl + postcursor;
	}
	return true;

}	// End WW_heuristicnextprevurls(usethisurl)

//	Control Determination of Thumbnail URL's
function WW_thumbnailbegin()	{

	if( WW_tangoboss.WW_numberurl <= 0 )
		return true;
	if( WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl-1].thumbnail.processed == 1 )
		return true;
	WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl-1].thumbnail = WW_heuristicthumbnails();
	return true;

}	// End WW_thumbnailbegin()

function WW_thumbnailend()	{

	if( WW_tangoboss.WW_numberurl <= 0 )
		return true;
	var tempthumb = WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl-1].thumbnail;
	if(WW_savethumbnail != '' && tempthumb.currenturl == '')	{
		tempthumb.currenturl = WW_savethumbnail;
		WW_savethumbnail = '';
	}
	if( tempthumb.processed == 1 )
		return true;
	tempthumb.processed = 1;
	WW_tangoboss.WW_absolutesnoopimageindex = -1;
	if(tempthumb.currenturl != '')	{
		if(!WW_tangoboss.WW_reviewoption)	{ // Preview Mode
			WW_tangoboss.WW_absolutesnoopimageindex = WW_tangoboss.WW_numberurl + WW_tangoboss.WW_previewincrement-1;
		}
		if(WW_tangoboss.WW_numberurl > 1)	{
			var guessthumb = WW_tangoboss.WW_nextthumbnail(WW_tangoboss.WW_numberurl-2,1);
			if( guessthumb == tempthumb.currenturl)	{
				WW_tangoboss.WW_setdebugline('Thumbnail predicted correctly ' + guessthumb); }
			else	{
				WW_tangoboss.WW_setdebugline('Incorrect thumbnail prediction ' + guessthumb + ' It was ' + tempthumb.currenturl);
			}
		}	
	}
	else	{
		WW_tangoboss.WW_setdebugline('No Thumbnail found');
	}
	if(WW_tangoboss.WW_numberurl > 1)	{
		if( WW_tangoboss.WW_reviewoption && (WW_tangoboss.WW_majorevent[WW_tangoboss.WW_numberurl-2].thumbnail.currenturl != '') )
			WW_tangoboss.WW_absolutesnoopimageindex = WW_tangoboss.WW_numberurl-2;
	}
	var makeorbreak = 0; // if 1 create window, else allow to be removed
	if( WW_tangoboss.WW_trackreview && (WW_tangoboss.WW_absolutesnoopimageindex>=0) )	{
		if( (WW_tangoboss.WW_absolutesnoopimageindex < WW_tangoboss.WW_numberurl)  && (WW_tangoboss.WW_majorevent[WW_tangoboss.WW_absolutesnoopimageindex].thumbnail.currenturl != '') )
			makeorbreak = 1;
		if( WW_tangoboss.WW_absolutesnoopimageindex >= WW_tangoboss.WW_numberurl )	{
			if( WW_tangoboss.WW_nextthumbnail(WW_tangoboss.WW_numberurl-1,WW_tangoboss.WW_absolutesnoopimageindex - WW_tangoboss.WW_numberurl + 1) != '' )	{
				makeorbreak = 1;
			}
		}
	}
	if( WW_tangoboss.WW_reviewmode != 3 )	{
		WW_tangoboss.WW_button_Review(makeorbreak);	
		WW_tangoboss.WW_setdebugline(makeorbreak + ' Numurl ' + WW_tangoboss.WW_numberurl + ' Snoopindex ' + WW_tangoboss.WW_absolutesnoopimageindex + ' thumburl ' + tempthumb.currenturl);
	}
	return true;
	
}	// End WW_thumbnailend()
	
// Data structure for Thumbnails
function WW_storethumbnails()	{

	this.currenturl = ''; // URL of Thumbnail unless '' when no url
	this.currentno = -1; // Current iterating number in Image URL
	this.numberstring = ''; // Iterating Number as String with Trailing zeros
	this.precursor = ''; // String before number
	this.postcursor = ''; // String after Iterating number
	this.lengthofno = 0; // Character Length of this.numberstring
	this.processed = 0; // Indicte that something done (-1 means no attempt made; =0 in process; =1 finished)

}	// End of WW_storethumbnails()

// Heuristic Analysis to Find Thumbnail Images
function WW_heuristicthumbnails()	{

	netscape.security.PrivilegeManager.enablePrivilege( "UniversalBrowserAccess" );
	var windowarg = window.WWsignedchild;
	var thumbnailstructure = new WW_storethumbnails();
	if(!WW_isitawindow(windowarg))
		return thumbnailstructure;
	if( windowarg.length > 1 )
		return thumbnailstructure;
	var documentimagelen = windowarg.document.images.length;
	var imagemaxno = WW_tangoboss.WW_imageheuristicmaxno;
	if( imagemaxno < 0 )
		return thumbnailstructure;
	var imageheuristictext = WW_tangoboss.WW_imageheuristictext;
	var chosen = -1;
	var chosenlen = WW_tangoboss.WW_imageheuristicminchar;
	var heuristicfind = new RegExp(imageheuristictext,"i");
	var numfind = new RegExp("(\\d+)(\\D*\\.[^\\.]*$)");

// Choose Image with largest number of digits before  image tag (.jpg etc.)
// Insist that URL matches WW_tangoboss.WW_imageheuristictext
	for(var mimage=0; mimage < documentimagelen; mimage++)	{
		var teststring = windowarg.document.images[mimage].src;
		if(imageheuristictext.length > 0 )	{
			if(!heuristicfind.test(teststring))
				continue
		}
		if( !numfind.test(teststring) )
			continue;
		var size = RegExp.$1.length;
		if( size < chosenlen )
			continue;
		chosenlen = size;
		chosen = mimage;
	}
	if(chosen < 0 )
		return thumbnailstructure;
	var imagethumbnailurl = windowarg.document.images[chosen].src;
	numfind.test(imagethumbnailurl);
	var thumbnailno = parseInt(RegExp.$1,10);
	if(thumbnailno > imagemaxno )
		return thumbnailstructure;
	thumbnailstructure.currenturl = imagethumbnailurl;
	thumbnailstructure.precursor = RegExp.leftContext;
	thumbnailstructure.numberstring = RegExp.$1;
	thumbnailstructure.postcursor = RegExp.$2;
	thumbnailstructure.lengthofno = chosenlen;
	thumbnailstructure.currentno = thumbnailno;
	return thumbnailstructure;

}	// End WW_heuristicthumbnails()

//	Register Wisdom Pages
function WW_signedwisdomregister(level,pagetype,pagelabel,originatingwindow)	{

	var framenumber = -level;
	if( level == 1 )	{ // Top level Wisdom Page
		framenumber = -1; }
	if( level == 2 )	{ // In Frame Set one deep
		framenumber = WW_identifyframe(originatingwindow); }
	WW_tangoboss.WW_wisdomregisterevent[WW_tangoboss.WW_numwisdomregister] = {};
	WW_tangoboss.WW_wisdomregisterevent[WW_tangoboss.WW_numwisdomregister].indicator = WW_tangoboss.WW_numeventindicators;
	WW_tangoboss.WW_registereventindicator(6,WW_tangoboss.WW_numwisdomregister,framenumber,WW_tangoboss.WW_tangogrouplabel,WW_tangoboss.WW_tangosequencenumber);
	WW_tangoboss.WW_wisdomregisterevent[WW_tangoboss.WW_numwisdomregister].pagelabel = pagelabel;
	WW_tangoboss.WW_wisdomregisterevent[WW_tangoboss.WW_numwisdomregister].pagetype = pagetype;

	WW_tangoboss.WW_setdebugline('Registered Page Frame:' + framenumber + ' Type ' + pagetype + ' Label:' + pagelabel);
	if( !WW_isthisapointeredpage(originatingwindow))	{
		originatingwindow = null;
	}
	WW_tangoboss.WW_wisdomregisterevent[WW_tangoboss.WW_numwisdomregister].pointerframe = originatingwindow;
	++WW_tangoboss.WW_numwisdomregister;
	if( WW_pointerframeset.trytocountdocarrays >= 0 )	{
		WW_thumbnailbegin();
		WW_thumbnailend();
	}
	return;
	
}	// End WW_wisdomregister(level,pagetype,pagelabel,originatingwindow)

function WW_spawnedframeset()	{ // Return current Pointer frameset

	return WW_pointerframeset;

}	// End WW_spawnedframeset()

function WW_returntangoboss()	{

	return WW_tangoboss;

}	// End WW_returntangoboss()

function WW_getfreewindow()	{

	return WW_getframehandle('freewindow');
	
}	// End WW_getfreewindow()

export WW_createdestroybuttonbar,WW_heuristicthumbnails,WW_spawnedframeset,WW_getspawnedmainframeurl,WW_getfreewindow,WW_signedwisdomregister,WW_returntangoboss,WW_signedcopyhistory,WW_spawnedparentclose,WW_signedconfirm,WW_spawnedsetframesfrominfo,WW_setspawnedwindowstatus,WW_getframehandle,WW_spawnedalignfocus,WW_getspawnedwidth,WW_getspawnedheight,WW_updatefullpointerparms,WW_saveforms,WW_interpretformevents;
export WW_cardhandalignfocus,WW_startgame,WW_endgame,WW_setgameoption,WW_getgamestatus;

function WW_pageloaded()	{

	if( WW_tangoboss.WW_countspawnedtries  < 1 )	{
		++WW_tangoboss.WW_countspawnedtries;
		if( WW_tangoboss.WW_targeturl != WW_tangoboss.WW_firsturl )	{
			self.WWsignedchild.location.href = WW_tangoboss.WW_targeturl;
		}
	}
	WW_tangoboss.WW_spawnedparentdone = true;
	setInterval("WW_loopforever()",2000/WW_clockunits);
	return true;

}	// End WW_pageloaded() for spawned window frameset
