// ****************** Copyright Header ************************************
// WebWisdom JavaScript Shared Browser Version 3.0
// Copyright 1999 Syracuse University and WebWisdom.com
// Author: Geoffrey C. Fox
// Contact: support@webwisdom.com
//
// Reproduction of this software without this Copyright Header
// is prohibited and it constitutes a violation of
// the SU and WebWisdom.com Copyright (a federal felony).
//
// This software cannot be incorporated into any commercial
// product, or a product supporting commercial activity,
// without first obtaining a license from WebWisdom.com
// E-mail license@webwisdom.com to apply.
// *********** End of Copyright Header ************************************
//

var bigboss= window.opener;
var WW_madebytango = true;
function WW_pageisloaded()	{

	var newdoc = self.document;
	var currentdate = new Date();
	var begintime = bigboss.WW_beginningoftime;
	newdoc.writeln('<title>WW:Console and Tango Sequence Listing</title>');
	newdoc.writeln('<script>bigboss= window.opener;WW_madebytango = true;</script>');
	newdoc.writeln('<style type="text/css" >');
	newdoc.writeln('#consoleparm {position:absolute; color:black; visibility:hidden; z-index:75; left:20; top:20; }');
	newdoc.writeln('#WWconfiglayer {position:absolute; color:black; visibility:hidden; z-index:75; left:0; top:0; }');
	newdoc.writeln('</style>');
	newdoc.writeln('<body background="../../help_background.gif" onload="bigboss.WW_consolehandler()" >');

//	Tango Stream Information
	newdoc.writeln('<h1>Tango Group and Stream Sequence</h1>');
	newdoc.writeln('<b>' + currentdate.toString() + '</b><br>');
	
	newdoc.writeln('<table  BORDER = 10 CELLSPACING=5 CELLPADDING=1 bgcolor=white >');
	newdoc.writeln('<th ALIGN=CENTER><b>#</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Event</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Time</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Tick</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Stream</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Group</b></th>');

	var oldgroup = '';
	for(var m=0; m<=bigboss.WW_tangosequencenumber;m++)	{
		var curcolor = "white";
		var localgroup = bigboss.WW_labelstream[m].grouplabel;
		if( localgroup != oldgroup)
			curcolor = "yellow";
		var eventno = bigboss.WW_labelstream[m].eventnumber;
		var eventprint =  "";
		if(eventno > 0 )	{
			eventprint = '<a href="javascript:void(0)" onclick="bigboss.WW_processevent0(' + (eventno-1) + ')" >' + eventno +'</a>';
		}
		var timeprint = bigboss.WW_toseconds(bigboss.WW_labelstream[m].time - begintime);
	
		newdoc.writeln('<tr><td align=left bgcolor="' + curcolor + '" nowrap>' + m + '</td><td align=center nowrap>' + eventprint + '</td>');
		newdoc.writeln('<td align=left nowrap>' + timeprint + '</td>');
		newdoc.writeln('<td align=center nowrap>' + bigboss.WW_labelstream[m].tickcount + '</td>');
		newdoc.writeln('<td align=left >' + bigboss.WW_labelstream[m].streamflag + '</td>');
		newdoc.writeln('<td align=left >' + bigboss.WW_labelstream[m].grouplabel + '</td></tr>');
	}	// End Loop over entries in WW_labelstream
	newdoc.writeln('</table>');

//	Tango Console Information
	newdoc.writeln('<h1>WebWisdom Console</h1>');
	newdoc.writeln('<b>' + currentdate.toString() + '</b><br>');
	
	newdoc.writeln('<table  BORDER = 10 CELLSPACING=5 CELLPADDING=1 bgcolor=white >');
	newdoc.writeln('<th ALIGN=CENTER><b>#</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Sequence#</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Tick</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Minor</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>DHTML</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Message</b></th>');
	newdoc.writeln('<tr><td align=center colspan=3><b> </b></td><td align=center colspan =2><b>Event</b></td>');
	
	for(var mm=0; mm< bigboss.WW_countconsolemessages; mm++)	{
		var m = bigboss.WW_countconsolemessages - mm -1;
		var curcolor = "white";
		var localtype = bigboss.WW_consoleentry[m].type;
		if( localtype == 0 )
			curcolor = "red";
		if( localtype == 1 )
			curcolor = "navajowhite";
		if( localtype == 3 )
			curcolor = "yellow";
		newdoc.writeln('<tr><td align=left bgcolor="' + curcolor + '" nowrap>' + m + '</td>');
		newdoc.writeln('<td align=center nowrap>' + bigboss.WW_consoleentry[m].sequencenumber + '</td>');
		newdoc.writeln('<td align=center nowrap>' + bigboss.WW_consoleentry[m].tickcount + '</td>');
		newdoc.writeln('<td align=center nowrap>' + bigboss.WW_consoleentry[m].numeventsdone + '</td>');
		newdoc.writeln('<td align=center nowrap>' + bigboss.WW_consoleentry[m].numpointereventsdone + '</td>');
		newdoc.writeln('<td align=left >' + bigboss.WW_consoleentry[m].message + '</td></tr>');
	}	// End Loop over Entries in WW_consoleentry
	newdoc.writeln('</table>');

//	Signatures of Page Change Information
	newdoc.writeln('<h1>Indicators of Page Changes</h1>');
	newdoc.writeln('<b>' + currentdate.toString() + '</b><br>');
	
	newdoc.writeln('<table  BORDER = 10 CELLSPACING=5 CELLPADDING=1 bgcolor=white >');
	newdoc.writeln('<th ALIGN=CENTER><b>#</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Frame#</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Type</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Typeindex</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Tick</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Time</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Group</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Sequence#</b></th>');
	indicatorlabel = new Array('','Unload Event','Dynamic Tango','URL Change','Form Click','Link Click','Wisdom Page','Major Event','Resize Event','Set Tango Group','Document Complete');
	
	for(var mm=0; mm< bigboss.WW_numeventindicators; mm++)	{
		var m = bigboss.WW_numeventindicators - mm -1;
		var curcolor = "white";
		var localtype = bigboss.WW_eventindicators[m].type;
		if( localtype == 7 )
			curcolor = "red";
		if( (localtype == 1) || (localtype == 2) )
			curcolor = "navajowhite";
		if( localtype == 6 )
			curcolor = "yellow";
		if( localtype == 9 )
			curcolor ="pink";
		var timeprint = bigboss.WW_toseconds(bigboss.WW_eventindicators[m].time - begintime);
		var indexprint = bigboss.WW_eventindicators[m].index;
		if( (localtype == 3) || (localtype == 4) || (localtype == 5) || (localtype == 8) )	{ // Event Array
			if(indexprint >= 0 )	{
				indexprint = '<a href="javascript:void(0)" onclick="bigboss.WW_processevent0(' + indexprint + ')" >' + (indexprint+1) +'</a>';
			}
		}
		else	{
			if(indexprint >= 0 )	{
				indexprint = '<a href="javascript:void(0)" onclick="bigboss.WW_processconsoleclick(event.pageX,event.pageY,' + localtype + ',' + indexprint + ')" >' + indexprint + '</a>';
			}
		}
		newdoc.writeln('<tr><td align=left bgcolor="' + curcolor + '" nowrap>' + m + '</td>');
		newdoc.writeln('<td align=center nowrap>' + bigboss.WW_eventindicators[m].framenumber + '</td>');
		newdoc.writeln('<td align=left nowrap>' + indicatorlabel[localtype] + '</td>');
		newdoc.writeln('<td align=center nowrap>' + indexprint + '</td>');
		newdoc.writeln('<td align=center nowrap>' + bigboss.WW_eventindicators[m].tickcount + '</td>');
		newdoc.writeln('<td align=left nowrap>' + timeprint + '</td>');
		newdoc.writeln('<td align=left nowrap>' + bigboss.WW_eventindicators[m].grouplabel + '</td>');
		newdoc.writeln('<td align=center nowrap>' + bigboss.WW_eventindicators[m].sequencenumber + '</td></tr>');

	}	// End Loop over Entries in WW_eventindicators
	newdoc.writeln('</table>');
	
	newdoc.writeln('<div id="consoleparm">Console Details</div>');
	newdoc.writeln('<div id="WWconfiglayer">Configuration</div>');
	newdoc.close();

}	// End WW_pageisloaded()
