// ****************** Copyright Header ************************************
// WebWisdom JavaScript Shared Browser Version 3.0
// Copyright 1999 Syracuse University and WebWisdom.com
// Author: Geoffrey C. Fox
// Contact: support@webwisdom.com
//
// Reproduction of this software without this Copyright Header
// is prohibited and it constitutes a violation of
// the SU and WebWisdom.com Copyright (a federal felony).
//
// This software cannot be incorporated into any commercial
// product, or a product supporting commercial activity,
// without first obtaining a license from WebWisdom.com
// E-mail license@webwisdom.com to apply.
// *********** End of Copyright Header ************************************
//

var WW_isloaded =0;
var WW_clockpageisloaded = 0;
var realbigboss = null;
var bigboss = window.opener;
if(WW_isitawindow(bigboss))	{
	realbigboss = bigboss.WW_tangoboss;
}
if(!WW_isitawindow(realbigboss))
	self.close();
if(realbigboss.name == '' )	{
	var rannum = Math.random();
	var intrannum = parseInt(1000.*rannum);
	realbigboss.name = 'Masterofthering' + intrannum.toString();
}
var newbossname = realbigboss.name;
var bossspec = realbigboss.WW_buttonspec
if(WW_isundefined(bossspec))
	self.close();
var baseurl = bossspec.baseurl;
realbigboss.WW_topcontrolwindowreadytogo =0;
var totalwidth = settotalwidth();
var barheight = 40.;
var allowedheight = screen.height;
var allowedwidth = screen.width;
var treebuttonpos = gettreeposition();
var treeleft = treeleftposition();

function doclick(mess,num1,num2)	{

	if(WW_isloaded == 0 )
		return true;
	if( bossspec.fiveway[num1] == 3 )	{ // Position bar
		var x = 0;
		var y = 0.;
		if( num2 == 2 )	{
			y = allowedheight - barheight; }
		if( num2 == 3 )	{
			x = allowedwidth - totalwidth; }
		if( num2 == 4 )	{
			x = allowedwidth - totalwidth;
			y = allowedheight - barheight; } 
		window.moveTo(x,y);
	}
	if( WW_isitawindow(realbigboss) )	{
		if(WW_isundefined(realbigboss.WW_launchedbarbutton))
			self.close();
		else	{
	        	realbigboss.WW_barbuttonclick(mess,num1,num2); }
	}
	else	{
		realbigboss = window.open("",newbossname);
		if (realbigboss.document.URL == "")	{
			if(WW_isitawindow(realbigboss))
				realbigboss.close();
			self.close();
		}
		else	{
			if(WW_isundefined(realbigboss.WW_launchedbarbutton))
				self.close();
			else	{
				realbigboss.WW_barbuttonclick(mess,num1,num2); }
		}
	}
	if( num1 == treebuttonpos )
		WW_clockmouseclick();
	return true;
}
function doover(mess,num1,num2)	{

	if(WW_isloaded == 0 )
		return true;
	if( WW_isitawindow(realbigboss) )	{
		if(WW_isundefined(realbigboss.WW_launchedbarbutton))
			self.close();
		else	{
	        	realbigboss.WW_barbuttonover(mess,num1,num2); }
	}
	else	{
		realbigboss = window.open("",newbossname);
		if (realbigboss.document.URL == "")	{
			if(WW_isitawindow(realbigboss))
				realbigboss.close();
			self.close();
		}
		else	{
			if(WW_isundefined(realbigboss.WW_launchedbarbutton))
				self.close();
			else	{
				if( bossspec.fiveway[num1] == 3 )	{ // Reset positioning image
					realbigboss.WW_processingerrorflag = 0;
				}
				realbigboss.WW_barbuttonover(mess,num1,num2); }
		}
	}
	return true;
}
function doout()	{

	if(WW_isloaded == 0 )
		return true;
	if( WW_isitawindow(realbigboss) )	{
		if(WW_isundefined(realbigboss.WW_launchedbarbutton))
			self.close();
		else	{
			realbigboss.WW_barbuttonout(); }
	}
	return true;
}
function changeimage(m)	{

	if(WW_isloaded == 0 )
		return true;
	var kind = bossspec.imgpos[m];
	var extrachar = '';
	if(bossspec.yesno[m] == 0 )
		extrachar = 'f';
	document.images[kind].src= baseurl + extrachar + bossspec.imageurl[m];
	return;
}
export changeimage;

function settotalwidth()	{

	var bartotalwidth =0;
	var row =0;
	for(var m=0; m< realbigboss.WW_barlayoutsize;m++)	{
		mm = realbigboss.WW_barlayout[m];
		if( bossspec.ignore[mm] == 1 )
			continue;
		if( bossspec.height[mm] < 30 )	{
			row = 1 - row;
			if( row == 0 )
				continue;
		}
		bartotalwidth += bossspec.width[mm]; 
	}
	return bartotalwidth;

}	// End settotalwidth()

function treeleftposition()	{

	var localtreeleft =0;
	var row =0;
	for(var m=0; m< realbigboss.WW_barlayoutsize;m++)	{
		mm = realbigboss.WW_barlayout[m];
		if( bossspec.fiveway[mm] == -1 )
			return localtreeleft;
		if( bossspec.ignore[mm] == 1 )
			continue;
		if( bossspec.height[mm] < 30 )	{
			row = 1 - row;
			if( row == 0 )
				continue;
		}
		localtreeleft += bossspec.width[mm]; 
	}
	return 0;

}	// End treeleftposition()

function gettreeposition()	{

	for(var mm=0;mm<bossspec.nbutton;mm++)  {
		if( bossspec.fiveway[mm] == -1 )
			return mm;
	}
	return -1;

}	// End gettreeposition() 

function WW_pageloaded()	{ 	// Initialize  when page loaded

	WW_isloaded=1;
	WW_clockpageloaded();
	if( WW_isitawindow(realbigboss) )	{
		if(WW_isundefined(realbigboss.WW_launchedbarbutton))
			self.close();
		else	{
			realbigboss.WW_topcontrolwindowreadytogo = 1; }
	}
	return true;

}	// End WW_pageloaded()

// clock related JavaScript *******************************
var WW_handcnt =0;
var WW_displaytree = false;
var WW_blackhandobject = null;
var WW_coloredhandcnt = 8;
var WW_relativetime = 0;
var WW_alternatered = 3;
var WW_lasthandarraypos = 7;
var WW_lasteventpos = 7;
WW_coloredhandobjects = new Array();
WW_coloredhandtimes = new Array();
WW_blackhandimages = new Array();
WW_arraysofimages = new Array();
WW_redhandimages = new Array();
WW_dottedredhandimages = new Array();
WW_bluehandimages = new Array();
WW_greenhandimages = new Array();
WW_orangehandimages = new Array();
WW_treeimage = new Image();
WW_baseclockimage = new Image();
WW_eventtypearray = new Array();
WW_eventtimearray = new Array();
WW_eventhandarray = new Array();
for(var m=0; m < WW_coloredhandcnt; m++)	{
	WW_eventhandarray[m] = 0;
	WW_eventtypearray[m] = -1;
	WW_eventtimearray[m] = -1; }

function WW_clocktick()	{

	if( WW_clockpageisloaded == 0 )
		return;
	WW_relativetime++;
	WW_handcnt++;
	if( WW_handcnt > 29)
		WW_handcnt = 0;
	if( WW_displaytree )
		return;
	WW_blackhandobject.document.images[0].src = WW_blackhandimages[WW_handcnt].src;
	var changed = false;
	for( var m=0; m < WW_coloredhandcnt; m++ )      {
		if(WW_eventtypearray[m] < 0 )
			continue;
		var colorindicator = WW_eventtypearray[m];
		WW_eventtypearray[m] = -1;
		++WW_lasthandarraypos;
		if( WW_lasthandarraypos >= WW_coloredhandcnt)
			WW_lasthandarraypos = 0;
		WW_coloredhandtimes[WW_lasthandarraypos] = WW_eventtimearray[m];
		WW_eventtimearray[m] = -1;
		var imageplace = WW_arraysofimages[0];
		++WW_alternatered;
		if( WW_alternatered >= 4 )
			WW_alternatered = 0;
		if( WW_alternatered  > 1 )
			imageplace = WW_dottedredhandimages; 
		if( colorindicator > 3 )
			colorindicator = 3;
		if( colorindicator > 0 )
			imageplace = WW_arraysofimages[colorindicator];
		if( colorindicator == 1)
			WW_alternatered = 2;
		WW_coloredhandobjects[WW_lasthandarraypos].document.images[0].src = imageplace[WW_eventhandarray[m]].src;
		WW_coloredhandobjects[WW_lasthandarraypos].visibility = 'show';
		changed = true;
//		if(WW_isitawindow(realbigboss))
//			realbigboss.WW_setdebugline(WW_lasthandarraypos + ' ' + WW_coloredhandobjects[WW_lasthandarraypos].document.images[0].src);
	}
	if( changed)
		return;

	for( var m=0; m < WW_coloredhandcnt; m++ )      {
		if(WW_coloredhandobjects[m].visibility == 'hide')
			continue;
		if(WW_coloredhandtimes[m] < WW_relativetime-30) {
//			doover('Deleting hand ' + m.toString(),-1,0);
			WW_coloredhandtimes[m] = 0;
			WW_coloredhandobjects[m].visibility = 'hide';
		}
	}
	return;

}	// End WW_clocktick()

function WW_addcoloredhand(colorindicator_ascii)	{
	
	if( WW_isloaded == 0 )
		return;
	if( WW_clockpageisloaded == 0 )
		return;
	++WW_lasteventpos;
	if( WW_lasteventpos >= WW_coloredhandcnt)
		WW_lasteventpos = 0;
	WW_eventtypearray[WW_lasteventpos] = parseInt(colorindicator_ascii);
	WW_eventtimearray[WW_lasteventpos] = WW_relativetime;
	WW_eventhandarray[WW_lasteventpos] = WW_handcnt;
	if(WW_eventhandarray[WW_lasteventpos]>29)
		WW_eventhandarray[WW_lasteventpos] =0;
	return true;

}	// End WW_addcoloredhand(colorindicator)
	
function WW_clockmouseclick()	{

	WW_displaytree = !WW_displaytree;
	if( WW_displaytree )	{
		WW_blackhandobject.visibility = 'hide';
		for( var m=0; m < WW_coloredhandcnt; m++ )	{
			WW_coloredhandobjects[m].visibility = 'hide'; }
		WW_baseclockobject.document.images[0].src = WW_treeimage.src;
	}
	else	{
		WW_baseclockobject.document.images[0].src = WW_baseclockimage.src;
		WW_blackhandobject.document.images[0].src = WW_blackhandimages[WW_handcnt].src;
		WW_blackhandobject.visibility = 'show';
	}
	return true;

}	// End WW_clockmouseclick()

var WW_barmessageobject = null;

// Make bar message -- called from outside which also controls how long it stays
function WW_makebarmessage(texttodisplay,colour)	{

	WW_changelayer(WW_barmessageobject,'<a onclick="WW_hidebarmessage()" href="javascript:void(0)">Delete Message</a>:<br>' + texttodisplay,colour,1001,true);
	return true;
	
}	// End WW_makebarmessage(texttodisplay,colour)

// Hide Text layer
function WW_hidebarmessage()	{

	WW_layerhide(WW_barmessageobject);
	return true;
	
}	// End WW_hidebarmessage()


function WW_barclose()	{	// Close Signed window

	self.close();
	return;
	
}	// End WW_barclose()

export WW_barclose,WW_addcoloredhand,WW_clocktick,WW_hidebarmessage,WW_makebarmessage;

function WW_clockpageloaded()	{ 	// Initialize clock when page loaded

	WW_barmessageobject = document.layers['WWbarmessage'];
	WW_treeimage.src = baseurl + 'blackclock/smallsquaretree.gif';
	WW_baseclockimage.src = baseurl + 'blackclock/base.gif';
	for(var m= 0;m <30; m++)	{
		var mlabel = 2*m;
		if( m == 0 )
			mlabel = 60;
		mlabel = mlabel.toString()+'.gif'
		WW_blackhandimages[m] = new Image();
		WW_blackhandimages[m].src = baseurl + 'blackclock/' + mlabel;
		WW_redhandimages[m] = new Image();
		WW_redhandimages[m].src = baseurl + 'redclock/' + mlabel;
		WW_dottedredhandimages[m] = new Image();
		WW_dottedredhandimages[m].src = baseurl + 'dottedredclock/' + mlabel;
		WW_bluehandimages[m] = new Image();
		WW_bluehandimages[m].src = baseurl + 'blueclock/' + mlabel;
		WW_greenhandimages[m] = new Image();
		WW_greenhandimages[m].src = baseurl + 'greenclock/' + mlabel;
		WW_orangehandimages[m] = new Image();
		WW_orangehandimages[m].src = baseurl + 'orangeclock/' + mlabel;
	} 
	WW_arraysofimages[0] = WW_redhandimages;
	WW_arraysofimages[1] = WW_bluehandimages;
	WW_arraysofimages[2] = WW_greenhandimages;
	WW_arraysofimages[3] = WW_orangehandimages;
	WW_baseclockobject = document.layers['WWbaseclock'];
	WW_blackhandobject = document.layers['WWblackhand'];
	WW_coloredhandobjects[0] = document.layers['WWcoloredhand1'];
	WW_coloredhandobjects[1] = document.layers['WWcoloredhand2'];
	WW_coloredhandobjects[2] = document.layers['WWcoloredhand3'];
	WW_coloredhandobjects[3] = document.layers['WWcoloredhand4'];
	WW_coloredhandobjects[4] = document.layers['WWcoloredhand5'];
	WW_coloredhandobjects[5] = document.layers['WWcoloredhand6'];
	WW_coloredhandobjects[6] = document.layers['WWcoloredhand7'];
	WW_coloredhandobjects[7] = document.layers['WWcoloredhand8'];
	for(var m=0;m<WW_coloredhandcnt;m++)	{
		WW_coloredhandobjects[m].visibility='hide';
		WW_coloredhandtimes[m] = 0; }
	WW_clockpageisloaded =1;
	
}	// End WW_clockpageloaded()

if( treebuttonpos >= 0 )	{
	if( WW_isundefined(treeleft))
		self.close();
	document.writeln('<style type="text/css" >');
	document.writeln('#WWbarmessage {position:absolute;  visibility:hidden; left:0; top:0; }');
	document.writeln('#WWbaseclock {position:absolute;  visibility:visible; left:' + treeleft +'; top:0; }');
	document.writeln('#WWblackhand {position:absolute;  visibility:visible; left:' + treeleft +'; top:0; }');
	document.writeln('#WWcoloredhand1 {position:absolute;  visibility:hidden; left:' + treeleft +'; top:0; }');
	document.writeln('#WWcoloredhand2 {position:absolute;  visibility:hidden; left:' + treeleft +'; top:0; }');
	document.writeln('#WWcoloredhand3 {position:absolute;  visibility:hidden; left:' + treeleft +'; top:0; }');
	document.writeln('#WWcoloredhand4 {position:absolute;  visibility:hidden; left:' + treeleft +'; top:0; }');
	document.writeln('#WWcoloredhand5 {position:absolute;  visibility:hidden; left:' + treeleft +'; top:0; }');
	document.writeln('#WWcoloredhand6 {position:absolute;  visibility:hidden; left:' + treeleft +'; top:0; }');
	document.writeln('#WWcoloredhand7 {position:absolute;  visibility:hidden; left:' + treeleft +'; top:0; }');
	document.writeln('#WWcoloredhand8 {position:absolute;  visibility:hidden; left:' + treeleft +'; top:0; }');
	document.writeln('</style>');
}
document.writeln('</head><BODY  BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#990000" TEXT="#000000" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0 onload="WW_pageloaded();" >');
document.writeln('<TABLE align=top BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=' + totalwidth + ' >');
var imgcnt =0;
for(var row=0;row < 2;row++)	{
var rowused =0;
if( row > 0 )
	document.writeln('</tr>');
document.writeln('<TR VALIGN="top" ALIGN="left">');
	for(var m=0; m< realbigboss.WW_barlayoutsize;m++)	{
		mm = realbigboss.WW_barlayout[m];
	if(bossspec.ignore[mm] > 0 )
		continue;
	var localheight = bossspec.height[mm];
	var rowspan = ''
	if( localheight < 30 )	{
		rowused = 1 -rowused;
		if( rowused == row )
			continue;
	}
	else	{
		if( row == 1)
			continue;
		rowspan = ' ROWSPAN=2 '; }
	var localwidth = bossspec.width[mm];
	bossspec.imgpos[mm] = imgcnt;
	++imgcnt;
	var extrachar = '';
	if(bossspec.yesno[mm] == 0 ) 
		extrachar = 'f';
	document.writeln('<TD ' + rowspan + ' WIDTH=' + localwidth + '  HEIGHT =' + localheight + '  ALIGN="left" VALIGN="top">');
	if( bossspec.fiveway[mm]  > 0 )	{
		document.writeln('<a href="javascript:void(0)"  >');
		document.writeln('<IMG name=image' + mm + ' HEIGHT=40 WIDTH=' + localwidth + ' SRC="' + baseurl + extrachar +  bossspec.imageurl[mm] + '"  BORDER=0 USEMAP="#map' + mm + '" >');
	        document.writeln('<MAP NAME="map' + mm + '" >');
		if( bossspec.fiveway[mm] == 1 )	{
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Positioned Top Left \',' + mm + ',1))" onmouseout="doout()" onmouseover="doover(\'Click to Position Top Left \',' + mm + ',1)"  COORDS="0,0,50,0,50,9,20,9,19,20,0,19,0,19">');
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Positioned Bottom Left \',' + mm + ',2))" onmouseout="doout()" onmouseover="doover(\'Click to Position Bottom Left \',' + mm + ',2)"  COORDS="1,20,20,20,19,31,50,31,50,39,1,39">');
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Positioned Top Right \',' + mm + ',3))" onmouseout="doout()" onmouseover="doover(\'Click to Position Top Right \',' + mm + ',3)"  COORDS="51,1,99,1,99,19,80,20,81,9,50,9,51,10">');
		        document.writeln('<AREA SHAPE="poly"  href="javascript:void(doclick(\'Positioned Bottom Right \',' + mm + ',4))" onmouseout="doout()" onmouseover="doover(\'Click to Position Bottom Right \',' + mm + ',4)" COORDS="99,39,99,21,80,21,80,30,50,32,51,39">');
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Focussed \',' + mm + ',5))" onmouseout="doout()" onmouseover="doover(\'Click to Focus \',' + mm + ',5)" COORDS="22,10,79,10,80,30,21,30,21,29" ></MAP></a></td>');
		}
		if( bossspec.fiveway[mm] == 2 )	{
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Positioned Top Left \',' + mm + ',1))" onmouseout="doout()" onmouseover="doover(\'Click to Position Top Left \',' + mm + ',1)"  COORDS="40,14,40,2,2,2,2,19,19,19,17,14,18,14">');
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Positioned Bottom Left \',' + mm + ',2))" onmouseout="doout()" onmouseover="doover(\'Click to Position Bottom Left \',' + mm + ',2)"  COORDS="40,39,40,28,19,27,19,23,1,23,1,39">');
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Positioned Top Right \',' + mm + ',3))" onmouseout="doout()" onmouseover="doover(\'Click to Position Top Right \',' + mm + ',3)"  COORDS="62,13,62,4,98,2,98,20,83,20,82,13">');
		        document.writeln('<AREA SHAPE="poly"  href="javascript:void(doclick(\'Positioned Bottom Right \',' + mm + ',4))" onmouseout="doout()" onmouseover="doover(\'Click to Position Bottom Right \',' + mm + ',4)" COORDS="98,39,98,24,82,23,81,29,62,29,62,39">');
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Focussed \',' + mm + ',5))" onmouseout="doout()" onmouseover="doover(\'Click to Focus \',' + mm + ',5)" COORDS="23,17,78,17,78,24,22,24" >');
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Pointer/Marker \',' + mm + ',6))" onmouseout="doout()" onmouseover="doover(\'Click to Toggle Pointer/Marker \',' + mm + ',6)" COORDS="42,29,60,28,60,38,41,38" >');
		        document.writeln('<AREA SHAPE="poly" href="javascript:void(doclick(\'Active/Visible \',' + mm + ',7))" onmouseout="doout()" onmouseover="doover(\'Click to Toggle Active/Visible \',' + mm + ',7)" COORDS="60,13,60,4,42,4,42,13" ></MAP></a></TD>');
		}
		if( bossspec.fiveway[mm] == 3 )	{
		        document.writeln('<AREA SHAPE="rect" href="javascript:void(doclick(\'Positioned Top Left \',' + mm + ',1))" onmouseout="doout()" onmouseover="doover(\'Click to Position Top Left \',' + mm + ',1)"  COORDS="0,0,21,21">');
		        document.writeln('<AREA SHAPE="rect" href="javascript:void(doclick(\'Positioned Bottom Left \',' + mm + ',2))" onmouseout="doout()" onmouseover="doover(\'Click to Position Bottom Left \',' + mm + ',2)"  COORDS="1,21,21,39">');
		        document.writeln('<AREA SHAPE="rect" href="javascript:void(doclick(\'Positioned Top Right \',' + mm + ',3))" onmouseout="doout()" onmouseover="doover(\'Click to Position Top Right \',' + mm + ',3)"  COORDS="21,1,39,21">');
		        document.writeln('<AREA SHAPE="rect"  href="javascript:void(doclick(\'Positioned Bottom Right \',' + mm + ',4))" onmouseout="doout()" onmouseover="doover(\'Click to Position Bottom Right \',' + mm + ',4)" COORDS="22,22,39,39"></MAP></a></TD>');
		}
	}
	else	{
		document.writeln('<a href="javascript:void(0)" onclick="doclick(\'Executed \',' + mm + ',0)" onmouseout="doout()" onmouseover="doover(\'Click to Execute \',' + mm + ',0)"  >');
		document.writeln('<IMG name=image' + mm + ' HEIGHT=' + localheight + '  WIDTH=' + localwidth + ' SRC="' + baseurl + extrachar + bossspec.imageurl[mm] + '"  BORDER=0  alt ="'  + bossspec.message[mm] + '" ></A></TD>');
	}
}
}
document.writeln('</tr></TABLE>');
if( treebuttonpos >= 0 )	{
	document.writeln('<div id="WWbarmessage">Bar Message</div><div id="WWbaseclock" ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'blackclock/base.gif" border=0  ></img></a></div><div id="WWblackhand"  ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'blackclock/60.gif" border=0 ></img></a></div><div id="WWcoloredhand1"  ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'redclock/60.gif" border=0 ></img></a></div><div id="WWcoloredhand2"  ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'blueclock/60.gif" border=0 ></img></a></div><div id="WWcoloredhand3"  ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'greenclock/60.gif" border=0 ></img></a></div><div id="WWcoloredhand4"  ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'redclock/60.gif" border=0 ></img></a></div><div id="WWcoloredhand5"  ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'blueclock/60.gif" border=0 ></img></a></div><div id="WWcoloredhand6" ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'blueclock/60.gif" border=0 ></img></a></div><div id="WWcoloredhand7" ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'blueclock/60.gif" border=0 ></img></a></div><div id="WWcoloredhand8" ><a href="javascript:void(0)" onclick="WW_clockmouseclick()" onmouseout="doout()" onmouseover="doover(\'Click to toggle clock \',' + treebuttonpos + ',0)"  ><img src="' + baseurl + 'blueclock/60.gif" border=0 ></img></a></div>');
}
document.writeln('</body></html>');
realbigboss.WW_topcontrolwindow = self;
