// WebWisdom JavaScript Shared Browser Version 3.0
// Copyright 1999 Syracuse University and WebWisdom.com
// Contact Geoffrey Fox gcf@npac.syr.edu
//
// Test on WW_isloaded = 1 to see if all loaded
var WW_pagelabel = 'Basic Pointer page'; // Set to user label for page
var WW_pagetype = 1; // concantenation of options 0...15 option =0 nothing, =1 Simple DHTML
var WW_wisdomregisterlevel = 0; // State of first discovered page with WW_wisdomregister defined

// WW_wisdomregisterlevel = 0 NOT discovered, = -1 window.opener >0 parent at this level (1 or 2)
// WW_wisdomregisterlevel = -2 means parent.opener while -3 implies used WWTango_doorkeeper at unknown relationship

function WW_initializeTango()	{

	WW_findwisdomregistry();
	
//	Initialize Tango Link -- setInterval killed later if Tango does not join
	WW_localprocessed = 0;
	WW_localeventqueue = 0;
	WW_IntervalID = setInterval("WW_processlocalqueue()",500);	

}	// End WW_initializeTango()

function WW_findwisdomregistry()	{ // Find a wisdom registry and/or tangoboss
//	Get WWTango_doorkeeper from first available source
// Note this can be overwritten by another doorkeeper

	if(WW_Microsoft)
		return;
	WWTango_doorkeeper = null;
	if(WW_isdefined(parent)&&(parent!=self))	{
		if(WW_lookforwisestuff(1,self,parent))
			return;
		var nexttry = parent.parent;
		if(WW_isdefined(nexttry)&&(parent!=nexttry))	{
			if(WW_lookforwisestuff(2,parent,nexttry))
				return;
		}
		var nexttry = parent.opener;
		if(WW_isitawindow(nexttry))	{
			if(WW_lookforwisestuff(-2,parent,nexttry))
				return;
		}
	}
	var nexttry = window.opener;
	if(WW_isitawindow(nexttry))	{
		if(WW_lookforwisestuff(-1,self,nexttry))
			return;
	}
	if(!WW_isitawindow(WWTango_doorkeeper))
		return;
	WW_lookforwisestuff(-3,self,WWTango_doorkeeper);
	return;

}	// End WW_findwisdomregistry()

function WW_lookforwisestuff(level,original,source)	{

	if(WW_Microsoft)
		return false;
	if(!WW_isitawindow(source))
		return false;

//	Special Processing for Signed source
//	Assume this is characterized by current name starting with WWsigned
	var curname = original.name;
	if(WW_isdefined(curname)&&(curname.substring(0,8)=='WWsigned'))	{ // Signed source
		eval("import source.WW_getfreewindow;var freeversion = WW_getfreewindow()"); // Fails unless eval includes use and import
		if(!WW_isitawindow(freeversion))
			return false;
		if(WW_isundefined(freeversion.WW_tangowisdomstatus))	{
			close(freeversion);
			return false;
		}
		WWTango_doorkeeper = freeversion.WW_returntangoboss();
		freeversion.WW_wisdomregister(level,WW_pagetype,WW_pagelabel,self);
		return true;
	}
	if(WW_isundefined(WWTango_doorkeeper))	{
		if(WW_isitawindow(source.WWTango_doorkeeper))
			WWTango_doorkeeper = source.WWTango_doorkeeper;
	}
	if(WW_isundefined(WWTango_doorkeeper))
		return false;
	if(WW_isdefined(source.WW_wisdomregister))	{
		WW_wisdomregisterlevel = level;
		source.WW_wisdomregister(level,WW_pagetype,WW_pagelabel,self);
		return true;
	}
	return false;
	
}	// End WW_lookforwisestuff(source)
			
var WWTango_status = 2;
var WWTango_canmovepointer = true;
var WWTango_canchangepointer = true;
var WWTango_acceptmasterstyle = true; // Set by Door Keeper
var WWTango_isrunning = false;
var WWTango_doorkeeper = null;
var WWTango_doorframenumber = -1;
var WWTango_windownumber = 1;
var WWTango_windowarray = new Array();
WWTango_windowarray[0] = self;
var WWTango_version = 1;
var WWTango_pointertarget = true;
var WW_parentwidth =0;
var WW_parentheight =0;
var WW_IntervalID = null;
var WW_countInterval = 0;
var WW_waitingfortimeout = false;
var WW_setmastercount = 0;

function WW_setasmaster(doorkeeper,framenumber,wid,hgt,version)	{

	if(WW_isitawindow(WWTango_doorkeeper))	{
		if(WW_setmastercount > 0)
			return true;
	}
	++WW_setmastercount;
	WWTango_doorkeeper = doorkeeper;
	WWTango_doorframenumber = framenumber;
	WW_parentwidth = wid;
	WW_parentheight = hgt;
	WWTango_isrunning = true;
	WWTango_canchangepointer = true;
	WWTango_canmovepointer = true;
	WWTango_status = 0;
	if(WW_isdefined(WW_messageobjectlist[0]))	{
		WW_messageobjectlist[0].document.open();
		WW_messageobjectlist[0].document.writeln(WW_messagecontent1master);
		WW_messageobjectlist[0].document.close();
	}
	if(WW_isdefined(WW_messageobjectlist[1]))	{
		WW_messageobjectlist[1].document.open();
		WW_messageobjectlist[1].document.writeln(WW_messagecontent2master);
		WW_messageobjectlist[1].document.close();
	}
	if( WWTango_version >= version)
		return true;
	return false;

}	// End WW_setasmaster(doorkeeper)

function WW_setasnonmaster(doorkeeper,framenumber,wid,hgt,version)	{

	if(WW_isitawindow(WWTango_doorkeeper))	{
		if(WW_setmastercount > 0)
			return true;
	}
	WWTango_doorkeeper = doorkeeper;
	WWTango_doorframenumber = framenumber;
	WW_parentwidth = wid;
	WW_parentheight = hgt;
	WWTango_isrunning = true;
	WWTango_canchangepointer = true;
	WWTango_canmovepointer = true;
	if( WW_pointersetupoption < 10 )
		WWTango_canmovepointer = false;
	WWTango_status = 1;
	if(WW_isdefined(WW_messageobjectlist[0]))	{
		WW_messageobjectlist[0].document.open();
		WW_messageobjectlist[0].document.writeln(WW_messagecontent1nonmaster);
		WW_messageobjectlist[0].document.close();
	}
	if(WW_isdefined(WW_messageobjectlist[1]))	{
		WW_messageobjectlist[1].document.open();
		WW_messageobjectlist[1].document.writeln(WW_messagecontent2nonmaster);
		WW_messageobjectlist[1].document.close();
	}
	if( WWTango_version >= version)
		return true;
	return false;

}	// End WW_setasnonmaster(doorkeeper)

// Send Current Parameters -- flag = 0 is heartbeat
function WW_updatefullpointerparms(flag)	{

	if(WW_isundefined(WW_pointerlayer))
		return;
	var clickX = WW_getlayerleft(WW_pointerlayer);
	var clickY = WW_getlayertop(WW_pointerlayer);
	WW_sendpointerparm(clickX,clickY,1,flag);
	return;

}	// end WW_updatefullpointerparms(flag)

// Input x,y is top,left of master pointer -- send actual pointer position itself
function WW_sendpointerparm(x,y,redo,flag)	{

	if( WWTango_status != 0 )
		return;
	WWTango_doorkeeper.WW_newtangolabel(WWTango_doorkeeper.WW_localflag,WWTango_doorkeeper.WW_tangogrouplabel);
	wwevent = new WW_generatedevent(WWTango_doorkeeper.WW_username,WWTango_doorkeeper.WW_localflag,WWTango_doorkeeper.WW_tangogrouplabel,WWTango_doorkeeper.WW_tangosequencenumber,'pointerdefn')
	wwevent.infotype =3;
	wwevent.divxpos = x + WW_localpointer.ptx*WW_pointerfamily_used.scalefactor;
	wwevent.divypos = y + WW_localpointer.pty*WW_pointerfamily_used.scalefactor;
	var label = ' Set Pointer x,y';
	if( redo != 0 )	{
		wwevent.divfamily = WW_pointerfamily_num;
		wwevent.divmood = WW_pointerentry_num;
		wwevent.divscale = WW_pointerfamily_used.scalefactor;
		if( WW_layerishidden(WW_pointerlayer) )
			wwevent.divhide =1;
		else	{
			wwevent.divhide = 0; }
		label = ' Reset Pointer';
		wwevent.innerheight = WW_parentheight;
		wwevent.innerwidth = WW_parentwidth;
	}
	WWTango_dispatch(wwevent,label,flag);
	return;

}	// End WW_sendpointerxy(x,y)

function WWTango_dispatch(wwevent,label,flag)	{

	if(!WW_isitawindow(WWTango_doorkeeper))
		return;
	wwevent.framenumber = WWTango_doorframenumber;
	wwevent.windownumber = WWTango_windownumber;
	var targetlabel = WW_Eventnonmastername;
	if( WW_pointersetupoption >= 10 )
		targetlabel = WW_Eventanyname; 
	WWTango_doorkeeper.WW_accumandsendevent(wwevent,targetlabel,label,flag);
	return;

}	// End WW_dispatch(wwevent,label)

function WW_printerror(mess)	{

	if(!WW_isitawindow(WWTango_doorkeeper))
		return;
	WWTango_doorkeeper.WW_seterrorline(mess);
	return;

}	// End	WW_printerror(mess)

function WW_processlocalqueue()	{ // Run through Queue formed in  Tango_receive

	if(!WW_isitawindow(WWTango_doorkeeper))	{
		++WW_countInterval;
		if(WW_countInterval>100)
			clearInterval(WW_IntervalID);
		return; }
	if((WWTango_status == 0)&&(WW_pointersetupoption < 10))	{	// Kill Master Loop for Pure Pointer
		clearInterval(WW_IntervalID);
		return; }
	if( WW_waitingfortimeout )
		return;
	while( WWTango_doorkeeper.WW_numpointereventsdone  < WWTango_doorkeeper.WW_numallevents)	{
		var receivedevent = WWTango_doorkeeper.WW_eventrecord[WWTango_doorkeeper.WW_numpointereventsdone];
		if( WW_isdefined(receivedevent.processed))	{
			if(receivedevent.processed>0)	{
				++WWTango_doorkeeper.WW_numpointereventsdone;
				continue; }
		}
		if( WW_isdefined(receivedevent.infotype))	{
			if((receivedevent.infotype> 3) || (receivedevent.infotype == 2) )	{
				++WWTango_doorkeeper.WW_numpointereventsdone;
				continue; }
		}	
		if(WW_isundefined(receivedevent.framenumber) || (receivedevent.framenumber == -1) )	{
			if( WWTango_doorframenumber != -1 )
				break;
		}
		else	{
			if( receivedevent.framenumber != WWTango_doorframenumber )
				break;
		}

		++WWTango_doorkeeper.WW_numpointereventsdone ; // Increment Count
		if( WW_isundefined(receivedevent.type))
			continue;
		var outputurltype = receivedevent.type;
		if( (outputurltype != 'pointerdefn')&& (outputurltype != 'card'))
			continue;

		if( outputurltype == 'pointerdefn' )	{	// Check Pointer Event Sequencing
			if(receivedevent.sourceflag != WWTango_doorkeeper.WW_inputsequence)
				continue; // Check Stream
			if(receivedevent.tangogrouplabel < WWTango_doorkeeper.WW_inputgrouplabel )
				continue; // Check Group within Stream
			if(receivedevent.tangogrouplabel > WWTango_doorkeeper.WW_inputgrouplabel )	{
				--WWTango_doorkeeper.WW_numpointereventsdone;
				break; }
		}	// End Pointer Event Sequencing
		
		receivedevent.processed = 1;
		WW_processeventfromtango(receivedevent);
	}

}	// End WW_processlocalqueue()

function WW_processeventfromtango(receivedevent)	{

	var testtype = receivedevent.type;
	if(WW_isundefined(testtype))
		return;
	if( WWTango_windownumber == 1 )	{
		if( receivedevent.windownumber > 1 )	{
			if(	WW_isitawindow(WWTango_windowarray[receivedevent.windownumber-1]) )	{
				WWTango_windowarray[receivedevent.windownumber-1].WW_processeventfromtango(receivedevent);
				return;
			}
			else	{
				receivedevent.processed = 2;
				WW_printerror('Event from Window ' + receivedevent.windownumber + ' discarded');
			}
		}
	}
	else	{
		if( receivedevent.windownumber != WWTango_windownumber  )	{
			receivedevent.processed = 2;
			WW_printerror('Illegal Window Number ' + receivedevent.windownumber + ' in ' + WWTango_windownumber);
		}
	}
			
	if( testtype != 'pointerdefn' )	{
		if( testtype == 'card' )
			WW_processcardevent(receivedevent);
		return;
	}
	if( WWTango_acceptmasterstyle )	{
		var redo = 0;
		if(WW_isdefined(receivedevent.divfamily) && WW_isdefined(receivedevent.divmood ) )	{
			if( (receivedevent.divfamily < WW_pointerfamilyct) && (receivedevent.divfamily >=0) )	{
				if( receivedevent.divfamily != WW_pointerfamily_num )	{
					redo = 1;
					WW_pointerfamily_num = receivedevent.divfamily;
					WW_pointerentry_num = 0; 
					WW_pointersetup(); }
			}
			if( (receivedevent.divmood < parseInt(WW_pointerfamily_used.familyct)) && (receivedevent.divmood >= 0 ) ) {
				if( receivedevent.divmood != WW_pointerentry_num)	{
					redo = 1;
					WW_pointerentry_num = receivedevent.divmood;
					WW_pointersetup(); }
			}
		}
		if(WW_isdefined(receivedevent.divscale))	{
			var curscale = WW_pointerfamily_used.scalefactor;
			var diff =Math.abs(receivedevent.divscale-curscale);
			WW_pointerfamily_used.scalefactor = receivedevent.divscale;
			WW_setcookie("pointerscale",receivedevent.divscale);
			if(diff > .1*curscale)
				redo=1;
		}
		if( redo == 1)	{
			WW_makenewpointer(1); }
	}
	if(WW_isdefined(receivedevent.divxpos)&&WW_isdefined(receivedevent.divypos))	{
		WW_layershiftto(WW_pointerlayer,receivedevent.divxpos - WW_localpointer.ptx*WW_pointerfamily_used.scalefactor,receivedevent.divypos - WW_localpointer.pty*WW_pointerfamily_used.scalefactor);
		if( WW_pointerabolish == 0 )
			WW_layershow(WW_pointerlayer); }
	if(WW_isdefined(receivedevent.divhide) && (WW_pointerabolish == 0) )	{
		if( receivedevent.divhide == 1 )	{
			WW_layerhide(WW_pointerlayer);
			WW_offpointerblock(); }
		else
			WW_layershow(WW_pointerlayer);
	}
	return;

}	// End WW_processeventfromtango(receivedevent)

// *** Start Non Tango General Pointer Package **********************************
// Define Tango Interfaces
// WW_sendpointerparm(x,y,redo,flag)
// WW_updatefullpointerparms(flag)
// WW_initializeTango()
// WWTango_canmovepointer
//	WW_pointersetupoption 
//	WW_gameinprogress

// Define Card Game Interfaces
// 
//	WW_cancardbedragged(localname)
//	WW_endofcarddrag()
//	WW_processclickoncard(curclicked,mouseoption)
//	WW_cardpageisload();
//
// Card Tango Interfaces
//
//	WW_processcardevent(receivedevent);
//	WW_sendcardparm(indextocard,x,y,zval,hideoption,redo,flag)
// 
// Set defaults below
var WW_gameinprogress = false; // True When Game in Progress
var WW_pointersetupoption = 1; // 1 Pointer 11 Card Game
var WW_utilityurlbase = "http://trurl.webwisdom.com/tango2-rel/tango-2.0/applets/sbd/"; // Base for Images used by layers
//var WW_utilityurlbase = "http://www.npac.syr.edu/users/gcf/"; // Base for Images used by layers
var WW_messagecontent1master = ''; // First Master Message can be reset
var WW_messagecontent2master = ''; // Second Master Message can be reset
var WW_messagecontent1nonmaster = ''; // First Non Master Message can be reset
var WW_messagecontent2nonmaster = ''; // Second Non Master Message can be reset
var WW_startpointerhidden = true;
var WW_defaultpointerfamily = 0;
var WW_defaultpointerentry = 0;
var WW_defaulthidemessages = 1;
var WW_defaultpointerabolish = 0;
var WW_defaultpointerscale = 1.0;

var WW_draggedlayer = null; // Layer being dragged as identified by mousedown
var WW_isloaded =0;
var WW_draghappening =0;
var WW_pointerlayer = null;
var WW_indexlayer = null;
var WW_indexlayertoggle = 0;
var WW_countmessages =0;
var WW_hideanywayafterthisnumber = 4;
var WW_messagetotalnumber = 2;
var WW_messagecount = 1;
WW_messageobjectlist = new Array();
var WW_updown =0;
var WW_ctupdown=0;
var WW_ctupdown_last=0;
var WW_xposition=0;
var WW_yposition=0;
var WW_firstxposition=0;
var WW_firstyposition=0;
var WW_hidemessages= WW_defaulthidemessages;
var WW_pointerabolish =0;

function WW_pointerdefn(num,angle,width,height,ptx,pty)	{
	this.num = num;
	this.angle = angle;
	this.width = width;
	this.height = height;
	this.ptx = ptx;
	this.pty = pty;
	this.urladdon = num.toString();

}	// End WW_pointerdefn defining a single pointer

function WW_pointerfamily(urlstem,urlsuffix,familyname,initialscale)	{
	this.urlstem = urlstem;
	this.urlsuffix = urlsuffix;
	this.familyname = familyname;
	this.scalefactor=initialscale;
	this.familyct = WW_pointerfamily.arguments.length;
	this.entries = new Array();
	for(var m =4; m < this.familyct; m++)	{
		this.entries[m-4] = WW_pointerfamily.arguments[m]; }
	this.familyct = this.familyct -4;

}	// End WW_pointerfamily defining a family of pointers at different angles of attack

WW_norkaaddonons = new Array("_normal","_confused","_angry","_cry","_happy","_laugh","_sad","_scared","_shout");

function WW_norkacharfamily(urlstem,familyname,initialscale,width,height)	{
	this.urlstem = urlstem;
	this.urlsuffix = '.gif';
	this.familyname = familyname;
	this.scalefactor=initialscale;
	this.familyct = 9;
	this.entries = new Array();
	for(var m =0; m < this.familyct; m++)	{
		this.entries[m] = new WW_pointerdefn(m,0,width,height,width,0); 
		this.entries[m].urladdon = familyname + WW_norkaaddonons[m]; }

}	// End WW_norkacharfamily defining a family of pointers from Norka's characters

function WW_pointersetup()	{
	WW_pointerfamily_used = WW_pointerfamilyarray[WW_pointerfamily_num];
	WW_setcookie("pointerfamily",WW_pointerfamily_num);
	WW_localpointer = WW_pointerfamily_used.entries[WW_pointerentry_num];
	WW_setcookie("pointerentry",WW_pointerentry_num);
	WW_localpointerurl = WW_pointerfamily_used.urlstem + WW_localpointer.urladdon + WW_pointerfamily_used.urlsuffix;
}	// End WW_pointersetup() Setting up Current Pointer

// Set Current Pointers and their families ************************
WW_hand0 = new WW_pointerdefn(0,0,64,48,60,18);
WW_hand1 = new WW_pointerdefn(1,45,64,46,56,42);
WW_hand2 = new WW_pointerdefn(2,90,48,64,28,62);
WW_hand3 = new WW_pointerdefn(3,135,44,54,0,53);
WW_hand4 = new WW_pointerdefn(4,180,64,48,2,19);
WW_hand5 = new WW_pointerdefn(5,225,44,54,0,0);
WW_hand6 = new WW_pointerdefn(6,270,48,64,28,1);
WW_hand7 = new WW_pointerdefn(7,315,44,54,43,0);
WW_handfamily = new WW_pointerfamily(WW_utilityurlbase + "whiteboard/pointers/realhand/",".gif","realhand",1.0,WW_hand0,WW_hand1,WW_hand2,WW_hand3,WW_hand4,WW_hand5,WW_hand6,WW_hand7); 
WW_redhand0 = new WW_pointerdefn(0,0,58,35,58,10);
WW_redhand1 = new WW_pointerdefn(1,45,58,58,50,50);
WW_redhand2 = new WW_pointerdefn(2,90,58,58,35,58);
WW_redhand3 = new WW_pointerdefn(3,135,58,58,10,50);
WW_redhand4 = new WW_pointerdefn(4,180,58,35,1,23);
WW_redhand5 = new WW_pointerdefn(5,225,58,58,5,11);
WW_redhand6 = new WW_pointerdefn(6,270,58,58,22,1);
WW_redhand7 = new WW_pointerdefn(7,315,58,58,38,0);
WW_redhandfamily = new WW_pointerfamily(WW_utilityurlbase + "whiteboard/pointers/redhand/",".gif","redhand",1.0,WW_redhand0,WW_redhand1,WW_redhand2,WW_redhand3,WW_redhand4,WW_redhand5,WW_redhand6,WW_redhand7);
WW_yellowhand0 = new WW_pointerdefn(0,0,60,37,60,10);
WW_yellowhand1 = new WW_pointerdefn(1,45,60,60,51,51);
WW_yellowhand2 = new WW_pointerdefn(2,90,60,60,35,60);
WW_yellowhand3 = new WW_pointerdefn(3,135,60,60,10,53);
WW_yellowhand4 = new WW_pointerdefn(4,180,60,60,1,37);
WW_yellowhand5 = new WW_pointerdefn(5,225,60,60,7,11);
WW_yellowhand6 = new WW_pointerdefn(6,270,60,60,23,1);
WW_yellowhand7 = new WW_pointerdefn(7,315,60,60,43,3);
WW_yellowhandfamily = new WW_pointerfamily(WW_utilityurlbase + "whiteboard/pointers/yellowhand/",".gif","yellowhand",1.0,WW_yellowhand0,WW_yellowhand1,WW_yellowhand2,WW_yellowhand3,WW_yellowhand4,WW_yellowhand5,WW_yellowhand6,WW_yellowhand7);
WW_whitehand0 = new WW_pointerdefn(0,0,58,35,58,10);
WW_whitehand1 = new WW_pointerdefn(1,45,58,58,50,50);
WW_whitehand2 = new WW_pointerdefn(2,90,58,58,35,58);
WW_whitehand3 = new WW_pointerdefn(3,135,58,58,10,50);
WW_whitehand4 = new WW_pointerdefn(4,180,58,35,1,23);
WW_whitehand5 = new WW_pointerdefn(5,225,58,58,5,11);
WW_whitehand6 = new WW_pointerdefn(6,270,58,58,22,1);
WW_whitehand7 = new WW_pointerdefn(7,315,58,58,38,0);
WW_whitehandfamily = new WW_pointerfamily(WW_utilityurlbase + "whiteboard/pointers/whitehand/",".gif","whitehand",1.0,WW_whitehand0,WW_whitehand1,WW_whitehand2,WW_whitehand3,WW_whitehand4,WW_whitehand5,WW_whitehand6,WW_whitehand7);

WW_redarrow0 = new WW_pointerdefn(0,0,38,18,38,9);
WW_redarrow1 = new WW_pointerdefn(1,45,28,33,28,33);
WW_redarrow2 = new WW_pointerdefn(2,90,20,40,10,40);
WW_redarrow3 = new WW_pointerdefn(3,135,36,26,0,26);
WW_redarrow4 = new WW_pointerdefn(4,180,38,18,38,9);
WW_redarrow5 = new WW_pointerdefn(5,225,30,34,0,0);
WW_redarrow6 = new WW_pointerdefn(6,270,20,41,10,0);
WW_redarrow7 = new WW_pointerdefn(7,315,34,33,34,0);
WW_redarrowfamily = new WW_pointerfamily(WW_utilityurlbase + "whiteboard/pointers/redarrow/",".gif","redarrow",1.0,WW_redarrow0,WW_redarrow1,WW_redarrow2,WW_redarrow3,WW_redarrow4,WW_redarrow5,WW_redarrow6,WW_redarrow7);
WW_oldhand0 = new WW_pointerdefn(0,0,27,17,27,0);
WW_oldhandfamily = new WW_pointerfamily(WW_utilityurlbase + "whiteboard/pointers/oldhand",".gif","oldhand",1.0,WW_oldhand0);
WW_alien = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/alien/","alien",0.5,200,250);
WW_baby = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/baby/","baby",1.0,78,90);
WW_daniel = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/daniel/","daniel",0.5,147,240);
WW_ghost = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/ghost/","ghost",0.5,206,250);
WW_jenny = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/jenny/","jenny",0.5,117,185);
WW_jerry = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/jerry/","jerry",0.5,137,190);
WW_kily = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/kily/","kily",0.5,175,250);
WW_marsian = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/marsian/","marsian",0.5,171,260);
WW_rosie = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/rosie/","rosie",0.5,153,250);
WW_sarah = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/sarah/","sarah",0.5,116,250);
WW_snake = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/snake/","snake",0.5,177,200);
WW_tom = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/characters/tom/","tom",0.5,187,250);
WW_psforacle = new WW_norkacharfamily(WW_utilityurlbase + "WWgamedata/oracles/","2oracle",1.0,70,106);

WW_pointerfamilyarray = new Array();
WW_pointerfamilyarray[0] = WW_handfamily;
WW_pointerfamilyarray[1] = WW_redhandfamily;
WW_pointerfamilyarray[2] = WW_yellowhandfamily;
WW_pointerfamilyarray[3] = WW_whitehandfamily;
WW_pointerfamilyarray[4] = WW_redarrowfamily;
WW_pointerfamilyarray[5] = WW_oldhandfamily;
WW_pointerfamilyarray[6] = WW_alien;
WW_pointerfamilyarray[7] = WW_baby;
WW_pointerfamilyarray[8] = WW_daniel;
WW_pointerfamilyarray[9] = WW_ghost;
WW_pointerfamilyarray[10] = WW_jenny;
WW_pointerfamilyarray[11] = WW_jerry;
WW_pointerfamilyarray[12] = WW_kily;
WW_pointerfamilyarray[13] = WW_marsian;
WW_pointerfamilyarray[14] = WW_rosie;
WW_pointerfamilyarray[15] = WW_sarah;
WW_pointerfamilyarray[16] = WW_snake;
WW_pointerfamilyarray[17] = WW_tom;
WW_pointerfamilyarray[18] = WW_psforacle;
// End Set Current Pointers and their families *********************

var WW_pointerfamilyct = WW_pointerfamilyarray.length;
var WW_pointerfamily_num = 0;
var WW_pointerentry_num = 0;
var WW_pointerfamily_used = WW_pointerfamilyarray[WW_pointerfamily_num];
var WW_localpointer = WW_pointerfamily_used.entries[WW_pointerentry_num];
var WW_localpointerurl = WW_pointerfamily_used.urlstem + WW_localpointer.urladdon + WW_pointerfamily_used.urlsuffix;

function WW_startdrag(e)	{ // Mouse Down

	++WW_ctupdown;
	WW_updown =1;
	var clickX = WW_eventx(e);
	var clickY = WW_eventy(e);
	WW_xposition = clickX;
	WW_yposition = clickY;
	WW_firstxposition = WW_xposition;
	WW_firstyposition = WW_yposition;
	var mouseoption = WW_mousemodifiers(e);
	localobject = WW_getclickedobject(clickX,clickY);
	
// If Right Mouse Ignore unless Pointer Defined and on Pointer
	if( WW_rightmouse(e) )	{ // Right Mouse Processing
		WW_draghappening =0;
		if( WW_pointerlayer == null )
			return true;
		if( WW_pointerlayer != localobject )
			return true;
		return WW_setindexlayer(mouseoption);
	}	// End Right Mouse Processing

// If Modified Mouse (Shift ALT CTRL) Then not a drag but a click and so unset Drag
	if( mouseoption > 0 )	{
		WW_draghappening =0;
		return true; }

//	Potential Drag	
	if(WW_isdefined(localobject))	{
		if(WW_isundefined(WW_pointerlayer) || (WW_pointerlayer!= localobject)) {		
			if(!WW_canitbedragged(localobject))	{
				WW_cleanupdrag();	// Mouse Down on defined layer which cannot be dragged
				return true; }
			window.status= 'Start Drag - ' +  localobject.id;
		}
		WW_draggedlayer = localobject;
		if( WW_layerishidden(WW_draggedlayer) )	{	// Mouse Down on Hidden Layer
			var amount = 75;
			if( WW_draggedlayer == WW_pointerlayer )
				amount = 80;
			if(WW_Netscape4)	{
				if( WW_draghappening == 1)	{
					window.releaseEvents(Event.KEYDOWN);
					if(WWTango_canmovepointer)
						WW_draggedlayer.releaseEvents(Event.MOUSEMOVE);
					}
			}
			else	{
				document.onkeydown = null; }
			WW_draghappening = 0;
			window.status= 'Key Down on Hidden Object NO Drag ' + localobject.id;
			return true;
		}	// End section for Mouse Down on Hidden Layer
		if(WW_Netscape4)	{
			if( WW_pointerlayer == WW_draggedlayer )	{
				window.captureEvents(Event.KEYDOWN );
				if(WWTango_canmovepointer)
					WW_pointerlayer.captureEvents(Event.MOUSEMOVE ); }
			else	{
				if(WWTango_canmovepointer)
					WW_draggedlayer.captureEvents(Event.MOUSEMOVE);
			}
		}
		if(WWTango_canmovepointer)
			WW_draggedlayer.onmousemove = WW_processdrag;
		if( WW_pointerlayer == WW_draggedlayer )	{
			if(WW_Netscape4)        {
				window.onkeydown = WW_processkeydown; }
			else	{
				document.onkeydown = WW_processkeydown; }
		}	
		WW_draghappening = 1;
		WW_layertotop(WW_draggedlayer);
		window.status = 'Start Moving ' + WW_draggedlayer.id;
		return true;
		
	}	// End Block for defined Object with Mouse down

// Mouse Down in No-Mans Land Unset Everything
	WW_cleanupdrag();
	return true;

}	// End WW_startdrag(e)

function WW_cleanupdrag()	{

	WW_draghappening =0;
	if(WW_isdefined(WW_draggedlayer))	{
		window.status = 'Drag Ended for ' + WW_draggedlayer.id;
		if(WW_Netscape4)        {
			if( WW_pointerlayer == WW_draggedlayer )	{
				window.releaseEvents(Event.KEYDOWN);
				if(WWTango_canmovepointer)
					WW_pointerlayer.releaseEvents(Event.MOUSEMOVE); }
			else	{
				if(WWTango_canmovepointer)
					WW_pointerlayer.releaseEvents(Event.MOUSEMOVE); }
		}
		else	{	// Microsoft
			 document.onkeydown = null;
		}
		var amount = 75;
		if( WW_draggedlayer == WW_pointerlayer)
			amount = 80;
		WW_layertogeneric(WW_draggedlayer,amount);
		if( WW_pointerlayer == WW_draggedlayer )
			WW_offpointerblock();
		WW_draggedlayer = null;
	}
	return true;

}	// End WW_cleanupdrag()

function WW_getclickedobject(xval,yval)	{

	var localobject;
	if(WW_Netscape4)	{
		for(var i=document.layers.length-1; i>=0; i--)	{
			localobject = document.layers[i];
			if( (xval > localobject.left) && ( xval < localobject.left+localobject.clip.width) && (yval > localobject.top) && ( yval < localobject.top+localobject.clip.height) )
				return localobject;
		}
	}
	else	{ // Internet Explorer
		return window.event.srcElement.parentElement;
	}

}	// End WW_getclickedobject(xval,yval)

function WW_canitbedragged(layerobject)	{

	if( WW_isundefined(layerobject))
		return false;
	var localname = layerobject.id;
	if( WW_cancardbedragged(localname))
		return true;
	if( localname == 'WWpointerblock')
		return true;
	return false;

}	// End WW_canitbedragged(layerobject)

//	Process Key Down
function WW_processkeydown(e)	{

	WW_ctupdown_last = WW_ctupdown;
	WW_updown=0;
	WW_draghappening =0;
	var keypressed =0;
	if( WW_Netscape4)	{
		keypressed = e.which}
	else	{
		keypressed = window.event.keyCode;
		if( (keypressed >= 16) && (keypressed <= 18) )
			return true;
	}
	var localflag = String.fromCharCode(keypressed);
	window.status = 'Keydown ' + localflag + ' ' + keypressed;

// Cycle Through Possibilities for Specifying Pointer
	var redo =0;
	if( localflag == 'h' || localflag == 'H' )	{
		WW_hidemessages =1;
		WW_countmessages = 0;
		WW_setcookie("hidemessages",WW_hidemessages);
		WW_offpointerblock(); 
		return true; }
	if( localflag == 'm' || localflag == 'M' )	{
		WW_hidemessages =0;
		WW_countmessages = 0;
		WW_setcookie("hidemessages",WW_hidemessages);
		WW_overpointerblock();
		return true; }
	if( localflag == 'a' || localflag == 'A' )      {
		WW_pointerabolish = 1;
		WW_setcookie("pointerabolish",WW_pointerabolish);
		WW_layerhide(WW_pointerlayer);
		WW_offpointerblock();
		return true; }

// Process WWindexlayer
	if( localflag == 'i'  || localflag == 'I' )      {
		return WW_setindexlayer(0); }
	if( localflag == 'j' || localflag == 'J' )      {
		return WW_setindexlayer(1); }

	if(!WWTango_canchangepointer)
		return true; // cannot allow change in pointer or cards

//	Process Cards
	if(WW_processcardkeydown(localflag))
		return true;

//	Process Pointer Images
	if( localflag == 'f' || localflag == 'F' )	{
		WW_pointerfamily_num++;
		if( WW_pointerfamily_num >= WW_pointerfamilyct )
			WW_pointerfamily_num = 0;
		WW_pointerentry_num = 0;
		WW_pointersetup();
		redo =1;
	}
	var fwidth = WW_pointerfamily_used.scalefactor;
	if( localflag == 'c' || localflag == 'C' )	{
                ++WW_pointerentry_num;
                if(parseInt(WW_pointerentry_num) >= parseInt(WW_pointerfamily_used.familyct) )
                        WW_pointerentry_num = 0;
                WW_pointersetup();
		redo =1;
	}
	if( localflag == 'u' || localflag == 'U' )	{
                fwidth = fwidth * 2.;
                if( fwidth > 8. )
                        fwidth=8.;
		redo =2;
	}
	if( localflag == 'd' || localflag == 'D' )	{
                fwidth = fwidth * 0.5;
                if(fwidth < .25)
                        fwidth =0.25;
		redo =2;
	}
	if(redo == 0 )
		return true;
	WW_pointerfamily_used.scalefactor = fwidth;
	WW_setcookie("pointerscale",fwidth);
	if(WW_Netscape4)	{
		window.releaseEvents(Event.KEYDOWN);
		WW_pointerlayer.releaseEvents(Event.MOUSEMOVE); }
	WW_makenewpointer(redo);
	var ex = WW_eventx(e);
	var ey = WW_eventy(e);
	var delx = WW_localpointer.width*WW_pointerfamily_used.scalefactor*.5;
	var dely = WW_localpointer.height*WW_pointerfamily_used.scalefactor*.5;
	WW_layershiftto(WW_pointerlayer,ex-delx,ey-dely);
	WW_sendpointerparm(ex-delx,ey-dely,redo,1);
	WW_offpointerblock();
	if(WW_Netscape4)	{
		window.captureEvents(Event.KEYDOWN );
		if( WWTango_canmovepointer )
			WW_pointerlayer.captureEvents(Event.MOUSEMOVE); 
		window.onkeydown = WW_processkeydown;
	}
	else	{
		document.onkeydown = WW_processkeydown;
        }
	WW_pointerlayer.onmousemove = WW_processdrag;
	return true;

}	// End WW_processkeydown(e)

function WW_processdrag(e)	{ // Mouse Move

	if(!WWTango_canmovepointer )	{
		WW_offpointerblock();
		return; }
	WW_updown =0;
	if(WW_draghappening == 0 )
		return true;
	if( WW_draggedlayer == null )
		return true;
	window.status= 'dragging ' + WW_draggedlayer.id;
	WW_offpointerblock();
	var ex = WW_eventx(e);
	var ey = WW_eventy(e);
	WW_layershiftby(WW_draggedlayer,ex-WW_xposition,ey-WW_yposition)
	WW_xposition = ex;
	WW_yposition = ey;
	return false;

}	// End WW_processdrag(e))

function WW_enddrag(e)	{ // Mouse Up

	if( !WWTango_canmovepointer )	{
		WW_offpointerblock();
		window.status = 'User Click';
		return WW_internalclick(e); }
	var savelayer = WW_draggedlayer;
	WW_cleanupdrag();
	var ex = WW_eventx(e);
	var ey = WW_eventy(e);
	if( (ex > WW_firstxposition-5) && (ex < WW_firstxposition+5) && (ey > WW_firstyposition-5) && (ey < WW_firstyposition+5) ) {
		window.status = 'User Click';
		return WW_internalclick(e); }
	window.status = 'Stop';
	WW_ctupdown_last = WW_ctupdown;
	WW_updown=0;
	WW_draghappening =0;

//	End of a Proper Drag NOT a Click -- send Pointer or card Parameters to Tango if necessary
	if(WW_isdefined(WW_pointerlayer) && (WW_pointerlayer == savelayer))
		WW_sendpointerparm(WW_getlayerleft(WW_pointerlayer),WW_getlayertop(WW_pointerlayer),0,1);
	WW_endofcarddrag(savelayer);
	return true;

}	// End  WW_enddrag(e)

function WW_processclick(e)	{ // System Click

	if( WW_draghappening > 0 )	{
		WW_enddrag(e);
		return true; }
	WW_draghappening=0;
	if( WW_ctupdown == WW_ctupdown_last)	{
		window.status = 'Vetoed Click';
		if( WW_Netscape4)	{ // Check if Form Click
			var targetev = e.target;
			if(WW_isdefined(targetev))	{
				var fromform = targetev.form;
				if(WW_isdefined(fromform))	{
					return routeEvent(e);
				}
				if(WW_isdefined(targetev.href))	{	// Link click
					return routeEvent(e);
				}
			}
		}
	}
	else	{
		window.status = 'System click'; }
	return WW_internalclick(e);

}	// End WW_processclick(e)

function WW_internalclick(e)	{ // Process System or User Click without duplication

	if( WW_ctupdown == WW_ctupdown_last)
	        return true;
	WW_ctupdown_last = WW_ctupdown;
	WW_updown =0;
	if( WW_rightmouse(e) )	{
		return true; }
	if( WW_Netscape4)	{ // Check if Form or Link Click
		var targetev = e.target;
		if(WW_isdefined(targetev))	{
			var fromform = targetev.form;
			if(WW_isdefined(fromform))	{
				return routeEvent(e);
			}
			if(WW_isdefined(targetev.href))	{
				return routeEvent(e);
			}
		}
	}
	var mouseoption = WW_mousemodifiers(e);
	if( WW_pointerabolish == 1 )	{
		if( mouseoption == 2 ) {	// CTRL + Click Toggles Pointer
			if(WW_isdefined(WW_pointerlayer) )
				WW_layershow(WW_pointerlayer);
			mouseoption = 0;
			WW_pointerabolish = 0;
			WW_setcookie("pointerabolish",WW_pointerabolish); }
		else	{
			return true; }
	}
	var clickX = WW_eventx(e);
	var clickY = WW_eventy(e);
	var curclicked = WW_getclickedobject(clickX,clickY);
	if(WW_isundefined(WW_pointerlayer) || (WW_pointerlayer != curclicked) )	{
		if(WW_processclickoncard(curclicked,mouseoption))
			return true;
	}
	if(WW_isdefined(WW_pointerlayer))	{	// Process Pointer
		if( (WW_pointerlayer == curclicked) && (!WW_layerishidden(WW_pointerlayer)) )	{
			if( mouseoption == 0 )	{
				WW_layertobottom(WW_pointerlayer);
				WW_layerhide(WW_pointerlayer);
				WW_updatefullpointerparms(1);
				WW_offpointerblock(); }
			if( mouseoption == 1)	{
				if( WW_hidemessages == 0 )	{
					WW_countmessages = 0;
					WW_hidemessages = 1;
					WW_setcookie("hidemessages",WW_hidemessages);
					WW_offpointerblock(); }
				else	{
					WW_hidemessages = 0;
					WW_countmessages = 0;
					WW_setcookie("hidemessages",WW_hidemessages);
					WW_overpointerblock(); }
			}
			if( mouseoption == 2 )	{
				WW_pointerabolish = 1;
				WW_setcookie("pointerabolish",WW_pointerabolish);
				WW_layerhide(WW_pointerlayer);
				WW_offpointerblock();
			}
			if( (mouseoption == 4) && WWTango_canchangepointer )	{
				WW_pointerfamily_num++;
				if( WW_pointerfamily_num >= WW_pointerfamilyct )
					WW_pointerfamily_num = 0;
				WW_pointerentry_num = 0;
				WW_pointersetup();
				WW_makenewpointer(1);
				var delx = WW_localpointer.width*WW_pointerfamily_used.scalefactor*.5;
				var dely = WW_localpointer.height*WW_pointerfamily_used.scalefactor*.5;
				WW_layershiftto(WW_pointerlayer,clickX-delx,clickY-dely);
				WW_sendpointerparm(clickX-delx,clickY-dely,1,1);
				WW_offpointerblock();
			}
			return true; 
		}
		if( !WWTango_canchangepointer )
			return true;
		if( (!WWTango_canmovepointer)||(mouseoption>0) )	{ // Restore to old position
			clickX = WW_getlayerleft(WW_pointerlayer)+WW_localpointer.ptx*WW_pointerfamily_used.scalefactor;
			clickY = WW_getlayertop(WW_pointerlayer)+WW_localpointer.pty*WW_pointerfamily_used.scalefactor;
		}
		var fwidth = WW_pointerfamily_used.scalefactor;
	        if( mouseoption == 1)   {
	                ++WW_pointerentry_num;
	                if(parseInt(WW_pointerentry_num) >= parseInt(WW_pointerfamily_used.familyct) )
	                        WW_pointerentry_num = 0;
	                WW_pointersetup();
	        }
	        if( mouseoption == 2)   {
	                fwidth = fwidth * 2.;
	                if( fwidth > 8. )
	                        fwidth=8.;
	        }
	        if( mouseoption == 4)   {
	                fwidth = fwidth * 0.5;
	                if(fwidth < .25)
	                        fwidth =0.25;
	        }
	        WW_pointerfamily_used.scalefactor = fwidth;
		WW_setcookie("pointerscale",fwidth);
		WW_makenewpointer(mouseoption);
		WW_layershiftto(WW_pointerlayer,clickX-WW_localpointer.ptx*WW_pointerfamily_used.scalefactor,clickY-WW_localpointer.pty*WW_pointerfamily_used.scalefactor);
		WW_sendpointerparm(clickX-WW_localpointer.ptx*WW_pointerfamily_used.scalefactor,clickY-WW_localpointer. pty*WW_pointerfamily_used.scalefactor,mouseoption,1);
	}	// End Processing Click on Pointer
	return true;

}	// End WW_internalclick(e)

function WW_rightmouse(e)	{

	if(WW_Netscape4)	{
		var testit = e.which;
		if(WW_isundefined(testit))
			return false;
		if(testit ==1)
			return false;
		window.status ='Right Mouse';
		return true;
	}
	return false;
	
}	// End WW_rightmouse(e)
	

function WW_mousemodifiers(e)	{ // Interpret Mouse Modifiers

	var mouseoption =0;
	if(WW_Netscape4)	{
	        var testit = e.modifiers;
			if(WW_isundefined(testit))
				return mouseoption;
	        if( testit == Event.ALT_MASK )
	                mouseoption = 1;
	        if( testit == Event.CONTROL_MASK)
	                mouseoption = 2;
	        if( testit == Event.SHIFT_MASK)
	                mouseoption = 4;
	}
	else	{
		var actualevent = window.event;
		if( actualevent.altKey )
			mouseoption = 1;
		if( actualevent.ctrlKey )
			mouseoption = 2;
		if( actualevent.shiftKey )
			mouseoption = 4;
	}
	return mouseoption;

}	// End WW_mousemodifiers(e)

function WW_makenewpointer(option)	{	// Set up new Pointer size/image/orientation

	if(WW_isundefined(WW_pointerlayer))
		return;
	if(option > 0 )	{
		var totalwidth = WW_pointerfamily_used.scalefactor*WW_localpointer.width;
		if(WW_Netscape4)	{
		        WW_pointerlayer.document.open();
		        WW_pointerlayer.document.writeln('<img src="' + WW_localpointerurl + '" width="' + totalwidth.toString() + '" ></img>');
		        WW_pointerlayer.document.close();
		}
		else	{
			WW_pointerlayer.innerHTML = '<img src="' + WW_localpointerurl + '" width="' + totalwidth.toString() + '" ></img>';
			WW_pointerlayer.style.width = totalwidth;
		}
	}
	WW_layertotop(WW_pointerlayer);
	WW_layershow(WW_pointerlayer);
	WW_pointerlayer.onmouseover = WW_overpointerblock;
	WW_pointerlayer.onmouseout = WW_offpointerblock;
		return;

}	// End WW_makenewpointer(option)

function WW_overpointerblock()	{ // Mouse Over Pointer or Message shown

	if(WW_hidemessages == 1 )
		return true;
        if( WW_countmessages > WW_hideanywayafterthisnumber )      {
                WW_hidemessages = 1;
		WW_countmessages = 0;
                return true;
        }
	++WW_countmessages;
	if(WW_isundefined(WW_pointerlayer))
		return true;
	if( WW_layerishidden(WW_pointerlayer))
		return true;
	++WW_messagecount;
	if(WW_messagecount>=WW_messagetotalnumber)
		WW_messagecount=0;
	WW_messageobject = WW_messageobjectlist[WW_messagecount];
	if(WW_isundefined(WW_messageobject))
		return true;
	WW_displaymessage();
	return true;

} // End WW_overpointerblock()

function WW_displaymessage()	{

	var XY = WW_positionrelative(WW_pointerlayer,WW_messageobject,self);
	WW_layershow(WW_messageobject);
	WW_layertotop(WW_messageobject);
	WW_setbackgroundcolor(WW_messageobject,'peachpuff');
	WW_layershiftto(WW_messageobject,XY.left,XY.top);
	return true;

} // End WW_displaymessage()

function WW_offpointerblock()  { // Mouse leaves Pointer or Message Abolished
	for( var m=0; m < WW_messagetotalnumber; m++)	{
		if(!WW_isundefined(WW_messageobjectlist[m]))
			WW_layerhide(WW_messageobjectlist[m]);
	}
	return true;

}	// End WW_offpointerblock()

// Toggle Index Layer -- option is nonzero to align with top of Scrolled Page
// Return false if processed
function WW_setindexlayer(option)	{

	if(WW_isundefined(WW_indexlayer))
		return true;
	WW_indexlayertoggle = 1-WW_indexlayertoggle;
	if( WW_indexlayertoggle == 0 )
		WW_layerhide(WW_indexlayer);
	else	{
		var zval = 1000;
		if(WW_isdefined(WW_pointerlayer))
			zval = WW_getlayerzindex(WW_pointerlayer)-1;
		if(zval <=0)
			zval = 50;
		WW_layertogeneric(WW_indexlayer,zval);
		WW_setbackgroundcolor(WW_indexlayer,'white');
		if(option > 0 )	{
			WW_scrolllayershiftto(WW_indexlayer,0,0); }
		else	{
			WW_layershiftto(WW_indexlayer,0,0); }
		WW_layershow(WW_indexlayer);
	}
	return false;

}	// End WW_setindexlayer(option)

function WW_setcapture()	{

	if( WW_Netscape4 )	{
		window.captureEvents(Event.MOUSEDOWN | Event.MOUSEUP | Event.CLICK);
		window.onmousedown=WW_startdrag;
		window.onmouseup=WW_enddrag;
		window.onclick=WW_processclick;
	}
	else	{
		document.onmousedown=WW_startdrag;
		document.onmouseup=WW_enddrag;
		document.onclick=WW_processclick;
	}
	return true;

}	// End WW_setcapture()

function WW_pageisloaded()	{ 	// Initialize when page loaded

	if(WW_oldbrowser)	{
		WW_isloaded=1;
		return; }
	WW_setcapture();
	WW_pointerlayer = WW_getlayer('WWpointerblock');
	WW_indexlayer = WW_getlayer('WWindexpage');
	if(WW_isdefined(WW_pointerlayer))	{
		WW_pointerlayer.onmouseover = WW_overpointerblock;
		WW_pointerlayer.onmouseout = WW_offpointerblock;
	}
	WW_messagecontent1master = '<b>Master Pointer Mode</b><br>Click outside pointer rectangle to move<br>Click on Pointer to Hide<br>Click on Pointer + ALT to toggle message hiding<br>Click on Pointer + CNTL to abolish pointer<br>Click on Pointer + Shift to cycle families<br>Click outside + Alt is Change Image<br>Click outside + Control is Double Size<br>Click outside + Shift is Halve Size';
	WW_messagecontent2master = '<b>Master Pointer Mode</b><br>Mouse Move on non pointer object gives confused Browser!<br>Cure with Mouse-Down and Up in No Mans Land<br>With Mouse Down on Current Pointer<br><b>h</b> hides This Message while <b>m</b> restores<br><b>a</b> Abolishes Pointer while <b>CNTL-Click</b> restores<br><b>f</b> cycles through pointer families<br><b>c</b> cycles through members of a family<br><b>u</b> increases Size Up and <b>d</b> decreases Down<br><b>Mouse Up-Down between changes of <br>Pointer to process new option</b>';
	WW_messagecontent1nonmaster = '<b>Followed Pointer Mode</b><br>Use Dialog Window to Control Pointer Image Choice<br>Click outside pointer rectangle<br> to delete message or restore<br>Click on Pointer to Hide<br>Click on Pointer + ALT to toggle message hiding<br>Click on Pointer + CNTL to abolish pointer<br>Click on Pointer + Shift to cycle families<br>Click outside + Alt is Change Image<br>Click outside + Control is Double Size<br>Click outside + Shift is Halve Size';
	WW_messagecontent2nonmaster = '<b>Followed Pointer Mode</b><br>With Mouse Down on Current Pointer<br><b>h</b> hides This Message while <b>m</b> restores<br><b>a</b> Abolishes Pointer while <b>CNTL-Click</b> restores<br><b>f</b> cycles through pointer families<br><b>c</b> cycles through members of a family<br><b>u</b> increases Size Up and <b>d</b> decreases Down<br><b>Mouse Up-Down between changes of <br>Pointer to process new option</b>';

	WW_messageobjectlist[0] = WW_getlayer('WWpointermessage1');
	WW_messageobjectlist[1] = WW_getlayer('WWpointermessage2');
	WW_messageobject = WW_messageobjectlist[0];
	if(!WW_Netscape4 )	{
		if( !WW_isundefined(WW_messageobjectlist[0]) )
			WW_messageobjectlist[0].style.width =300;
		if( !WW_isundefined(WW_messageobjectlist[1]) )
			WW_messageobjectlist[1].style.width =300;
	}

//	Process Cookies ************************
	WW_pointerfamily_num = parseInt(WW_getCookie("pointerfamily",WW_defaultpointerfamily));
	if(WW_pointerfamily_num < 0 )
		WW_pointerfamily_num =0;
	if(WW_pointerfamily_num >= WW_pointerfamilyct)
		WW_pointerfamily_num = WW_pointerfamilyct-1;
	WW_setcookie("pointerfamily",WW_pointerfamily_num);
	WW_pointerfamily_used = WW_pointerfamilyarray[WW_pointerfamily_num];
	WW_pointerentry_num = parseInt(WW_getCookie("pointerentry",WW_defaultpointerentry));
	if(WW_pointerentry_num < 0 )
		WW_pointerentry_num =0;
	if(WW_pointerentry_num >= parseInt(WW_pointerfamily_used.familyct))
		WW_pointerentry_num = parseInt(WW_pointerfamily_used.familyct)-1;
	WW_setcookie("pointerentry",WW_pointerentry_num);
	WW_pointersetup();
	var pointerscale = parseFloat(WW_getCookie("pointerscale",WW_defaultpointerscale));
	if(pointerscale < 0.125 )
		pointerscale = 0.125;
	if(pointerscale >=  8.0 )
		pointerscale = 8.0;
	WW_setcookie("pointerscale",pointerscale);
	WW_pointerfamily_used.scalefactor = pointerscale;
	WW_makenewpointer(1);
	if(WW_startpointerhidden)
		WW_layerhide(WW_pointerlayer);
	WW_pointerabolish =  parseInt(WW_getCookie("pointerabolish",WW_defaultpointerabolish));
	if( WW_pointerabolish != 1 )
		WW_pointerabolish == 0;
	WW_setcookie("pointerabolish",WW_pointerabolish);
	if( WW_pointerabolish == 1 )
		WW_layerhide(WW_pointerlayer);
	WW_hidemessages =  parseInt(WW_getCookie("hidemessages",WW_defaulthidemessages));
	if( WW_hidemessages != 1 )
		WW_hidemessages == 0;
	WW_setcookie("hidemessages",WW_hidemessages);
	if( WW_hidemessages == 1 )
		WW_offpointerblock();
		
// Optional Initialization of Card Game
	WW_cardpageisload();

//	Register if possible
	if(WW_pageisloaded.arguments.length > 0 )	{
		if(WW_pageisloaded.arguments[1])
			WW_initializeTango(); }
	else	{
		WW_initializeTango(); }
	WW_isloaded =1;
	return;
	
}	// End WW_pageisloaded()

// ********************************************************************************************
// Start of Real Card section *****************************************************************

// divoption = 1
// Input x,y is top,left of current card
function WW_sendcardparm(indextocard,x,y,zval,hideoption,flag)	{

	if(!WWTango_transmit )
		return;
	var seq = WWTango_doorkeeper.WW_newgamelabel(0);
	wwevent = new WW_generatedevent(WWTango_doorkeeper.WW_username,WWTango_doorkeeper.WW_gamestream,WWTango_doorkeeper.WW_gamegroup,seq,"card");
	wwevent.infotype = 3;
	wwevent.divoption = 1;
	wwevent.divindex = indextocard;
	wwevent.divxpos = x;
	wwevent.divypos = y;
	wwevent.divzindex = zval;
	wwevent.divhide = hideoption;
	wwevent.divstatus = WW_cardstatus[indextocard];
	wwevent.divowner = WW_cardowner[indextocard];
	wwevent.divrole1 = WW_cardrole1[indextocard];
	wwevent.divrole2 = WW_cardrole2[indextocard];
	wwevent.playernumber = WW_playermoving;
	var label = ' Set Card x,y,status,hide';
	WWTango_dispatch(wwevent,label,flag);
	return;

}	// End WW_sendcardparm(indextocard,x,y,redo,flag)

//	Process a Card Event and direct away cases if divoption is not 1
//	divoption = 1 justs moves and turns/hides/shows card
function WW_processcardevent(receivedevent)	{

	var divoption = receivedevent.divoption;
	if(divoption >= 999)	{
		WW_getgamedata(receivedevent);
		return;
	}
	if( divoption == 2 )	{
		WW_getcardfamilydata(receivedevent);
		return;
	}
	if( divoption > 10 )	{
		WW_getgeneralcardoption(receivedevent);
		return;
	}
	var cardindex = receivedevent.divindex;
	if( (cardindex < 0 ) || (cardindex >= WW_carddecksize) )	{	// Illegal Index
		WWTango_doorkeeper.WW_seterrorline(' Illegal Card index ' + cardindex);
		return false;
	}
	WW_cardowner[cardindex] = receivedevent.divowner;
	WW_cardrole1[cardindex] = receivedevent.divrole1;
	WW_cardrole2[cardindex] = receivedevent.divrole2;
	var locallayer = WW_cardlayers[cardindex];
	var newstatus = receivedevent.divstatus;
	var oldstatus = WW_cardstatus[cardindex];
	if( oldstatus != newstatus )	{
		WW_cardstatus[cardindex] = newstatus;
		if( newstatus == 1 )	{ // turn to front
			WW_changecard(locallayer,WW_listofcardurls[cardindex],1); }
		if( newstatus == 0 )	{ // turn to back
			WW_changecard(locallayer,WW_currentcardbackurl,1); }
	}
	if( receivedevent.divhide > 0 )	{ // Hide Card
		WW_layerhide(locallayer); }
	else	{
		WW_layershow(locallayer); }
	WW_layertogeneric(locallayer,receivedevent.divzindex);
	if( !WW_ignoretangocardposition )
		WW_layershiftto(locallayer,receivedevent.divxpos,receivedevent.divypos);
	return true;

}	// End WW_processcardevent(receivedevent)

//	divoption = 2
//	Send Card Family Data
function WW_sendcardfamilydata(flag)	{

	if( WWTango_status != 0 )
		return;
	var seq = WWTango_doorkeeper.WW_newgamelabel(0);
	wwevent = new WW_generatedevent(WWTango_doorkeeper.WW_username,WWTango_doorkeeper.WW_gamestream,WWTango_doorkeeper.WW_gamegroup,seq,"card");
	wwevent.infotype = 3;
	wwevent.divoption = 2;
	wwevent.divfamily = WW_cardfamily_num;
	wwevent.divback = WW_cardback_used;
	wwevent.divscale = WW_cardfamily_used.scalefactor;
	label = ' Reset Card Family Data';
	wwevent.innerheight = WW_parentheight;
	wwevent.innerwidth = WW_parentwidth;
	WWTango_dispatch(wwevent,label,flag);
	return;

}	// End WW_sendcardfamilydata(flag)

function WW_getcardfamilydata(receivedevent)	{

	if( !WWTango_acceptmasterstyle )
		return;
	var cardredo = 0;
	if(WW_isundefined(receivedevent.divfamily))
		return true;
	if(WW_isundefined(receivedevent.divback))
		return true;
	if(WW_isundefined(receivedevent.divscale))
		return true;
	var newcardfamily = receivedevent.divfamily;
	if( (newcardfamily >= 0 ) && (newcardfamily < WW_cardfamilyct))	{
		if( WW_cardfamily_num != newcardfamily )	{
			WW_cardfamily_num = newcardfamily;
			WW_cardback_used = 0;
			WW_cardsetup();
			cardredo =2;
		}
	}
	var newcardback = receivedevent.divback;
	if( (newcardback >= 0 ) && (newcardback < parseInt(WW_cardfamily_used.backct)))	{
		if( newcardback != WW_cardback_used )	{
			WW_cardback_used = newcardback;
			WW_cardsetup();
			cardredo =1;
		}
	}
	var curscale = WW_cardfamily_used.scalefactor;
	var diff = Math.abs(receivedevent.divscale-curscale);
	if( diff > 0.1*curscale)
		cardredo =3;
	WW_cardfamily_used.scalefactor = receivedevent.divscale;
	if( cardredo > 0 )
		WW_makenewcard(cardredo);
	return;

}	// End WW_getcardfamilydata(receivedevent)

//	divoption > 10 Send Card and Option
//	divoption = 11 WW_clickintrickwindow(curclicked)
//	divoption = 12 WW_accumulateclicks(cardindex)
function WW_sendgeneralcardoption(indextocard,divoption,flag)	{

	if(!WWTango_transmit )
		return;
	var seq = WWTango_doorkeeper.WW_newgamelabel(0);
	wwevent = new WW_generatedevent(WWTango_doorkeeper.WW_username,WWTango_doorkeeper.WW_gamestream,WWTango_doorkeeper.WW_gamegroup,seq,"card");
	wwevent.infotype =3;
	wwevent.divoption = divoption;
	wwevent.divindex = indextocard;
	wwevent.divowner = WW_playermoving;
	var label = ' Set Card Index+Option';
	WWTango_dispatch(wwevent,label,flag);
	return;

}	// End WW_sendgeneralcardoption(indextocard,divoption,flag)

function WW_getgeneralcardoption(receivedevent)	{

	var divoption = receivedevent.divoption;
	var cardindex = receivedevent.divindex;
	if( (cardindex < 0 ) || (cardindex >= WW_carddecksize) )	{	// Illegal Index
		WWTango_doorkeeper.WW_seterrorline(' Illegal Card index ' + cardindex);
		return false;
	}
	if( divoption == 11)	{
		if(receivedevent.divowner != WW_cardowner[cardindex])	{
			var pos = WW_cardrole1[cardindex];
			if( pos<WW_numcardsintricksstackdone )	{
				WW_printerror(' Inconsistent card owners ' + cardindex + ' sent ' + receivedevent.divowner + ' here ' + receivedevent.divowner);
				return;
			}
		}
		WW_cardrole2[cardindex] = 1-WW_cardrole2[cardindex];
		return;
	}
	if( divoption == 12)	{
		WW_accumulateclicks(cardindex);
		return;
	}

}	// End WW_getgeneralcardoption(receivedevent)

//	divtype = 0 Hollerith type for divvalue
//	divtype = 1 Integer
//	divtype = 2 Floating
//	divtype = 3 Logical
//  Other divtypes imply ignore divvalue
function WW_sendgeneralgameoption(divoption,divvalue,divtype,flag)	{

	var seq = WWTango_doorkeeper.WW_newgamelabel(0);
	wwevent = new WW_generatedevent(WWTango_doorkeeper.WW_username,WWTango_doorkeeper.WW_gamestream,WWTango_doorkeeper.WW_gamegroup,seq,"card");
	wwevent.infotype =3;
	wwevent.divoption = divoption + 1000;
	if( divtype==0 )
		wwevent.stringparametervalue = divvalue;
	if( divtype==1 )
		wwevent.integerparametervalue = divvalue;
	if( divtype==2 )
		wwevent.floatparametervalue = divvalue;
	if( divtype==3 )
		wwevent.logicalparametervalue = divvalue;
	var label = ' Set Game Option ' + divoption;
	WWTango_dispatch(wwevent,label,flag);
	return;

}	// End WW_sendgeneralgameoption(divoption,divvalue,divtype,flag)

function WW_getgamedata(receivedevent)	{

	var divoption = receivedevent.divoption;
	if( divoption == 999 )	{ // Start Game
		var container = receivedevent.arrayitself;
		var nplayer = receivedevent.arraysize;
		WW_dealername = receivedevent.username;
		if( WW_dealername == WWTango_doorkeeper.WW_username )	{
			WWTango_doorkeeper.WW_tangogamedealer = true;	}
		else	{
			WWTango_doorkeeper.WW_tangogamedealer = false; }
		WW_playernames.length = 0;
		for( var m=0; m<nplayer;m++)	{
			WW_playernames[m] = container[m].username;
			WWTango_doorkeeper.WW_playernames[m] = WW_playernames[m];
		}
		WWTango_doorkeeper.WW_dealername = WW_dealername;
		WW_beginmemorygame(nplayer);
		return;
	}
	divoption = divoption-1000;
	if( divoption==0 )
		WW_setmemorygameoptions(0);
	if( divoption==1 )
		WW_turntoback();
	if( divoption==2 )
		WW_turntofront();
	if( divoption==3 )
		WW_orderedstart(0);
	if( divoption==4 )
		WW_orderedstart(1);
	if( divoption==5 )
		WW_randomstart();
	if( divoption==6 )	{
		WW_setmemorygameoptions(receivedevent.integerparametervalue); }
	if( divoption==7 )	{
		WW_delaytime = receivedevent.integerparametervalue;
		WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);
	}
	if( divoption==8 )	{
		WW_dealername = receivedevent.stringparametervalue;
		WWTango_doorkeeper.WW_dealername = WW_dealername;
		if( WW_dealername == WWTango_doorkeeper.WW_username )	{
			WWTango_doorkeeper.WW_tangogamedealer = true;	}
		else	{
			WWTango_doorkeeper.WW_tangogamedealer = false; }
		WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);
	}
	if( divoption==9 )
		WW_orderedstart(2);
	if( divoption==11 )	{
		WW_tricklimit = receivedevent.integerparametervalue;
		WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);
	}
	return;

}	// End WW_getgamedata(receivedevent)

//	Start a Game with type given by gametype
// players is an array containing players in order
// length of this array is number of players
// dealer is Tango Name of dealer
function WW_startgame(players,dealer,gametype)	{

	var nplayer = players.length;
	WW_dealername = dealer;
	WW_playernames.length = 0;
	for( var m=0; m<nplayer;m++)	{
		WW_playernames[m] = players[m];
	}
	WWTango_doorkeeper.WW_newgamelabel(-1);
	WW_beginmemorygame(nplayer);
	var seq = WWTango_doorkeeper.WW_newgamelabel(0);
	wwevent = new WW_generatedevent(WWTango_doorkeeper.WW_username,WWTango_doorkeeper.WW_gamestream,WWTango_doorkeeper.WW_gamegroup,seq,"card")
	wwevent.infotype =3;
	wwevent.divoption = 999;
	wwevent.username = WW_dealername;
	wwevent.arraysize = nplayer;
	wwevent.arrayitself = new Array();
	for(var m=0; m<nplayer; m++)	{
		var child = new WW_childevent("card");
		child.username = players[m];
		wwevent.arrayitself[m] = child;
	}
	var label = ' Set Game Players and Start it ';
	WWTango_dispatch(wwevent,label,1);
	return true;
	
}	// End WW_startgame(players,dealer,gametype)

//	Terminate Game
function WW_endgame()	{

	WW_setmemorygameoptions(0);
	WW_sendgeneralgameoption(0,-1,0,1);
	return true;
	
}	// End WW_endgame()

//	Set A game option with type optiontype and optional value optionvalue
function WW_setgameoption(optiontype,optionvalue)	{

	if( optiontype== 1 )	{
		WW_turntoback();
		WW_sendgeneralgameoption(1,-1,0,1);
		return true;
	}
	if( optiontype== 2 )	{
		WW_turntofront();
		WW_sendgeneralgameoption(2,-1,0,1);
		return true;
	}
	if( optiontype== 3 )	{
		WW_orderedstart(0);
		WW_sendgeneralgameoption(3,-1,0,1);
		return true;
	}
	if( optiontype== 4 )	{
		WW_orderedstart(1);
		WW_sendgeneralgameoption(4,-1,0,1);
		return true;
	}
	if( optiontype== 5 )	{
		WW_randomstart();
		WW_sendgeneralgameoption(5,-1,0,1);
		return true;
	}
	if( optiontype== 6 )	{
		WW_setmemorygameoptions(optionvalue);
		WW_sendgeneralgameoption(6,optionvalue,1,1);
		return true;
	}
	if( optiontype == 7 )	{
		WW_delaytime = optionvalue;
		if(WW_delaytime < 250)
			WW_delaytime = 250;
		if(WW_delaytime > 10000)
			WW_delaytime = 10000;
		WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);
		WW_sendgeneralgameoption(7,WW_delaytime,1,1);
		return true;
	}
	if( optiontype == 8 )	{
		WW_dealername = optionvalue;
		WW_sendgeneralgameoption(7,WW_delaytime,2,1);
		return true;
	}
	if( optiontype== 9 )	{
		WW_orderedstart(2);
		WW_sendgeneralgameoption(9,-1,0,1);
		return true;
	}
	if( optiontype== 10 )	{	// Local Action -- No Tango Message
		WW_launchtrickswindow();
		return true;
	}
	if( optiontype == 11 )	{
		WW_tricklimit = optionvalue;
		if(WW_tricklimit < 1)
			WW_tricklimit = 1;
		if(WW_tricklimit > WW_carddecksize/2)
			WW_tricklimit = WW_carddecksize/2;
		WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);
		WW_sendgeneralgameoption(11,WW_tricklimit,1,1);
		return true;
	}

}	// End WW_setgameoption(optiontype,optionvalue)

function WW_getgamestatus()	{
	
	var conc = {};
	conc.gameinprogress = WW_gameinprogress;
	conc.pointersetupoption = WW_pointersetupoption;
	conc.matchoption = WW_matchoption;
	conc.gameplayers = WW_numgameplayers;
	conc.frozencards = WW_frozencards;
	conc.playernames = WW_playernames;
	conc.dealername = WW_dealername;
	conc.playermoving = WW_playermoving;
	conc.allowedtomove = WW_allowedtomove;
	conc.allowedtoclick = WW_allowedtoclick;
	conc.delaytime = WW_delaytime;
	conc.tricklimit = WW_tricklimit;
	return conc;

}	// End	WW_getgamestatus()

// **********************************************************************************************
// ***** Non Tango Part of Card section **********************************************************


// Define card packs *************************************************

function WW_cardfamily(urlstem,urlsuffix,familyname,height,width,scale,joker0,joker1,joker2,joker3)	{
	this.urlstem = urlstem;
	this.urlsuffix = urlsuffix;
	this.familyname = familyname;
	this.height = height;
	this.width = width;
	this.scalefactor= scale;
	this.jokers = new Array()
	this.jokers[0] = joker0;
	this.jokers[1] = joker1;
	this.jokers[2] = joker2;
	this.jokers[3] = joker3;
	this.backct = WW_cardfamily.arguments.length;
	this.backs = new Array();
	for(var m=10 ; m < this.backct; m++)	{
		this.backs[m-10] = WW_cardfamily.arguments[m]; }
	this.backct = this.backct -10;

}	// End WW_cardfamily defining family of cards with 56 cards and at least one back

function WW_cardsetup()	{
	WW_cardfamily_used = WW_cardfamilyarray[WW_cardfamily_num];
	WW_currentcardback = WW_cardfamily_used.backs[WW_cardback_used];
	WW_currentcardbackurl = WW_cardfamily_used.urlstem + WW_currentcardback.toString() + WW_cardfamily_used.urlsuffix;
	for( var i=0; i<4; i++)	{
		for( var m=0; m<13; m++)	{
			var lab = WW_cardlabels[m] + WW_cardsuits[i];
			WW_listofcards[m+13*i] = "WWcard" + lab;
			WW_listofcardurls[m +13*i] = WW_cardfamily_used.urlstem + lab + WW_cardfamily_used.urlsuffix;
		}
	}
	for( var i=0; i<4; i++) {
		var lab = WW_cardfamily_used.jokers[i];
		var lab1 = i+1;
		WW_listofcards[52+ i] = "WWcardjoker" + lab1.toString();
		WW_listofcardurls[52+i] = WW_cardfamily_used.urlstem + lab + WW_cardfamily_used.urlsuffix;
	}
	for( var i=0; i < WW_carddecksize; i++)	{
		if( WW_Netscape4)
			WW_cardlayers[i] = eval("document." + WW_listofcards[i]);
		else	{
			WW_cardlayers[i] = eval("document.all." + WW_listofcards[i]); 
			WW_cardlayers[i].style.width = WW_cardfamily_used.width*WW_cardfamily_used.scalefactor;
			}
	}
	return;

}	// End WW_cardsetup() Setting up Current Card Set

function setassoc()	{

	for( var i=0; i<56; i++)        {
		eval("this." + WW_listofcards[i] + "=" + i);
	}

}	// End setassoc()

// Set Card Families Available
WW_oxymoroncards = new WW_cardfamily("http://trurl.webwisdom.com/tango2-rel/tango-2.0/applets/sbd/WWgamedata/cardsoxymoron/",".gif","Oxymoron GNU License",97,73,0.75,"j","j","j","j","backs/b","backs/ww");
WW_pamelacards = new WW_cardfamily("http://trurl.webwisdom.com/tango2-rel/tango-2.0/applets/sbd/WWgamedata/cardspamela/",".gif","Pamela Fox Folk Art",174,137,0.4,"jokerb","jokerb","jokerr","jokerr","backs/cardbb","backs/cardbg","backs/cardbs");

WW_cardfamilyarray = new Array();
WW_cardfamilyarray[0] = WW_oxymoroncards;
WW_cardfamilyarray[1] = WW_pamelacards;
// End Set Current Card Families

WW_cardlabels = new Array("a","2","3","4","5","6","7","8","9","t","j","q","k");
WW_cardsuits = new Array("c","d","h","s");
var WW_cardfamilyct = WW_cardfamilyarray.length;
var WW_cardfamily_num = 0;
var WW_cardback_used = 0;
var WW_cardfamily_used = null;
var WW_currentcardback = null;
var WW_currentcardbackurl = null;
var WW_carddecksize = 56;
WW_listofcards = new Array();
WW_cardlayers = new Array();
WW_cardstatus = new Array(); // 0 on board to the back; 1 on board seen
WW_cardowner = new Array(); // Owner of Card (0 on card table)
WW_cardrole1 = new Array(); // First Game Dependent Card Role
WW_cardrole2 = new Array(); // Second Game Dependent Card Role
WW_listofcardurls = new Array();
var WW_associativecards = null;

//************** Game Specific Variables
var WW_ignoretangocardposition = false;
var WW_tricklimit = WW_carddecksize/2;	// Game Limit on tricks taken
var WW_counttricks = 0; // Count total tricks upto WW_counttricks
var WW_matchoption =1;	// Control Matching of cards (2-way or 4-way)
var WW_numgameplayers =0; // Number of Players
var WW_delaytime = 3000;  // delay time in milliseconds for tricks to be displayed
var WW_playernames = new Array();
var WW_dealername = '';
var WW_ourname = ''
var WW_frozencards = false;
var WW_playermoving = 0;
var WW_allowedtoclick = true;
var WW_allowedtomove = true;
var WW_countclicks =0;
var WW_storeclicks = new Array();
var WW_cardtablewindow = null;
var WW_trickswindow = null;
var WW_thisistable = true;
var WW_thisistricks = false;
var WW_thisdocumentURLpath = null;
var WW_tricksloaded = false;
var WW_cardindex0saved =0;
var WW_cardindex1saved =0;
var WW_successmessage = null;
var WW_failuremessage = null;
var WW_tricksIntervalID = 0;
var WW_stackfortrickswindow1 = new Array();
var WW_stackfortrickswindow2 = new Array();
var WW_numcardsintricksstack = 0;
var WW_numcardsintricksstackdone =0;
var WW_countlaunchcycles = 0;
var WW_trickxpos = new Array();
var WW_trickseach = new Array();
var WW_trickypos = new Array();


//************** Special Card Utilities ******************************

function WW_cardpageisload()	{ // Initialize Cards after page is loaded

	WW_pagelabel = 'Card Game:Concentration page';// Overwites default (WW_pagelabel  defined in basic package)
	WW_pagetype = 11;	// Indicate Type of Page
	
	WW_pointersetupoption = 11;
	WW_messagetotalnumber = 5;
	WW_messagecount = 4;
	WW_messagecontent1master = '<b>To Play - Click on starting option (Ordered/Random)<br>and then select number of players<br>4way match ignores color of card while default requires exact match</b>';
	WW_messagecontent2master = 'Click outside pointer rectangle to move<br>Click on Pointer to Hide<br>Click on Pointer + ALT to toggle message hiding<br>Click on Pointer + CNTL to abolish pointer<br>Click on Pointer + Shift to cycle families<br>Click outside + Alt is Change Image<br>Click outside + Control is Double Size<br>Click outside + Shift is Halve Size';
	WW_messagecontent1nonmaster = WW_messagecontent1master;
	WW_messagecontent2nonmaster = WW_messagecontent2master;
	WW_messageobjectlist[2] = WW_getlayer('WWpointermessage3');
	WW_messageobjectlist[3] = WW_getlayer('WWpointermessage4');
	WW_messageobjectlist[4] = WW_getlayer('WWpointermessage5');
	if(!WW_Netscape4 )	{
		if( !WW_isundefined(WW_messageobjectlist[0]) )
			WW_messageobjectlist[0].style.width =300;
		if( !WW_isundefined(WW_messageobjectlist[1]) )
			WW_messageobjectlist[1].style.width =300;
		if( !WW_isundefined(WW_messageobjectlist[2]) )
			WW_messageobjectlist[2].style.width =300;
		if( !WW_isundefined(WW_messageobjectlist[3]) )
			WW_messageobjectlist[3].style.width =300;
		if( !WW_isundefined(WW_messageobjectlist[4]) )
			WW_messageobjectlist[4].style.width =300;
	}
	WW_hideanywayafterthisnumber = 32;
	var endofpathname = document.URL.lastIndexOf("/") + 1;
	WW_thisdocumentURLpath = document.URL.slice(0,endofpathname);

	WW_successmessage=WW_getlayer('WWsuccess');
	WW_failuremessage=WW_getlayer('WWfailure');
	if(!WW_Netscape4 )	{
		if( !WW_isundefined(WW_successmessage) )
			WW_successmessage.style.width =300;
		if( !WW_isundefined(WW_failuremessage) )
			WW_failuremessage.style.width =300;
	}
	WW_cardsetup();
	WW_associativecards = new setassoc();
	for(var m=0; m< WW_carddecksize; m++)	{
		WW_cardstatus[m] = 1;
		WW_cardowner[m] = 0;
		WW_cardrole1[m] = -1;
		WW_cardrole2[m] = 1;
	}

}	// End WW_cardpageisload()

function WW_setinitialcardposition()	{

	var cw = WW_cardfamily_used.width*WW_cardfamily_used.scalefactor;
	var ch = WW_cardfamily_used.height*WW_cardfamily_used.scalefactor;
	var xpos = 0.;
	var ypos =0.;
	var xct =0;
	var maxinrow = 14;
	ordertodo = new Array();
	ordertodo[13] = 52;
	ordertodo[27] = 53;
	ordertodo[41] = 54;
	ordertodo[55] = 55;
	for(var m=0; m<13;m++)	{
		ordertodo[m] = m;
		ordertodo[m+14] = m+13;
		ordertodo[m+28] = m+26;
		ordertodo[m+42] = m+39;
	}
	for( var m=0; m< WW_carddecksize;m++)   {
		var actualm = ordertodo[m];
		if( xct>=maxinrow )	{
			xct=0;
			xpos =0.;
			ypos += ch;
		}
		WW_layershiftto(WW_cardlayers[actualm],xpos,ypos);
		WW_layershow(WW_cardlayers[actualm]);
		xpos += cw;
		++xct;
	}

}	//	End WW_setinitialcardposition()

function WW_turntoback()	{

	for( var m=0; m< WW_carddecksize;m++)	{
		WW_cardowner[m] = 0;
		WW_cardrole1[m] = -1;
		WW_cardrole2[m] = 0;
		var stat = WW_cardstatus[m];
		WW_layershow(WW_cardlayers[m]);
		if( stat==0 )
			continue;
		WW_cardstatus[m] = 0;
		WW_changecard(WW_cardlayers[m],WW_currentcardbackurl,1);
	}
	return true;

}	// End WW_turntoback()

function WW_turntofront()	{

	for( var m=0; m< WW_carddecksize;m++)	{
		WW_cardowner[m] = 0;
		WW_cardrole1[m] = -1;
		WW_cardrole2[m] = 1;
		var stat = WW_cardstatus[m];
		WW_layershow(WW_cardlayers[m]);
		if( stat==1 )
			continue;
		WW_cardstatus[m] = 1;
		WW_changecard(WW_cardlayers[m],WW_listofcardurls[m],1);
	}
	return true;

}	// End WW_turntofront

function WW_orderedstart(mode)	{

	var dir = 0;
	var randomorder = true;
	if(mode==1)
		dir =1;
	if(mode==2)
		randomorder = false;
	WW_waitingfortimeout = true;
	WW_cleanupagame();
	WW_allowedtoclick = false;
	var winwidth = WW_getwindowwidth();
	
	var cw = WW_cardfamily_used.width*WW_cardfamily_used.scalefactor +3;
	var ch = WW_cardfamily_used.height*WW_cardfamily_used.scalefactor +3;
	var xpos = 0.;
	var ypos =0.;
	var xct =0;
	var maxifdiris0 = WW_carddecksize/4;
	ordertodo = new Array();
	if( randomorder)
		randomlist(ordertodo,WW_carddecksize);
	else	{
		ordertodo[13] = 52;
		ordertodo[27] = 53;
		ordertodo[41] = 54;
		ordertodo[55] = 55;
		for(var m=0; m<13;m++)	{
			ordertodo[m] = m;
			ordertodo[m+14] = m+13;
			ordertodo[m+28] = m+26;
			ordertodo[m+42] = m+39;
		}
	}
	for( var m=0; m< WW_carddecksize;m++)   {
		var actualm = ordertodo[m];
		WW_cardowner[actualm] = 0;
		WW_cardrole1[actualm] = -1;
		WW_cardrole2[actualm] = 0;
		var stat = WW_cardstatus[actualm];
		if( stat == 1 )	{
			WW_cardstatus[actualm]=0;
			WW_changecard(WW_cardlayers[actualm],WW_currentcardbackurl,1);
		}
		if( ((xpos > winwidth -cw) && (dir==1)) || ((xct>=maxifdiris0) && (dir==0)) )	{
			xct=0;
			xpos =0.;
			ypos += ch;
		}
		WW_layershiftto(WW_cardlayers[actualm],xpos,ypos);
		xpos += cw;
		++xct;
	}
	WW_ignoretangocardposition = true;
	WW_waitingfortimeout = false;
	return true;

}	// End WW_orderedstart

function WW_randomstart()	{

	WW_waitingfortimeout = true;
	WW_cleanupagame();
	WW_allowedtoclick = false;
	var winwidth = WW_getwindowwidth()-WW_cardfamily_used.width*WW_cardfamily_used.scalefactor;
	var winheight = WW_getwindowheight()-WW_cardfamily_used.height;
	ordertodo = new Array();
	randomlist(ordertodo,WW_carddecksize);
	for( var m=0; m< WW_carddecksize;m++)   {
		var actualm = ordertodo[m];
		WW_cardowner[actualm] = 0;
		WW_cardrole1[actualm] = -1;
		WW_cardrole2[actualm] = 0;
		var stat = WW_cardstatus[actualm];
		if( stat == 1 )	{
			WW_cardstatus[actualm]=0;
			WW_changecard(WW_cardlayers[actualm],WW_currentcardbackurl,1);
		}
		WW_layershiftto(WW_cardlayers[actualm],winwidth*Math.random(),winheight*Math.random());
	}
	WW_ignoretangocardposition = true;
	WW_waitingfortimeout = false;
	return true;

}	// End WW_randomstart()

function randomlist(arraylist,maxsize)	{

	if(maxsize <= 0 )
		return;
	for( var m=0; m<maxsize; m++)	{
		arraylist[m] = m; }
	var posleft = maxsize;
	for( var m=0; m<maxsize-1; m++)   {
		var rannum = Math.random();
		var nextchoice = Math.floor(posleft*rannum);
		var secret = arraylist[m];
		arraylist[m] = arraylist[m+nextchoice];
		arraylist[m+nextchoice] = secret;
		--posleft;
	}
	return;

}	// End randomlist(arraylist,maxsize)

//	Set of Functions to Control Game from Cardtable Window
function WW_cleanupagame()	{

	if( WW_isdefined(WW_tricksIntervalID))
		clearInterval(WW_tricksIntervalID);
	WW_gameinprogress = false;
	WW_numgameplayers = 0;
	WW_frozencards = false;
	WW_allowedtomove = true;
	WW_allowedtoclick = true;
	WW_ignoretangocardposition = false;
	WW_playermoving = 0;
	WW_turntofront();
	WW_tricksloaded = false;

	WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);	
	return true;

}	// End WW_cleanupagame()

function WW_setmemorygameoptions(gameflag)	{

	if( gameflag == 0 )	{ // End Game but Don't Cleanup
		if( WW_isdefined(WW_tricksIntervalID))
			clearInterval(WW_tricksIntervalID);
		WW_gameinprogress = false;
		WW_ignoretangocardposition = false;
		WW_playermoving = 0;
		WW_allowedtomove = true;
		WW_allowedtoclick = true;
		WW_frozencards = false;
		if(WW_isitawindow(WW_trickswindow))
			WW_trickswindow.close();
		WW_turntoback();
	}
	if( gameflag == 1 )
		WW_matchoption = 1;
	if( gameflag == 2 )
		WW_matchoption = 2;
	WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);
	return true;

}	// End WW_setmemorygameoptions(gameflag)

function WW_beginmemorygame(nplayers)	{

	for(var m=0;m<WW_carddecksize;m++)	{
		WW_layertogeneric(WW_cardlayers[m],75);
	}
	for( var m=0; m<WW_messagetotalnumber; m++)	{
		WW_layertogeneric(WW_messageobject[m],0);
		WW_layerhide(WW_messageobject[m]);
	}
	WW_layertogeneric(WW_successmessage,0);
	WW_layertogeneric(WW_failuremessage,0);
	WW_layerhide(WW_successmessage);
	WW_layerhide(WW_failuremessage);
	WW_gameinprogress = true;
	WW_waitingfortimeout = true;
	WW_ourname = WWTango_doorkeeper.WW_username;
	WW_turntoback();
	WW_numgameplayers = nplayers;
	for(var m=0; m < WW_numgameplayers; m++)	{
		WW_trickseach[m] = 0; }
	WW_frozencards = true;
	WW_allowedtomove = false;
	WW_countclicks =0;
	WW_counttricks = 0;
	WW_cardindex0saved = -1;
	WW_cardindex1saved = -1;
	WW_playermoving = 1;
	WW_allowedtoclick = true;
	if( WW_ourname == WW_numgameplayers[WW_playermoving-1] )
		WW_allowedtoclick = false;
	WW_numcardsintricksstack = 0;
	WW_launchtrickswindow();
	if( WW_isdefined(WW_tricksIntervalID))
		clearInterval(WW_tricksIntervalID);
	WW_tricksIntervalID = setInterval("WW_processtricksqueue()",500);	
	return true;

}	// End WW_beginmemorygame(nplayers)

function WW_launchtrickswindow()	{

	if(WW_isitawindow(WW_trickswindow))
		WW_trickswindow.close()
	WW_tricksloaded = false;
	for( var m=0; m< WW_carddecksize;m++)	{
		WW_cardowner[m] = 0;
	}
	WW_countlaunchcycles =0;
	WW_numcardsintricksstackdone = 0;
	var totalwidth = WW_numgameplayers*(WW_cardfamily_used.width*WW_cardfamily_used.scalefactor +50)
	var totalheight = 90. + 2*WW_cardfamily_used.height;
	if(totalwidth < 100)
		totalwidth =100;
	if( totalheight < 100 )
		totalheight = 100;
        var extrarandomname = parseInt(10000.*Math.random());
	WW_trickswindow = window.open(WW_thisdocumentURLpath + "tricks.html",'TrickWindow' + extrarandomname.toString(),'toolbar=no,location=no,menubar=no,resizable=no,directories=no,status=yes,width=' + totalwidth + ',height=' + totalheight);
	WW_waitingfortimeout = false;
	WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);
	return true;

}	// End WW_launchtrickswindow()

//	Keep Tricks Window Upto Date -- Restart if necessary
//  This runs in Cardtable window and updates variables in both cardtable and tricks windows
//	In Cardtable Cardrole1 is -1 initially and is reset to position in card stack when stack updated in WW_processmove
 
function WW_processtricksqueue()	{

	var isitbad = true;
	if(WW_isitawindow(WW_trickswindow))	{
		if( WW_isdefined(WW_trickswindow.WW_isloaded) )	{
			if( WW_trickswindow.WW_isloaded == 1 )	{
				if( WW_tricksloaded )
					isitbad = false;
			}
		}
	}
	if(isitbad)	{
		++WW_countlaunchcycles;
		if(WW_countlaunchcycles > 50)
			WW_launchtrickswindow();
		return;
	}
	localnum = new Array();
	localcut = new Array();
	for(var m=0; m<WW_numgameplayers; m++)	{
		localnum[m] = 0;
		localcut[m] = 0;
	}
	var problem = -1;
	for( var runq = 0; runq<WW_numcardsintricksstackdone; runq++)	{
		var cardindex = WW_stackfortrickswindow1[runq];
		if( cardindex < 0 )
			continue;
		var owner = WW_stackfortrickswindow2[runq];
		if( owner != WW_cardowner[cardindex])	{
			problem = cardindex;
			WW_cardowner[cardindex] = owner;	}
		++localnum[owner-1];
		if( WW_cardrole2[cardindex] == 1 )
			++localcut[owner-1];
		if( WW_cardrole2[cardindex] != WW_trickswindow.WW_cardrole2[cardindex] )
			WW_trickswindow.WW_possiblecardflip(cardindex,owner,WW_cardrole2[cardindex],localnum[owner-1])
	}
	if( problem >= 0 )	{
		WW_printerror('Error in Queue for ' + problem); }

// Do Next Trick
	while( WW_numcardsintricksstackdone  < WW_numcardsintricksstack )	{
		var notpaired = false;
		if( (WW_numcardsintricksstackdone%2) == 0 )	{
			notpaired=true; }
		var cardindex = WW_stackfortrickswindow1[WW_numcardsintricksstackdone];
		var owner = WW_stackfortrickswindow2[WW_numcardsintricksstackdone];
		if(cardindex >= 0)	{
			WW_cardowner[cardindex] = owner
			if(localcut[owner-1] > 0 )
				WW_cardrole2[cardindex] = 1;
			var zval = 2*WW_trickseach[owner-1]+2;
			if(notpaired)
				--zval;
			WW_trickswindow.WW_sendtotrickwindow(cardindex,owner,WW_cardrole2[cardindex],zval);
		}
		++WW_numcardsintricksstackdone;


//	Cards occur in pairs -- Update Message every other card
//	Note "Player Moving" is Calculated independently in CardTable and Tricks windows
//	CardTable and Controlbar are synchronized
		if(notpaired)
			continue;
		if( cardindex >= 0 )	{
			++WW_trickseach[owner-1];
			++WW_trickswindow.WW_trickseach[owner-1];
			++WW_counttricks;	
			if( WW_counttricks >= WW_tricklimit )	{
				var mess = 'Game ended ';
				for(var m=0; m<WW_numgameplayers; m++)	{
					mess += (m+1).toString() +'(' + WW_playernames[m] + ') Got ' + WW_trickseach[m] + ' / ';
				}
				WWTango_doorkeeper.WW_setstatusline(mess);
			}
		}
		if(WW_isitawindow(WW_trickswindow))	{
			if( WW_isdefined(WW_trickswindow.WW_isloaded) )	{
				if( WW_trickswindow.WW_isloaded == 1 )	{
					if( WW_tricksloaded )	{
						var newowner = owner+1;
						if( newowner > WW_numgameplayers)
							newowner = 1;
						WW_trickswindow.WW_playermessage(newowner,WW_playernames,WW_dealername,WW_ourname);
					}
				}
			}
		}
	}
	return;

}	// End WW_processtricksqueue()

//	Runs in Card Table Window and updates WW_playermoving in Cardtable
//	WW_playermoving is correctly reflected in Control Bar
//	WW_playermoving is maintained independently in Tricks window
function WW_accumulateclicks(cardindex)	{

	if(!WW_tricksloaded)
		return;
	if( WW_cardindex0saved >= 0 )
		return;
	if( WW_cardindex1saved >= 0 )
		return;
	if( (WW_countclicks == 1) && (cardindex == WW_storeclicks[0]))	{
		WW_cardstatus[cardindex] = 0;
		WW_changecard(WW_cardlayers[cardindex],WW_listofcardurls[cardindex],1);
		return; }
	WW_storeclicks[WW_countclicks] = cardindex;
	++WW_countclicks;
	if( WW_countclicks < 2 )
		return;
	WW_processmove();
	WW_countclicks = 0;
	++WW_playermoving;
	if( WW_playermoving > WW_numgameplayers)
		WW_playermoving = 1;
	WWTango_doorkeeper.WW_gameupdated(WW_gameinprogress,WW_pointersetupoption,WW_playermoving);
	return;

}	// End  WW_accumulateclicks(cardindex) 

function WW_processmove()	{ // Return true if NO match

	WW_cardindex0saved = WW_storeclicks[0];
	WW_cardindex1saved = WW_storeclicks[1];
	if(WW_dotheymatch(WW_cardindex0saved ,WW_cardindex1saved ))	{
		WW_messageobject = WW_successmessage;
		WW_displaymessage();
		for(var m=0; m < 2; m++)	{
			var cardindex = WW_storeclicks[m];
			WW_stackfortrickswindow1[WW_numcardsintricksstack] = cardindex;
			WW_stackfortrickswindow2[WW_numcardsintricksstack] = WW_playermoving;
			++WW_numcardsintricksstack;
		}
		setTimeout("WW_removemessage()",WW_delaytime);
		WW_allowedtoclick = false;
		WW_waitingfortimeout = true;
		return false;
	}
	WW_messageobject = WW_failuremessage;
	WW_displaymessage();
	WW_allowedtoclick = false;
	WW_waitingfortimeout = true;
	WW_stackfortrickswindow1[WW_numcardsintricksstack] = -1;
	WW_stackfortrickswindow2[WW_numcardsintricksstack] = WW_playermoving;
	++WW_numcardsintricksstack;
	WW_stackfortrickswindow1[WW_numcardsintricksstack] = -1;
	WW_stackfortrickswindow2[WW_numcardsintricksstack] = WW_playermoving;
	++WW_numcardsintricksstack;
	setTimeout("WW_finishprocessmove()",WW_delaytime);
	return true;

}	// End WW_processmove()

function WW_finishprocessmove()	{

	WW_cardstatus[WW_cardindex0saved] =0;
	WW_cardstatus[WW_cardindex1saved] =0;
	WW_changecard(WW_cardlayers[WW_cardindex0saved],WW_currentcardbackurl,1);
	WW_cardindex0saved = -1;
	WW_changecard(WW_cardlayers[WW_cardindex1saved],WW_currentcardbackurl,1);
	WW_cardindex1saved = -1;
	WW_layerhide(WW_failuremessage);
	WW_nextmove();
	return true;

}	// End WW_finishprocessmove()

function WW_removemessage()	{

	WW_layerhide(WW_cardlayers[WW_cardindex0saved]);
	WW_layerhide(WW_cardlayers[WW_cardindex1saved]);
	WW_layerhide(WW_successmessage);
	WW_cardindex0saved = -1;
	WW_cardindex1saved = -1;
	WW_nextmove();
	return true;

}	// End WW_removemessage()

function WW_nextmove()	{

	if( WW_playernames.length > 0 )	{
		if(WW_playernames[WW_playermoving-1] == WW_ourname)	{
			WW_allowedtoclick= true; }
	}
	else	{
		WW_allowedtoclick= true; }
	WW_waitingfortimeout = false;
	return true;

}	// End WW_nextmove()

function WW_dotheymatch(cardindex0,cardindex1)	{

	if( cardindex0 > 51 )	{ // Jokers
		if( cardindex1 > 51 )
			return true;
		return false;
	}
	var diff = Math.abs(cardindex0-cardindex1);
	if( WW_matchoption == 1 )	{ // Exact Match
		var firstcard = Math.min(cardindex0,cardindex1);
		if( (firstcard<13) && (diff == 39) )
			return true;
		if( ((firstcard>=13)&&(firstcard<26)) && (diff == 13 ) )
			return true;
		return false;
	}
	if( (diff == 13 ) || (diff == 39) || (diff == 26) )
		return true;
	return false;

}	// End WW_dotheymatch(cardindex0,cardindex1)

// Executed inside Tricks window and called from Queue Processor
function WW_sendtotrickwindow(cardindex,playermoving,role2,zval)	{

	WW_cardowner[cardindex] = playermoving;
	WW_possiblecardflip(cardindex,playermoving,role2,zval);
	return;

}	// End WW_sendtotrickwindow(cardindex,playermoving,role2,zval)

function WW_possiblecardflip(cardindex,playermoving,role2,zval)	{

	WW_cardstatus[cardindex] = role2;
	WW_cardrole2[cardindex] = role2;
	originalz = 50+zval;
	var curclicked = WW_cardlayers[cardindex];
	if( role2 == 0 )	{
		WW_layershiftto(curclicked,WW_trickxpos[playermoving-1]+zval,WW_trickypos[0]);
		WW_changecard(curclicked,WW_currentcardbackurl,1);
		WW_layertogeneric(curclicked,originalz);
		WW_layershow(curclicked);
		return true;
	}
	else	{
		WW_changecard(curclicked,WW_listofcardurls[cardindex],1);
		WW_layertogeneric(curclicked,500-originalz);
		WW_layershiftto(curclicked,WW_trickxpos[playermoving-1]+zval,WW_trickypos[1]);
		WW_layershow(curclicked);
	}
	return true;

}	// End WW_possiblecardflip(cardindex,playermoving,role2,zval)

// Executed inside Tricks window
function WW_playermessage(playermoving,listofplayers,dealername,ourname)	{

	WW_playermoving = playermoving;
	if( WW_playermoving <= 0 )
		return true;
	var itisended = false;
	if( WW_cardtablewindow.WW_counttricks >= WW_cardtablewindow.WW_tricklimit )
		itisended = true;
	var togoflag = false;
	if( (listofplayers[WW_playermoving-1] == ourname)&&(!itisended) )
		togoflag = true;
	var totalwidth = WW_cardfamily_used.scalefactor*WW_cardfamily_used.width+40.;
	for( var m =0; m < WW_numgameplayers; m++)	{
		var displayedm = m+1;
		var textobject = WW_getlayer('WWyourmove' + displayedm.toString());
		if( listofplayers[m] == dealername )	{
			WW_setbackgroundcolor(textobject,'goldenrod'); }
		else	{
			WW_setbackgroundcolor(textobject,'mistyrose'); }
		var texttodisplay = '<b>Matches ' + WW_trickseach[m] + '<br>' + listofplayers[m] + '</b>';
		if( itisended && (m==0) )
			texttodisplay += '<br><b>Game ended!</b>';
		if(WW_Netscape4)	{
			textobject.document.open();
			textobject.document.writeln('<div>' + texttodisplay.toString() + '</div>');
			textobject.document.close();
			textobject.clip.width = totalwidth;
		}
		else	{
			textobject.style.width = totalwidth;
			textobject.innerHTML = texttodisplay.toString();
		}
		WW_layershow(textobject);
		WW_layershiftto(textobject, WW_trickxpos[m], 5.);
	}
	if(itisended)
		return;
	var textobject = WW_getlayer('WWyourmove' + WW_playermoving.toString());
	var order = 'Wait for Move!';
	if(togoflag)
		order = 'Your Move!';
	var texttodisplay = '<b>Matches ' + WW_trickseach[WW_playermoving-1] + '<br>' + listofplayers[WW_playermoving-1] + '<br>Player ' + WW_playermoving +'<br>' + order + '</b>';
	if(WW_Netscape4)	{
	        textobject.document.open();
	        textobject.document.writeln('<div>' + texttodisplay.toString() + '</div>');
	        textobject.document.close();
		textobject.clip.width = totalwidth;
	}
	else	{
		textobject.style.width = totalwidth;
		textobject.innerHTML = texttodisplay.toString();
	}

	if( togoflag )	{
		WW_setbackgroundcolor(textobject,'lightgreen'); }
	else	{
		WW_setbackgroundcolor(textobject,'mistyrose'); }
	WW_layershiftto(textobject, WW_trickxpos[WW_playermoving-1], 5.);
	return true;

}	// End WW_playermessage()

//	Call from onload handler in Tricks window ONLY
function WW_settrickplaces()	{

	var x=0;
	for( var m=0; m <WW_numgameplayers; m++)	{
		WW_trickxpos[m] =x;
		x += WW_cardfamily_used.scalefactor*WW_cardfamily_used.width +50.;
	}
	WW_trickypos[0] =80;
	WW_trickypos[1] = WW_cardfamily_used.scalefactor*WW_cardfamily_used.height + 85;
	return;

}	// End WW_settrickplaces()

// Basic Card Manipulation routines ************************************************************
function WW_reversecard(cardindex,cardobject)	{ // reverse card

	if( WW_cardowner[cardindex] !=  0 )
		return;
	var stat = WW_cardstatus[cardindex];
	if( stat == 1 )	{
		WW_changecard(cardobject,WW_currentcardbackurl,1); }
	else	{
		WW_changecard(cardobject,WW_listofcardurls[cardindex],1); }
	WW_cardstatus[cardindex] = 1-stat;
	return;


}	// End WW_reversecard(cardindex)


function WW_changecard(cardtochange,newimageurl,option)	{	// Change Card

	if(option > 0 )	{
		var totalwidth = WW_cardfamily_used.scalefactor*WW_cardfamily_used.width;
		if(WW_Netscape4)	{
			if(option > 1)	{
			        cardtochange.document.open();
			        cardtochange.document.writeln('<img src="' + newimageurl + '" width="' + totalwidth.toString() + '" ></img>');
			        cardtochange.document.close();
			}
			else	{
				cardtochange.document.images[0].src = newimageurl; }
		}
		else	{
			cardtochange.innerHTML = '<img src="' + newimageurl + '" width="' + totalwidth.toString() + '" ></img>';
			cardtochange.style.width = totalwidth;
		}
	}
	else	{
		WW_layershow(cardtochange);
	}
	WW_layertogeneric(cardtochange,75);

}	// End WW_changecard(cardtochange,newimageurl,option)

function WW_makenewcard(cardredo)	{ // Change all cards (cardredo =1 just backs )

	for( var m=0; m< WW_carddecksize;m++)	{
		var stat = WW_cardstatus[m];
		if( (cardredo==1) && (stat==1) )
			continue;
		var imagetouse = WW_currentcardbackurl;
		if( stat == 1 )
			imagetouse = WW_listofcardurls[m];
		WW_changecard(WW_cardlayers[m],imagetouse,cardredo);
	}
	return;

}	// End WW_makenewcard(cardredo)

// Interfaces to General DHTML/Pointer Package ********************************************

var WWTango_transmit = true;

// Return True of layer of this name can be dragged
function WW_cancardbedragged(nameofobject)	{

	if( (nameofobject.indexOf('card') > 0) && WW_allowedtomove )
		return true;
	return false;	

}	// End WW_cancardbedragged(nameofobject)

//	Process Card related Key Down Options
//	Return True if no more processing allowed
//	Return False if further Pointer work appropriate
function WW_processcardkeydown(localflag)	{

	if( WW_frozencards )
		return true;
	var cardwidth = WW_cardfamily_used.scalefactor;
	var cardredo = 0;
	if( localflag == 'p' || localflag == 'P' )	{ // Cycle through Card Families
		WW_cardfamily_num++;
		if( WW_cardfamily_num >= WW_cardfamilyct )
			WW_cardfamily_num = 0;
		WW_cardback_used = 0;
		WW_cardsetup();
		cardredo =2;
	}
	if( localflag == 'b' || localflag == 'B' )	{ // Cycle through backs within a card family
		++WW_cardback_used;
		if(parseInt(WW_cardback_used) >= parseInt(WW_cardfamily_used.backct) )
			WW_cardback_used = 0;
		WW_cardsetup();
		cardredo =1;
	}
	if( localflag == 'l' || localflag == 'L' )	{ // Increase Card Size
		cardwidth = cardwidth * 1.5;
		if( cardwidth > 7.5 )
			cardwidth=7.59375;
		cardredo =3;
		WW_cardfamily_used.scalefactor = cardwidth;
	}
	if( localflag == 's' || localflag == 'S' )	{ // Decrease Card Size
		cardwidth = cardwidth * 0.666667;
		if(cardwidth < .14)
			cardwidth =0.13169;
		cardredo =3;
		WW_cardfamily_used.scalefactor = cardwidth;
	}
	WW_sendcardfamilydata(1);
	if( cardredo > 0 )	{
		WW_makenewcard(cardredo);
		return true;
	}
	return false;

}	// end	WW_processcardkeydown(localflag)

//	End of a Drag -- Process WW_draggedlayer if a card
function WW_endofcarddrag(actuallayer)	{

	WW_processcardlayer(actuallayer);
	return true;

}	// End WW_endofcarddrag()

//	Package up Card for Tango
function WW_processcardlayer(cardlayer)	{

	var cardindex = WW_isitacard(cardlayer);
	if(cardindex == -1 )	{	// Not a Card
		return true; }
	var curz = WW_getlayerzindex(cardlayer);
	var curhide= 0;
	if( WW_layerishidden(cardlayer))
		curhide=1;
	WW_sendcardparm(cardindex,WW_getlayerleft(cardlayer),WW_getlayertop(cardlayer),curz,curhide,1);
	return true;

}	// End	WW_endofcarddrag()

// return -1 if not a card
// Return Index to card arrays ( 0 .... WW_carddecksize-1) if a Card
function WW_isitacard(curclicked)	{

	if(WW_isundefined(curclicked))
		return -1;
	var test = curclicked.id;
	if(WW_isundefined(test))
		return -1;
	var index = WW_associativecards[test.toString()];
	if(WW_isundefined(index))
		return -1;
	if(index >= 0 && (index<WW_carddecksize) )
		return index;

}	// End WW_isitacard(curclicked)

//	Process Click on a Card -- Return true if was a card; false otherwise
function WW_processclickoncard(curclicked,mouseoption)	{

	var cardindex = WW_isitacard(curclicked);
	if( cardindex == -1 )	{ // Not a Card Clicked ***************
		return false; }

//	Card is Clicked ****************
	if( (WW_allowedtoclick) && (mouseoption ==0) )	{ // No mouse modifier -- reverse
		if( WW_thisistricks)	{	// in Tricks window
			var owner = WW_cardowner[cardindex];
			if(owner != WW_playermoving)
				return true;
			WW_clickintrickwindow(curclicked);
			WW_cardtablewindow.WW_sendgeneralcardoption(cardindex,11,1);
			return true;
		}
		WW_reversecard(cardindex,curclicked);
		window.status ='Card ' + cardindex + ' status' + WW_cardstatus[cardindex];
		WW_processcardlayer(curclicked);
		if( WW_frozencards )	{
			WW_sendgeneralcardoption(cardindex,12,1);
			WW_accumulateclicks(cardindex); }
		return true;
	}
	if( WW_frozencards )
		return true;
	var cardwidth = WW_cardfamily_used.scalefactor;
	var cardredo =0;
	if( mouseoption == 1)   { // Click Card ALT modifier: Cycle through Backs and then through Families
		++WW_cardback_used;
		cardredo =1;
		if(parseInt(WW_cardback_used) >= parseInt(WW_cardfamily_used.backct) ) {
			WW_cardback_used = 0;
		WW_cardfamily_num++;
		if( WW_cardfamily_num >= WW_cardfamilyct )
			WW_cardfamily_num = 0;
		cardredo =2;
		}
		WW_cardsetup();
	}
	if( mouseoption == 2)   { // Click Card CONTROL modifier: Increase Card Size
		cardwidth = cardwidth * 1.5;
		if( cardwidth > 7.5 )
			cardwidth=7.59375;
		cardredo =3;
		WW_cardfamily_used.scalefactor = cardwidth;
		}
	if( mouseoption == 4 )	{ // Click Card SHIFT modifier: Decrease Card Size
		cardwidth = cardwidth * 0.666667;
		if(cardwidth < .14)
			cardwidth =0.13169;
		cardredo =3;
		WW_cardfamily_used.scalefactor = cardwidth;
	}
	WW_makenewcard(cardredo);
	WW_sendcardfamilydata(1);
	return true;

}	// End WW_processclickoncard(curclicked,mouseoption)

// Card Clicked in Trick Window
function WW_clickintrickwindow(curclicked)	{

	var cardindex = WW_isitacard(curclicked);
	var testy = WW_getlayertop(curclicked);
	var oldzindex = WW_getlayerzindex(curclicked);
	if( testy < 0.5*(WW_trickypos[0]+WW_trickypos[1]) ) {
		testy = WW_trickypos[1];
		WW_cardstatus[cardindex] =1;
		WW_cardrole2[cardindex] = 1;
		WW_cardtablewindow.WW_cardrole2[cardindex] = 1;
		WW_changecard(curclicked,WW_listofcardurls[cardindex],1);
	}
	else	{
		testy = WW_trickypos[0]; 
		WW_cardstatus[cardindex] =0;
		WW_cardrole2[cardindex] = 0;
		WW_cardtablewindow.WW_cardrole2[cardindex] = 0;
		WW_changecard(curclicked,WW_currentcardbackurl,1);
	}
	WW_layertogeneric(curclicked,500-oldzindex);
	WW_layershiftto(curclicked,WW_getlayerleft(curclicked),testy);
	return true;
	
}	// End WW_clickintrickwindow(curclicked)
	
