// ****************** Copyright Header ************************************
// WebWisdom JavaScript Shared Browser Version 3.0
// Copyright 1999 Syracuse University and WebWisdom.com
// Author: Geoffrey C. Fox
// Contact: support@webwisdom.com
//
// Reproduction of this software without this Copyright Header
// is prohibited and it constitutes a violation of
// the SU and WebWisdom.com Copyright (a federal felony).
//
// This software cannot be incorporated into any commercial
// product, or a product supporting commercial activity,
// without first obtaining a license from WebWisdom.com
// E-mail license@webwisdom.com to apply.
// *********** End of Copyright Header ************************************
//
// Page and Code to Produce History Lists and Archive Information

var bigboss= window.opener;
var WW_madebytango = true;
function WW_pageisloaded()	{
	var displaytimes = false;
	var displayevents = false;
	if( !bigboss.WW_incrementalarchive )	{
		bigboss.WW_lasteventarchived =0;
		bigboss.WW_lastmajoreventarchived =0; }
	var lasteventprinted = bigboss.WW_lasteventarchived;
	var timemessage = '';
	var localtimestart = bigboss.WW_beginningoftime;
	if( bigboss.WW_numallevents > 0 )	{
		if( bigboss.WW_includeeventlist )
			displayevents = true;
		displaytimes = true;
		var originaldate = new Date();
		originaldate.setTime(localtimestart);
		var ans =  bigboss.WW_settimelabel(0,localtimestart)
		var targetmess = ans.here;
		if( targetmess != '' )
			targetmess = ' Target First event Displaced by ' + targetmess + ' Seconds';
		timemessage = 'Reference Time ' + originaldate.toString() + '<br>' + targetmess + '<br>';
	}
	var newdoc = self.document;
	var currentdate = new Date();
	var firsteventm1 = bigboss.WW_lasteventarchived;
	var firstmajoreventm1 = bigboss.WW_lastmajoreventarchived;
	newdoc.writeln('<title>WW:History and Archive Listing</title>');
	newdoc.writeln('<script>bigboss= window.opener;WW_madebytango = true;</script>');
	newdoc.writeln('<style type="text/css" >');
	newdoc.writeln('#eventuse {position:absolute; color:black; visibility:hidden; z-index:75; left:20; top:20; }');
	newdoc.writeln('</style>');
	newdoc.writeln('<body background="../../help_background.gif" >');
	newdoc.writeln('<h1>Session History</h1>');
	newdoc.writeln('<b>' + currentdate.toString() + '</b><br>');
	if(!bigboss.WW_listpointerstuff)
		newdoc.writeln('<b>Pointer Events Deleted</b><br>');
	if(!bigboss.WW_listformstuff)
		newdoc.writeln('<b>Form Events Deleted</b><br>');
	newdoc.writeln('<b>Major Events(URL changes)  Logged in Header from ' + (firstmajoreventm1+1).toString() + ' to ' + bigboss.WW_numberurl + ' </b><br>');
	if(bigboss.WW_includeeventdata)
		newdoc.writeln('<b>Detailed Event Data Logged in Header from ' + (firsteventm1+1).toString() + ' to ' + bigboss.WW_numallevents + ' </b><br>');
	newdoc.writeln("We have created two new browser windows which are independent of <b>Shared Browser Page</b> except that they are reloaded every time you click History or CloneURL Button");
	newdoc.writeln("<br>This <b>History Parent</b> Window lists all URL's transmitted in this session<br>Events are also recorded and their data saved in header if options to do this chosen in Dialog window<br><b>Save History Page to Archive Your Session</b>");
	newdoc.writeln("<br>Dialog window also allows you to read back History Pages to find either Favorite URL's or Event Lists<br>Click on \"minor events\" on this page to get a set of options to display individual events or control replay");
	newdoc.writeln("<br>There is a special \"minor event\" colored pink which is the minor event that generated following major event");
	newdoc.writeln("<br>The other <b>CloneURL</b> window starts off holding current Browser Page but will be loaded with whatever URL you click (Major Events in pink in list) on in this History Parent Window<br>When you leave Tango Session, the CloneURL and History Parent Page are left untouched as a record of session<br>");
	if( bigboss.WW_numallevents <= 0 )	{
		newdoc.writeln('<b>There are currently No Pages Logged but as session progresses and you click History button, you will indeed see entries here!</b>');
		newdoc.close();
		return;
	}
	if(timemessage != '')
		newdoc.writeln('<b><br>' + timemessage + '</b>');

	newdoc.writeln('<table  BORDER = 10 CELLSPACING=5 CELLPADDING=1 bgcolor=white >');
	newdoc.writeln('<th ALIGN=CENTER><b>Source</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Here</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>There</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Major</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Minor</b></th>');
	newdoc.writeln('<th ALIGN=CENTER><b>Details <i>(Click on Major Event loads it into Clone page)</i></b></th>');
	newdoc.writeln('<tr><td><b>Name</b></td><td align=center colspan=2><b>Time</b></td><td align=center colspan =2><b>Events</b></td><td ALIGN=CENTER><b><i>Click on Minor Event gives Control Panel For Actions incl. Display</i></b></td></tr>');

	for( var m=firstmajoreventm1; m < bigboss.WW_numberurl; m++ )	{
		var timelabel = {};
		timelabel.here = '';
		timelabel.there = '';
		timelabel.sourcename = '';
		var lastevent = bigboss.WW_majorevent[m].associatedevent-1;
		if( lastevent >= 0 )	{
			if(displaytimes)
				timelabel = bigboss.WW_settimelabel(lastevent,localtimestart);
			if( displayevents )	{
				for(var mm=lasteventprinted; mm < lastevent;mm++)	{
					if( bigboss.WW_discardevent(mm))
						continue;
					var numlabel = (mm+1).toString();
					var localtimelabel = bigboss.WW_settimelabel(mm,localtimestart);
					var eventlabel = bigboss.WW_seteventprintline(mm);
					newdoc.writeln('<tr><td>' + localtimelabel.sourcename + '</td><td>' + localtimelabel.here + '</td><td>' +localtimelabel.there + '</td><td></td><td align=center>' + numlabel + '</td><td>' + eventlabel + '</td></tr>');
				}
				var eventlabel = bigboss.WW_seteventprintline(lastevent);
				lasteventprinted = lastevent+1;
				newdoc.writeln('<tr><td bgcolor = "pink" >' + timelabel.sourcename + '</td><td bgcolor = "pink" >' + timelabel.here + '</td><td bgcolor = "pink" >' + timelabel.there + '</td><td></td><td bgcolor = "pink" align=center>' + (lastevent+1).toString() + '</td><td>' + eventlabel + '</td></font></tr>');
			}
		}
		var uselabel = bigboss.WW_majorevent[m].label;
		numlabel = ')';
		if( m < 9 )
			numlabel = '&nbsp;)';
		numlabel = (m+1).toString() + numlabel;
		if( uselabel == '' )
			uselabel = 'URL ' + bigboss.WW_majorevent[m].url;
		var clickeventno = '<a href="javascript:void(0)" onclick="bigboss.WW_processmajoreventclick(event.pageX,event.pageY,' + m + ')" >' + (m+1).toString() + '</a>';
		newdoc.writeln('<tr><td bgcolor = "pink" >' + timelabel.sourcename + '</td><td bgcolor = "pink" >' + timelabel.here + '</td><td bgcolor = "pink" >' + timelabel.there + '</td><td align=center bgcolor = "pink" >' + clickeventno + '</td><td bgcolor = "pink" ></td><td><a target="HistoryTarget"  href="' + bigboss.WW_majorevent[m].url + '" >' + bigboss.WW_majorevent[m].label + '</a></td></tr>');
	}
	for(var mm=lasteventprinted; mm < bigboss.WW_numallevents;mm++)	{
		if( bigboss.WW_discardevent(mm))
			continue;
		var localtimelabel = bigboss.WW_settimelabel(mm,localtimestart);
		var eventlabel = bigboss.WW_seteventprintline(mm);
		newdoc.writeln('<tr><td>' + localtimelabel.sourcename + '</td><td>' + localtimelabel.here + '</td><td>' + localtimelabel.there + '</td><td></td><td align=center>' + (mm+1).toString() + '</td><td>' + eventlabel + '</td></tr>');
	}
	newdoc.writeln('</table>');

// Start Archiving Section ********
	newdoc.writeln('<form name="majorevents" >');
	newdoc.writeln('<input type=hidden name="firstmajoreventcount" value="' + (firstmajoreventm1+1).toString() + '" ><br>');
	newdoc.writeln('<input type=hidden name="totalmajoreventcount" value="' + bigboss.WW_numberurl.toString() +'" ><br>');
	for(var m=firstmajoreventm1; m<bigboss.WW_numberurl; m++)	{
		newdoc.writeln('<input type=hidden name="majorevent' + m + '" value="' + (m+1).toString() + '" ><br>');
		newdoc.writeln('<input type=hidden name="url' + m + '" value="' + escape(bigboss.WW_majorevent[m].url) + '" ><br>');
		newdoc.writeln('<input type=hidden name="label' + m + '" value="' + escape(bigboss.WW_majorevent[m].label) + '" ><br>');
		newdoc.writeln('<input type=hidden name="thumbnail' + m + '" value="' + bigboss.WW_packthumbnail(bigboss.WW_majorevent[m].thumbnail) + '" ><br>');
		newdoc.writeln('<input type=hidden name="minorevent' + m + '" value="' + bigboss.WW_majorevent[m].associatedevent + '" ><br>');
	}
	newdoc.writeln('</form>');
	
	newdoc.writeln('<form name="configurations" >');
	newdoc.writeln('<input type=hidden name="numconfigs" value="' + bigboss.WW_numconfigs.toString() + '" ><br>');
	for( var m = 2; m < bigboss.WW_numconfigs; m++ )	{
		var wwevent = bigboss.WW_eventconfig(m);
		var packedevent = bigboss.WW_packevent(wwevent,'','');
		newdoc.writeln('<input type=hidden name="WWJSSBConfig' + m + '" value="' + packedevent + '" ><br>');
		newdoc.writeln('<input type=hidden name="WWJSSBFav' + m + '" value="' + bigboss.WW_configarray[m].packedfav + '" ><br>');
		newdoc.writeln('<input type=hidden name="WWJSSBParmWW1' + m + '" value="' + bigboss.WW_configarray[m].packedww1 + '" ><br>');
		newdoc.writeln('<input type=hidden name="WWJSSBParmWW2' + m + '" value="' + bigboss.WW_configarray[m].packedww2 + '" ><br>');
		newdoc.writeln('<input type=hidden name="WWJSSBParmWW3' + m + '" value="' + bigboss.WW_configarray[m].packedww3 + '" ><br>');
	}
	newdoc.writeln('</form>');
	
	if( bigboss.WW_includeeventdata )	{
		newdoc.writeln('<form name="minorevents" >');
		newdoc.writeln('<input type=hidden name="firsteventcount" value="' + (firsteventm1+1).toString() + '" ><br>');
		newdoc.writeln('<input type=hidden name="totaleventcount" value="' + bigboss.WW_numallevents.toString() + '" ><br>');
		for(var m=firsteventm1; m<bigboss.WW_numallevents; m++)    {
			if( bigboss.WW_discardevent(m))
				continue;
			newdoc.writeln('<input type=hidden name="minorevent' + m + '" value="' + (m+1).toString() + '" ><br>');
			var mess = bigboss.WW_packevent(bigboss.WW_eventrecord[m],'','');
			newdoc.writeln('<input type=hidden name="eventarchivearray' + m + '" value="' + mess + '" ><br>');
		}
		newdoc.writeln('</form>');
	}
	newdoc.writeln('<div id="eventuse">Event Use</div>');
	newdoc.close();
	if( displayevents )
                bigboss.WW_lasteventarchived = bigboss.WW_numallevents;
	bigboss.WW_lastmajoreventarchived = bigboss.WW_numberurl;

}	// End WW_pageisloaded()
