// ****************** Copyright Header ************************************
// WebWisdom JavaScript Shared Browser Version 3.0
// Copyright 1999 Syracuse University and WebWisdom.com
// Author: Geoffrey C. Fox
// Contact: support@webwisdom.com
//
// Reproduction of this software without this Copyright Header
// is prohibited and it constitutes a violation of
// the SU and WebWisdom.com Copyright (a federal felony).
//
// This software cannot be incorporated into any commercial
// product, or a product supporting commercial activity,
// without first obtaining a license from WebWisdom.com
// E-mail license@webwisdom.com to apply.
// *********** End of Copyright Header ************************************
//
// Begin Basic Library ****************************************************

WW_Netscape4 = true;
WW_Microsoft = false;
WW_oldbrowser = false;
WW_setbrowser();

function WW_setbrowser()	{ // Set Browser Flags

	if( navigator.appName != "Netscape" )	{
		WW_Netscape4 = false;
		WW_Microsoft = true;  }
	if( navigator.appVersion < 4 )	{
		WW_Netscape4 = false;
		WW_Microsoft = false;
		WW_oldbrowser = true; }

}	// End WW_setbrowser()

function WW_getlayer(idstring)	{ // Find layer with given label

	var contextwindow = self;
	if(WW_getlayer.arguments.length > 1 )
		contextwindow = WW_getlayer.arguments[1];
	if( WW_Netscape4 )      {
		return contextwindow.eval("document." + idstring);
	}
	else	{
		return contextwindow.eval("document.all." + idstring);
	}

}	// End WW_getlayer()

function WW_getlayertop(obj)	{
	
	if(WW_isundefined(obj))
		return 0;
	if(WW_Netscape4 )      {
		return obj.top; }
	else	{
		return obj.style.pixelTop; }

}	// End WW_getlayertop(obj)

function WW_getlayerleft(obj)	{
	
	if(WW_isundefined(obj))
		return 0;
	if(WW_Netscape4 )      {
		return obj.left; }
	else	{
		return obj.style.pixelLeft; }

}	// End WW_getlayerleft(obj)

function WW_getlayerheight(obj)	{

	if(WW_isundefined(obj))
		return 0;
	if(WW_Netscape4 )      {
		return obj.clip.height; }
	else	{
		return obj.clientHeight; }

}	// End WW_getlayerheight(obj) 

function WW_getlayerwidth(obj)	{

	if(WW_isundefined(obj))
		return 0;
	if(WW_Netscape4 )      {
		return obj.clip.width; }
	else	{
		return obj.clientWidth; }

}	// End WW_getlayerwidth(obj) 

function WW_setlayerwidth(obj,value)	{
	
	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.clip.width = value; }
	else	{
		obj.style.width = value; }

}	// End WW_setlayerwidth(obj,value) 

function WW_setlayerheight(obj,value)	{
	
	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.clip.height = value; }
	else	{
		obj.style.height = value; }

}	// End WW_setlayerheight(obj,value) 

function WW_getwindowwidth()	{

	var contextwindow = window;
	if( WW_getwindowwidth.arguments.length > 0 )
		contextwindow = WW_getwindowwidth.arguments[0];
	if(WW_Netscape4 )      {
		return contextwindow.innerWidth; }
	else	{
		return contextwindow.document.body.clientWidth; }

}	// End WW_getwindowwidth()

function WW_getwindowheight()	{

	var contextwindow = window;
	if( WW_getwindowheight.arguments.length > 0 )
		contextwindow = WW_getwindowheight.arguments[0];
	if(WW_Netscape4 )      {
		return contextwindow.innerHeight; }
	else	{
		return contextwindow.document.body.clientHeight; }

}	// End WW_getwindowheight()

function WW_getwindowxscroll()	{	// x displacement of window due to scrolling

	var contextwindow = window;
	if( WW_getwindowxscroll.arguments.length > 0 )
		contextwindow = WW_getwindowxscroll.arguments[0];
	if(WW_Netscape4 )      {
		return contextwindow.pageXOffset; }
	else	{
		return contextwindow.document.body.scrollLeft; }

}	// End WW_getwindowxscroll()

function WW_getwindowyscroll()	{	// y displacement of window due to scrolling

	var contextwindow = window;
	if( WW_getwindowyscroll.arguments.length > 0 )
		contextwindow = WW_getwindowyscroll.arguments[0];
	if(WW_Netscape4 )      {
		return contextwindow.pageYOffset; }
	else	{
		return contextwindow.document.body.scrollTop; }

}	// End WW_getwindowxscroll()

function WW_setbackgroundcolor(obj,actualcolor)	{
	
	if(WW_isundefined(obj))
		return;
	if( WW_Netscape4 )	{
		obj.bgColor = actualcolor; }
	else	{
		obj.style.backgroundColor = actualcolor; }
	return;

}	// End WW_setbackgroundcolor(obj,actualcolor) 

function WW_getlayerzindex(obj)	{
	
	if(WW_isundefined(obj))
		return 0;
	if(WW_Netscape4 )      {
		return obj.zIndex; }
	else	{
		return obj.style.zIndex; }

}	// End WW_getlayerzindex(obj)

function WW_layertotop(obj)	{

	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.zIndex = 1000; }
	else	{
		obj.style.zIndex = 1000; }

}	// End WW_layertotop(obj)

function WW_layertogeneric(obj,amount)	{

	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.zIndex = amount; }
	else	{
		obj.style.zIndex = amount; }

}	// End WW_layertogeneric(obj)

function WW_layertobottom(obj)	{

	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.zIndex = 0; }
	else	{
		obj.style.zIndex = 0; }

}	// End WW_layertobottom(obj)

function WW_layershow(obj)	{

	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.visibility = "visible"; }
	else	{
		obj.style.visibility = "visible"; }

}	// End WW_layershow(obj)

function WW_layerhide(obj)	{

	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.zIndex = 0; 
		obj.visibility = "hidden"; }
	else	{
		obj.style.zIndex = 0;
		obj.style.visibility = "hidden"; }
	return;

}	// End WW_layerhide(obj)

function WW_layerishidden(obj)	{
	
	if(WW_isundefined(obj))
		return true;
	if(WW_Netscape4)        {
		if( obj.visibility == 'hide' )
			return true;
	}
	else	{
		if( obj.style.visibility == 'hidden' )
			return true;
	}
	return false;

}	// End WW_layerishidden(obj)

//	 Shift to Absolute Page Position x,y for object (left,top)
function WW_layershiftto(obj,x,y)	{

	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.moveTo(x,y); }
	else	{
		obj.style.pixelLeft = x;
		obj.style.pixelTop = y;  }

}	// End WW_layershiftto(obj,x,y)

// Shift to Visible Page Position x,y for object (left,top)
function WW_scrolllayershiftto(obj,x,y)       {

        if(WW_isundefined(obj))
                return;
	var xscroll = WW_getwindowxscroll();
	var yscroll = WW_getwindowyscroll();
        if(WW_Netscape4 )      {
                obj.moveTo(x+xscroll,y+yscroll); }
        else    {
                obj.style.pixelLeft = x+xscroll;
                obj.style.pixelTop = y+yscroll;  }

}       // End WW_layershiftto(obj,x,y)
function WW_layershiftby(obj,deltax,deltay)	{

	if(WW_isundefined(obj))
		return;
	if(WW_Netscape4 )      {
		obj.moveBy(deltax,deltay); }
	else	{
		obj.style.pixelLeft += deltax;
		obj.style.pixelTop += deltay;  }

}	// End WW_layershiftby(obj,deltax,deltay)

function WW_eventx(e)	{ // return x value of event

	if(WW_Netscape4 )      {
		return e.pageX; }
	else	{
		var contextwindow = window;
		if( WW_eventx.arguments.length > 1 )
			contextwindow = WW_eventx.arguments[1];
		var xscroll = WW_getwindowxscroll();
		return (contextwindow.event.clientX+xscroll); }

}	// End WW_eventx(e)

function WW_eventy(e)	{ // return y value of event

	if(WW_Netscape4 )      {
		return e.pageY; }
	else	{
		var contextwindow = window;
		if( WW_eventy.arguments.length > 1 )
			contextwindow = WW_eventy.arguments[1];
		var yscroll = WW_getwindowyscroll();
		return (contextwindow.event.clientY+yscroll); }

}	// End WW_eventy(e)

//  set htmltext in layerobj with background color bgcolor and z-index as newzindex
//  bgcolor = '' to get no background
//  if showornot true, make visible
function WW_changelayer(layerobj,htmltext,bgcolor,newzindex,showornot)	{	// Change content in Layer

	if(WW_isundefined(layerobj))
		return false;
	WW_layerhide(layerobj);
	if(htmltext != "" )	{
		if(WW_Netscape4)	{
		        layerobj.document.open();
		        layerobj.document.writeln(htmltext);
		        layerobj.document.close();
		}
		else	{
			layerobj.innerHTML = htmltext;
		}
	}
	if( bgcolor != '' )
		WW_setbackgroundcolor(layerobj,bgcolor);
	WW_layertogeneric(layerobj,newzindex);
	if( showornot )
        	WW_layershow(layerobj);
	return true;	

}	// End WW_changelayer(layerobj,htmltext,bgcolor,left,top,width,newzindex)

//	Position Message of size (layerheight,layerwidth) optimally in windowobject
//  Drape around original message with (top,left,height,width) at (mastertop,masterleft,masterheight,masterwidth)
//  Return XY.top XY.left as proposed positioning of Message
function WW_positionrelative(originallayer,newlayer,windowobject)	{

	var XY = WW_positionmessage(WW_getlayerleft(originallayer),WW_getlayertop(originallayer),WW_getlayerwidth(originallayer),WW_getlayerheight(originallayer),WW_getlayerwidth(newlayer),WW_getlayerheight(newlayer),windowobject);
	return XY;

}	// End

function WW_positionmessage(masterleft,mastertop,masterwidth,masterheight,layerwidth,layerheight,windowobject)	{

	if(!WW_isitawindow(windowobject))
		return null;
	var XY = {};
	var localy = mastertop + masterheight;
	var localx = masterleft;
	var originx = WW_getwindowxscroll(windowobject);
	var originy = WW_getwindowyscroll(windowobject);
	var windowwidth = WW_getwindowwidth(windowobject)-20;
	var windowheight = WW_getwindowheight(windowobject)-20;
	if( localx + layerwidth > windowwidth+originx)
		localx = Math.max(originx,windowwidth + originx - layerwidth);
	if( localy < originy)	{
		localy = originy;
		localx = masterleft + masterwidth;
		if( localx + layerwidth > (windowwidth+originx))
			localx = Math.max(originx,masterleft - layerwidth);
	}
	if( localy + layerheight > (windowheight+originy))	{
		localy = mastertop - layerheight;
		if( localy < originy )	{
			localy = mastertop;
			if(localy + layerheight > (windowheight+originy))
				localy = Math.max(originy,windowheight+originy-layerheight);
			localx = masterleft + masterwidth;
			if( localx + layerwidth > (windowwidth+originx))
				localx = Math.max(originx,masterleft - layerwidth); 
		}
	}
	XY.top = localy;
	XY.left = localx;
	return XY;
	
}	// End WW_positionmessage(mastertop,masterleft,masterheight,masterwidth,layerheight,layerwidth,windowobject)
